// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('starter', ['ionic', 'ion-floating-menu', 'angular-md5'])
    .run(['$ionicPlatform', '$rootScope','$location', '$ionicHistory', '$ionicLoading', 'nativeHelper', 'localStorage', 'nav', 'control','$ionicViewSwitcher','$interval',
        function ($ionicPlatform, $rootScope,$location, $ionicHistory, $ionicLoading, nativeHelper, localStorage, nav, control,$ionicViewSwitcher,$interval) {

        window.currentUrl = 'https://zsfwpt.icinfo.cn';
        //    window.currentUrl = 'http://115.238.48.66:8085';
        // window.currentUrl = 'http://192.168.5.209:8089';
        //证书申领操作说明
        window.certApply='https://helpcenter.icinfo.cn/article?uid=365C4BBED58C452C9EDF4295AFDE2715';
        //证书补办操作说明
        window.certMakeUp='https://helpcenter.icinfo.cn/article?uid=B0067A15E37641CE8BEBB8A97B236AAF';
        //证书使用说明
        window.certUserHelp='https://helpcenter.icinfo.cn/article?uid=35F98FAFB5AB445CB79677CB4821ECF5';
        //法人授权操作说明
        window.authorizationHelp='https://helpcenter.icinfo.cn/article?uid=8BAE43C7084F419E9ABC3C7F17BBC3F3';

        
        var logoutAlertShow = false;
            $ionicPlatform.ready(function () {
                if (cordova.platformId === 'ios' && window.cordova && window.cordova.plugins.Keyboard) {
                    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
                    // for form inputs)
                    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);

                    //禁止header向上移动
                    cordova.plugins.Keyboard.disableScroll(true);
                }
                if (window.StatusBar) {
                    //StatusBar.styleDefault 状态栏默认样式，也就是电池信号黑色；
                    //StatusBar.styleLightContent 状态栏内容浅色，貌似就是白色，适合深色背景；
                    //StatusBar.styleBlackTranslucent 状态栏黑色半透明，电池时间都是白色的，适合深色背景；
                    //StatusBar.styleBlackOpaque 状态栏黑色不透明，还是白色的，适合深色背景；
                    //StatusBar.hide 状态栏隐藏；
                    //StatusBar.show(); //状态栏显示；
                    StatusBar.styleDefault();

                }

                $rootScope.isShowLetterGuide = true;//询证函提示
                $rootScope.cancelSecond = false;//隐私协议弹窗是否拒绝第二次

                //监听后台消息弹窗
                var showMsg = function (e) {
                    if ("error_017" == e.msgType) return;

                    $ionicLoading.hide();
                    control.showPopup(e.msg, 2000);
                }
                window.broadcaster.addEventListener("showMsg", showMsg);
                
                //监听页面跳转
                var navToPage = function (e) {
                    nav.navigate(e.pagePath);
                }
                window.broadcaster.addEventListener("navToPage", navToPage);

                //登出操作
                var logoutFunc = function () {
                    $rootScope.localCertList = [];
                    localStorage.deleteItem('loginInfo');
                    PushAgent.delAlias(function(){},$rootScope.loginInfo.userId,'userUniqueId')
                    $ionicHistory.clearHistory();
                    nav.navigate('signIn');
                    logoutAlertShow = false;
                }
                //监听登出
                var logout = function () {
                    if (!logoutAlertShow) {
                        //control.showAlert1("您的账号在其他设备登录，如果这不是您的操作，请即时修改您的登录密码",logoutFunc, null, null);
                        control.showAlert1("发生异常，自动退出当前登录状态",logoutFunc, null, null);
                    }
                }
                window.broadcaster.addEventListener("logout", logout);


                $rootScope.isShowGuide = true;//生物识别引导页是否显示

                $rootScope.appid = "";
                $rootScope.secret = "";
                $rootScope.urlConfig = {};
                // 获取native基础数据配置
                var getBaseConfig = function() {
                    var returnFunc = function(baseData) {
                        $rootScope.appid = baseData.appid;
                        $rootScope.secret = baseData.secret;
                        $rootScope.zwwAppid = baseData.zwwAppid;
                        $rootScope.zwwSecret = baseData.zwwSecret;
                        $rootScope.deviceModelName = baseData.deviceModelName;
                        $rootScope.systemVersion = baseData.systemVersion;
                        $rootScope.uuid = baseData.uuid;
                        $rootScope.deviceAuthenticationType = baseData.deviceAuthenticationType;//0-生物识别都不支持 1-面容 2-指纹
                        $rootScope.appVersion = baseData.version;
                        if (cordova.platformId === 'android') {
                            $rootScope.urlConfig = {
                                "serverUrl": baseData.urlConfig.serverUrl,
                                "cloudCertUrl": baseData.urlConfig.cloudCertUrl,
                                "doDecDataUrl": baseData.urlConfig.cloudCertUrl,
                                "authCenterUrl" : baseData.urlConfig.authCenterUrl,
                                "scanUrl": baseData.urlConfig.scanUrl,
                                "OCRUrl": baseData.urlConfig.OCRUrl,
                                "CTIDAuthUrl": baseData.urlConfig.CTIDAuthUrl,
                                "msgCenterUrl": baseData.urlConfig.msgCenterUrl,
                                "TimeUrl": baseData.urlConfig.TimeUrl,
                                "frdecrUrl": baseData.urlConfig.frdecrUrl,
                                "stampUrl": baseData.urlConfig.stampUrl,
                                "letterUrl":baseData.urlConfig.letterUrl
                            }
                        }

                        window.currentUrl = baseData.urlConfig.serverUrl;

                        // 判断测试/正式环境
                        if (-1 != baseData.urlConfig.serverUrl.search("test.icinfo.cn")
                        || -1 != baseData.urlConfig.serverUrl.search("115.238.48.66")
                        || -1 != baseData.urlConfig.serverUrl.search("192.168.5.101")
                        || -1 != baseData.urlConfig.serverUrl.search("192.168.1.240")
                        ) {
                            $rootScope.isDebug = true;
                            var vConsole = new VConsole();
                        } else {
                            $rootScope.isDebug = false;
                        }

                    }

                    nativeHelper.getBaseConfig({
                        data:[],
                        success: returnFunc
                    });
                }
                getBaseConfig();

                var loaded = function () {
                    try {
                        var loginInfo = localStorage.getObject('loginInfo');
                        if (JSON.stringify(loginInfo) == '{}') {
                            //nav.navigate('certManage');
                            // nav.navigate('signIn');
                            // nav.navigate('home');
                            // nav.navigate('home');
                            nav.navigate('tab/home');
                        }
                        else {
                            if (parseInt(new Date().getTime() - loginInfo.firstLoginDate) <= 86400000 * 30) {
//                            if(device.version!='5.1.1')
                                PushAgent.setAlias(function(){},loginInfo.userId,'userUniqueId');

                                nav.navigate('tab/home');
                            }
                            else {
                                nav.navigate('tab/home');
                            }
                        }
                    } catch (e) {
                        nav.navigate('tab/home');
                    }
                };

                // getConfigInfo();
                //loaded();

                var checkConnection = function () {
                    // var networkState = navigator.connection.type;

                    // if (networkState == Connection.NONE) {
                    //     // nav.navigate('signIn');
                    //     nav.navigate('home');
                    //     return;
                    // }
                    // else {
                        loaded();
                    // }
                };

                checkConnection();

            });

            if (cordova.platformId === 'android') {

                //控制选择控件物理返回不消失的问题
                $ionicPlatform.registerBackButtonAction(function (e) {
                    if (control.androidPicker($location.path())) {
                         $.closePicker()
                        }
                         if ($location.path() == '/applyAuthorizeComplete' || $location.path() == '/authorizationRecord') {
                                       if ($rootScope.backButtonGoBack) {
                                              $rootScope.backButtonGoBack = false;
                                                $ionicHistory.goBack();
                                                $ionicViewSwitcher.nextDirection("back");
                                            } else {

                                    setTimeout(function () {
                                        $rootScope.backButtonGoBack = true;
                                    }, 500);
                                            };
                                        }
                     //android物理返回退回home
                    if (control.androidPlatFormGoHome($location.path())) {
                        var timeout = setTimeout(function () {
                            control.showLoading();
                            if (angular.isDefined($rootScope.stop)) {
                                $interval.cancel($rootScope.stop);
                                $rootScope.stop = undefined;
                            }
                            nav.go('tab/home');
                            $ionicHistory.clearHistory();
                            $ionicViewSwitcher.nextDirection("back");
//                            $ionicHistory.clearCache();
                            clearTimeout(timeout)
                            control.hideLoading();
                        }, 50);
                    }

                    //判断处于哪个页面时双击退出

                    else if (control.androidPlatFormExit($location.path())) {

                        if ($rootScope.backButtonPressedOnceToExit) {
                            $ionicHistory.clearHistory();
                            $ionicHistory.clearCache();
                            ionic.Platform.exitApp();

                        } else {
                            $rootScope.backButtonPressedOnceToExit = true;
                            control.showPopup('再按一次退出E照通', 1000);
                            setTimeout(function () {
                                $rootScope.backButtonPressedOnceToExit = false;
                            }, 2000);
                        };
                    }
                    else if ($ionicHistory.backView()) {
                        $ionicHistory.goBack();
                    }
//                    else if ($rootScope.backButtonPressedOnceToExit) {
//                        ionic.Platform.exitApp();
//                    } else {
//                        $rootScope.backButtonPressedOnceToExit = true;
//                        control.showPopup('再按一次退出E照通', 1000);
//                        setTimeout(function () {
//                            $rootScope.backButtonPressedOnceToExit = false;
//                        }, 2000);
//                    }
                    e.preventDefault();
                    return false;
                }, 101);
            }
        }])

    .config(['$stateProvider', '$urlRouterProvider', '$locationProvider', '$ionicConfigProvider',function ($stateProvider, $urlRouterProvider, $locationProvider, $ionicConfigProvider) {
        $stateProvider
        //登录
           .state('signIn', {
               url: '/signIn',
               cache: 'false',
               templateUrl: 'html/account/signIn.html',
               controller: 'signIn'
           })

           //注册
           .state('signUp', {
               url: '/signUp',
               cache: 'false',
               templateUrl: 'html/account/signUp.html',
               controller: 'signUp'
           })

           //忘记密码
           .state('retrievePassword', {
               url: '/retrievePassword',
               cache: 'false',
               templateUrl: 'html/account/retrievePassword.html',
               controller: 'retrievePassword'
           })

//           //首页
        //    .state('home', {
        //        url: '/home',
        //        cache: 'false',
        //        templateUrl: 'html/home/home.html',
        //        controller: 'home',
        //        params:{
        //        pagePath:''
        //        }
        //    })

           //我的证书
           .state('certManage', {
               url: '/certManage',
               cache: 'false',
               templateUrl: 'html/home/certManage.html',
               controller: 'certManage',
               params:{
                certManageSearchKey:null,
               }
           })
           //证书详情
           .state('certDetail', {
               url: '/certDetail',
               cache: 'false',
               templateUrl: 'html/home/certDetail.html',
               controller: 'certDetail',
               params:{
                parentPage:""
               }
           })
           //业务管理
           .state('businessManage', {
               url: '/businessManage',
               cache: 'false',
               templateUrl: 'html/home/businessManage.html',
               controller: 'businessManage',
               params:{
                businessManageSearchKey:null,
                orderNo:"",
                parentPage:""
               }
           })

//           //用户
        //    .state('account', {
        //        url: '/account',
        //        cache: 'false',
        //        templateUrl: 'html/account/account.html',
        //        controller: 'account'
        //    })

           //账号与安全
           .state('security', {
            url: '/security',
            cache: 'false',
            templateUrl: 'html/account/security.html',
            controller: 'security'
            })
             //注销
           .state('logOff', {
               url: '/logOff',
               cache: 'false',
               templateUrl: 'html/account/logOff.html',
               controller: 'logOff'
           })
           // 应用权限设置
           .state('permissionSettings', {
              url: '/permissionSettings',
              cache: 'false',
              templateUrl: 'html/account/permissionSettings.html',
              controller: 'permissionSettings'
           })

           //证书设备管理
           .state('deviceManage', {
            url: '/deviceManage',
            cache: 'false',
            templateUrl: 'html/account/deviceManage.html',
            controller: 'deviceManage'
            })

           // 常见问题
           .state('commonProblem', {
               url: '/commonProblem',
               cache: 'false',
               templateUrl: 'html/account/commonProblem.html',
               controller: 'account'
           })

            // 视频引导
            .state('videoGuidance', {
                url: '/videoGuidance',
                cache: 'false',
                templateUrl: 'html/home/videoGuidance.html',
                controller: 'videoGuidance'
            })


           // 使用帮助
           .state('usingHelp', {
               url: '/usingHelp',
               cache: 'false',
               templateUrl: 'html/account/usingHelp.html',
               controller: 'account'
           })

           //扫一扫证书列表
           .state('showLocalCertList', {
               url: '/showLocalCertList',
               cache: 'false',
               templateUrl: 'html/home/showLocalCertList.html',
               controller: 'showLocalCertList'
           })

           

           //忘记密码
           .state('retrievePasswordForPwdPopup', {
                url: '/retrievePasswordForPwdPopup',
                cache: 'false',
                templateUrl: 'html/downloadCert/retrievePasswordForPwdPopup.html',
                controller: 'retrievePasswordForPwdPopup'
            })

           //下载证书
           .state('downloadCert', {
               url: '/downloadCert',
               cache: 'false',
               templateUrl: 'html/downloadCert/downloadCert.html',
               controller: 'downloadCert',
               params:{
               downloadCertInfo:null
               }
           })
             //下载证书成功
           .state('downloadCertSuccess', {
               url: '/downloadCertSuccess',
               cache: 'false',
               templateUrl: 'html/downloadCert/downloadCertSuccess.html',
               controller: 'downloadCertSuccess',
               params: {
                   downloadSuccessInfo: null
               }
           })
           //--添加管理员
            .state('addAdmin', {
                url: '/addAdmin',
                cache: 'false',
                templateUrl: 'html/downloadCert/addAdmin.html',
                controller: 'addAdmin',
                params: {
                   certEntInfo: null
                }
            })
           //变更、延期下载证书
           .state('delayOrChangeDwnCert', {
               url: '/delayOrChangeDwnCert',
               cache: 'false',
               templateUrl: 'html/downloadCert/delayOrChangeDwnCert.html',
               controller: 'delayOrChangeDwnCert',
               params: {
                lastPage: null,
                entName: null,
                uniscid: null,
                orderNo: null,
                corpid: null,
                type: null,
                certId: null,
                containerName: null
                }
           })
           //主体查询
           .state('subjectQuery', {
               url: '/subjectQuery',
               cache: 'false',
               templateUrl: 'html/home/subjectQuery.html',
               controller: 'subjectQuery'
           })

           //证书补办(证书新领)
           .state('reissueOrGetNewCert', {
               url: '/reissueOrGetNewCert',
               cache: 'false',
               templateUrl: 'html/home/reissueOrGetNewCert.html',
               controller: 'reissueOrGetNewCert'

           })

           //证书新领/补办（办理须知）
           .state('certApplyNotice', {
               url: '/certApplyNotice',
               templateUrl: 'html/home/certApplyNotice.html',
               controller: 'certApplyNotice'

           })

           //证书补办/新领（经办人信息）
           .state('certAgentInfo', {
               url: '/certAgentInfo',
               cache: 'false',
               templateUrl: 'html/home/certAgentInfo.html',
               controller: 'certAgentInfo'

           })

           //证书补办/新领（办理材料）
           .state('certExamineMaterial', {
               url: '/certExamineMaterial',
               cache: 'false',
               templateUrl: 'html/home/certExamineMaterial.html',
               controller: 'certExamineMaterial'

           })

           //委托模板
           .state('entrustTemplate', {
               url: '/entrustTemplate',
               templateUrl: 'html/home/entrustTemplate.html',
               controller: 'certApplyNotice'
           })

           //协议
           .state('eztAgreement', {
               url: '/eztAgreement',
               cache: 'false',
               templateUrl: 'html/home/eztAgreement.html',
               controller: 'eztAgreement'
           })

           //授权记录-提升用户等级
//           .state('authenticationConfirm', {
//                url: '/authenticationConfirm',
//                templateUrl: 'html/other/authenticationConfirm.html',
//                controller: 'authenticationConfirm',
//                params:{
//                }
//            })

           //更新证件照片
           .state('updateCertificatePic', {
               url: '/updateCertificatePic',
               cache: 'false',
               templateUrl: 'html/home/updateCertificatePic.html',
               controller: 'updateCertificatePic'
           })

           //修改密码
           .state('modifyPassword', {
               url: '/modifyPassword',
               cache: 'false',
               templateUrl: 'html/account/modifyPassword.html',
               controller: 'modifyPassword'
           })

           //证书延期
           .state('certDelay', {
               url: '/certDelay',
               cache: 'false',
               templateUrl: 'html/home/certDelay.html',
               controller: 'certDelay'
           })

           //证书变更
           .state('certChange', {
               url: '/certChange',
               cache: 'false',
               templateUrl: 'html/home/certChange.html',
               controller: 'certChange'
           })

           //新领证书新流程
           .state('userNotice', {
               url: '/userNotice',
               cache: 'false',
               templateUrl: 'html/home/autoApply/userNotice.html',
               controller: 'userNotice',
               params:{
                   orderNo:null
               }
           })

           //拍摄规则
           .state('photoRules', {
               url: '/photoRules',
               cache: 'false',
               templateUrl: 'html/home/autoApply/photoRules.html',
               controller: 'photoRules'
           })

           //上传营业执照
           .state('checkBusinessLicense', {
               url: '/checkBusinessLicense',
               cache: 'false',
               templateUrl: 'html/home/autoApply/checkBusinessLicenseV2.html',
               controller: 'checkBusinessLicense'
           })


           //上传营业执照-补全资料
           .state('uploadBusinessLicense', {
                url: '/uploadBusinessLicense',
                cache: 'false',
                templateUrl: 'html/home/autoApply/uploadBusinessLicense.html',
                controller: 'uploadBusinessLicense',
                params : {
                    from: null
                }
            })

            //上传身份证正反面-补全资料
           .state('uploadIdentityCard', {
                url: '/uploadIdentityCard',
                cache: 'false',
                templateUrl: 'html/home/autoApply/uploadIdentityCard.html',
                controller: 'uploadIdentityCard'
            })

            //上传人脸图片
           .state('uploadAuthPic', {
                url: '/uploadAuthPic',
                cache: 'false',
                templateUrl: 'html/home/autoApply/uploadAuthPic.html',
                controller: 'uploadAuthPic'
            })

           // 电子营业执照
           .state('eleBusinessLicense', {
               url: '/eleBusinessLicense',
               cache: 'false',
               templateUrl: 'html/home/eleBusinessLic/eleBusinessLicense.html',
               controller: 'eleBusinessLicense'
           })

           // 电子营业执照申领信息
           .state('businessLicApplyInfo', {
               url: '/businessLicApplyInfo',
               cache: 'false',
               templateUrl: 'html/home/eleBusinessLic/businessLicApplyInfo.html',
               controller: 'businessLicApplyInfo'
           })
           //下载电子营业执照
           .state('downloadEleBusinessLic', {
               url: '/downloadEleBusinessLic',
               cache: 'false',
               templateUrl: 'html/home/eleBusinessLic/downloadEleBusinessLic.html',
               controller: 'downloadEleBusinessLic',
               params: {
                   applyInfo: null
               }
           })
           // 营业执照
           .state('viewBusinessLicense', {
               url: '/viewBusinessLicense',
               cache: 'false',
               templateUrl: 'html/home/eleBusinessLic/viewBusinessLicense.html',
               controller: 'viewBusinessLicense',
           })
           // 使用/出示营业执照
           .state('useBusinessLicense', {
               url: '/useBusinessLicense',
               cache: 'false',
               templateUrl: 'html/home/eleBusinessLic/useBusinessLicense.html',
               controller: 'useBusinessLicense',
               params: {
                   imgBase64: null
               }
           })
           //证照识别
           .state('businessLicDiscern', {
               url: '/businessLicDiscern',
               cache: 'false',
               templateUrl: 'html/home/eleBusinessLic/businessLicDiscern.html',
               controller: 'businessLicDiscern'
           })
           //上传授权书
           .state('checkAuthorization', {
               url: '/checkAuthorization',
               cache: 'false',
               templateUrl: 'html/home/autoApply/checkAuthorizationV2.html',
               controller: 'checkAuthorization'
           })

           //上传身份证
           .state('checkIdentityCard', {
               url: '/checkIdentityCard',
               cache: 'false',
               templateUrl: 'html/home/autoApply/checkIdentityCardV2.html',
               controller: 'checkIdentityCard'
           })

           //业务完成
           .state('businessCompleted', {
               url: '/businessCompleted',
               cache: 'false',
               templateUrl: 'html/home/autoApply/businessCompletedV2.html',
               controller: 'businessCompleted',
               params:{
                orderNo:null,
                sourceType:""
               }
           })

           //OCR通道用户协议
           .state('agreement', {
               url: '/agreement',
               cache: 'false',
               templateUrl: 'html/home/autoApply/agreement.html',
               controller: 'agreement'
           })
           //付款信息查询接口
           .state('orderDetails', {
               url: '/orderDetails',
               cache: 'false',
               templateUrl: 'html/home/orderDetailsV2.html',
               controller: 'orderDetails',
               params: {
                   orderInfo: null
               }
           }).state('paymentSuccess', {
               url: '/paymentSuccess',
               cache: 'false',
               templateUrl: 'html/aliPay/paymentSuccess.html',
               controller: 'paymentSuccess',
               params: {
                   orderNo: null
               }
           })
           //年费付款信息查询接口
           .state('annualOrderDetails', {
               url: '/annualOrderDetails',
               cache: 'false',
               templateUrl: 'html/home/orderDetailsV2.html',
               controller: 'annualOrderDetails',
               params: {
                   orderInfo: null
               }
           }).state('annualPaymentSuccess', {
               url: '/annualPaymentSuccess',
               cache: 'false',
               templateUrl: 'html/annualFeePay/annualPaymentSuccess.html',
               controller: 'annualPaymentSuccess'
           })

           //----新领证书付费人工审核发票路由 start----
           .state('payCertApplyInvoice', {
               url: '/payCertApplyInvoice',
               cache: 'false',
               templateUrl: 'html/home/payApply/payCertApplyInvoice.html',
               controller: 'payCertApplyInvoice'
           })

           //----新领证书付费人工审核路由 end----
           .state('autoApplyInvoice', {
               url: '/autoApplyInvoice',
               cache: 'false',
               templateUrl: 'html/home/confirmInvoiceInfoV2.html',
               controller: 'autoApplyInvoice'
           })
           //----证书年费流程 start-----
           .state('confirmPayInfo', {
               url: '/confirmPayInfo',
               cache: 'false',
               templateUrl: 'html/annualFeePay/confirmPayInfo.html',
               controller: 'confirmPayInfo'
           }).state('annualFeeInvoice', {
               url: '/annualFeeInvoice',
               cache: 'false',
               templateUrl: 'html/home/confirmInvoiceInfoV2.html',
               controller: 'annualFeeInvoice'
           })
           //-----------授权中心-------------
           //------身份信息核对-------
           .state('authorityCenter', {
               url: '/authorityCenter',
               cache: 'false',
               templateUrl: 'html/home/authority/authorityCenter.html',
               controller: 'authorityCenter'
           })
               //授权记录
               .state('authorizationRecord', {
               url: '/authorizationRecord',
               cache: 'false',
               templateUrl: 'html/authorizationRecord/authorizationRecord.html',
               controller: 'authorizationRecord',
               params:{
                   authStatus:"",
                   parentPage: ""
               }
           })
              //授权记录详情
               .state('authorizationDetails', {
               url: '/authorizationDetails',
               cache: 'false',
               templateUrl: 'html/authorizationRecord/authorizationDetails.html',
               controller: 'authorizationDetails',
               params:{
                    authorizationDetail:null
               }
               })
                 //授权审批
               .state('authenticationApproval', {
               url: '/authenticationApproval',
               templateUrl: 'html/authorizationRecord/authenticationApproval.html',
               controller: 'authenticationApproval',
               cache: 'false',
               params:{
                    authorizationDetail:null
               }

           })
                 //授权签名
               .state('signatureAuthorization', {
               url: '/signatureAuthorization',
               templateUrl: 'html/authorizationRecord/signatureAuthorization.html',
               controller: 'signatureAuthorization',
               cache:'false',
               params:{
                    authorizationDetail:null
               }

           })
                 //授权记录-提升用户等级认证信息
               .state('authenticationInfo', {
               url: '/authenticationInfo',
               templateUrl: 'html/authorizationRecord/authenticationInfoV2.html',
               controller: 'authenticationInfo',
               cache:'false',
               params:{
//                    authorizationDetail:null
               }
           })
           //授权记录-提升用户等级
           .state('authorizationFace', {
               url: '/authorizationFace',
               templateUrl: 'html/authorizationRecord/authorizationFace.html',
               controller: 'authorizationFace',
               params:{
//                    authorizationDetail:null
               }

           })


           //-------------------授权申领-------------
           //------------------申领人身份信息--------
           .state('authorizedPerson', {
               url: '/authorizedPerson',
               cache: 'false',
               templateUrl: 'html/home/authorityApply/authorizedPerson.html',
               controller: 'authorizedPerson',

           }).state('authorityConfirm', {
               url: '/authorityConfirm',
               cache: 'false',
               templateUrl: 'html/home/authorityApply/authorityConfirm.html',
               controller: 'authorityConfirm',
               params: {
                   cardId: null,
                   cardName: null
               }
           })
           //授权申领完成
           .state('authorizedApplyComplete', {
               url: '/authorizedApplyComplete',
               cache: 'false',
               templateUrl: 'html/home/authorityApply/authorizedApplyComplete.html',
               controller: 'businessCompleted',
           })

            //授权领证--搜索企业
            .state('applyCertSearch', {
                url: '/applyCertSearch',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/applyCertSearch.html',
                controller: 'applyCertSearch',
            })
            //授权领证--可领证书
            .state('ableApplyCertInfo', {
                url: '/ableApplyCertInfo',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/ableApplyCertInfo.html',
                controller: 'ableApplyCertInfo',
                //               params: {searchContent:null}
            })
            //授权领证--确认经办人信息
            .state('claimantInfo', {
                url: '/claimantInfo',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/claimantInfo.html',
                controller: 'claimantInfo',

            })
            //授权领证--经办人信息人脸认证结果
//            .state('authenticationResults', {
//                url: '/authenticationResults',
//                cache: 'false',
//                templateUrl: 'html/home/authorizedApplyCert/authenticationResults.html',
//                controller: 'authenticationResults',
//                //               params: {searchContent:null}
//            })
            //授权领证--确认授权证书
            .state('confirmAuthorizeInfo', {
                url: '/confirmAuthorizeInfo',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/confirmAuthorizeInfo.html',
                controller: 'confirmAuthorizeInfo',
                //               params: {searchContent:null}
            })
            //授权领证--确认授权证书发票
            .state('confirmCertInvoice', {
                url: '/confirmCertInvoice',
                cache: 'false',
                templateUrl: 'html/home/confirmInvoiceInfoV2.html',
                controller: 'confirmCertInvoice',
                params: {netOrderInfoWithInvoice:null}
            })
            //授权领证--确认授权证书付费订单信息
            .state('orderInfoConfirm', {
                url: '/orderInfoConfirm',
                cache: 'false',
                templateUrl: 'html/home/orderDetailsV2.html',
                controller: 'orderInfoConfirm',
                params: {
                    orderInfo: null
                }
            })
            //授权领证--申请授权
            .state('applyAuthorize', {
                url: '/applyAuthorize',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/applyAuthorize.html',
                controller: 'applyAuthorize',
                params: {params:null}
            })

            //授权领证--申领成功
            .state('applyAuthorizeComplete', {
                url: '/applyAuthorizeComplete',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/applyAuthorizeCompleteV2.html',
                controller: 'applyAuthorizeComplete',
                params: {
                    linkInfo: null
                }
            })
            //授权领证--选择经办人
            .state('selectHandler', {
                url: '/selectHandler',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/selectHandler.html',
                controller: 'selectHandler',
//                params: {
//                         link: null
//                               }
            })   //授权领证--确认授权经办人
            .state('approvalInfo', {
                url: '/approvalInfo',
                cache: 'true',
                templateUrl: 'html/home/authorizedApplyCert/approvalInfo.html',
                controller: 'selectHandler',
//                params: {
//                         link: null
//                               }
            })
               //授权领证--法定代表人
            .state('legalRepresentative', {
                url: '/legalRepresentative',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/legalRepresentative.html',
                controller: 'legalRepresentative',
//                params: {
//                         link: null
//                               }
            })
            //授权领证--新增经办人
            .state('addNewHandler', {
                url: '/addNewHandler',
                cache: 'false',
                templateUrl: 'html/home/authorizedApplyCert/addNewHandler.html',
                controller: 'addNewHandler',
//                params: {
//                         link: null
//                               }
            })

        //----消息中心---

            //消息中心--消息列表
            .state('messageCenter', {
                url: '/messageCenter',
                cache: 'false',
                templateUrl: 'html/notificationCenter/messageCenter.html',
                controller: 'messageCenter',

            })
            //消息中心--消息详情
            .state('messageDetails', {
                url: '/messageDetails',
                cache: 'false',
                templateUrl: 'html/notificationCenter/messageDetails.html',
                controller: 'messageDetails',
                 params: {
                                         msgDetail: null
                                               }
            })
             //完成业务单-邮寄说明
            .state('postIntroduction', {
                url: '/postIntroduction',
                cache: 'false',
                templateUrl: 'html/home/autoApply/postIntroduction.html',
                controller: 'postIntroduction',
                 params: {
                     orderNo: null,
                 }
            })
               //扫一扫-提示页面
            .state('scanPrompt', {
                url: '/scanPrompt',
                cache: 'false',
                templateUrl: 'html/home/scanPrompt.html',
                controller: 'scanPrompt',
                 params: {
//                        orderNo: null
                 }
            })
        
        //完成签章
       .state('signCompleted', {
           url: '/signCompleted',
           cache: 'false',
           templateUrl: 'html/home/signCompleted.html',
           controller: 'signCompleted',
            params: {
                cert:null
            }
       })
          //签名会话
       .state('signConversation', {
           url: '/signConversation',
           cache: 'false',
           templateUrl: 'html/home/signConversation.html',
           controller: 'signConversation',
            params: {
                cert:null
            }
       })
        //tab
       .state('tab', {
            url: '/tab',
            abstract: true,
            templateUrl: 'html/tab/tabs.html',
            controller: 'tab'
        })

        //首页
        .state('tab.home', {
            url: '/home',
            cache: 'false',
            views: {
                'tab-home': {
                    templateUrl: 'html/tab/tab-home.html',
                    controller: 'home'
                }
            }
        })

        //我的
        .state('tab.account', {
            url: '/account',
            cache: 'false',
            views: {
                'tab-account': {
                    templateUrl: 'html/tab/tab-account.html',
                    controller: 'account'
                }
            }
        })

         //授权领证--搜索企业
       .state('applyCertSearchV2', {
            url: '/applyCertSearchV2',
            cache: 'false',
            templateUrl: 'html/home/authorizedApplyCert/applyCertSearchV2.html',
            controller: 'applyCertSearchV2'
       })
       //授权领证--可申领证书
       .state('ableApplyCertInfoV2', {
             url: '/ableApplyCertInfoV2',
             cache: 'false',
             templateUrl: 'html/home/authorizedApplyCert/ableApplyCertInfoV2.html',
             controller: 'ableApplyCertInfoV2'
       })
       //授权领证--可补办证书
       .state('ableMakeUpCertInfoV2', {
            url: '/ableMakeUpCertInfoV2',
            cache: 'false',
            templateUrl: 'html/home/authorizedApplyCert/ableMakeUpCertInfoV2.html',
            controller: 'ableApplyCertInfoV2'
       })
       //授权领证--选择身份
       .state('chooseIdentity', {
            url: '/chooseIdentity',
            cache: 'false',
            templateUrl: 'html/home/authorizedApplyCert/chooseIdentity.html',
            controller: 'chooseIdentity'
       })
        //授权领证--选择身份
       .state('approvallnfoV2', {
            url: '/approvallnfoV2',
            cache: 'false',
            templateUrl: 'html/home/authorizedApplyCert/approvallnfoV2.html',
            controller: 'approvallnfoV2'
       })

        //授权经办人领证--授权成功
        .state('authorizeComplete', {
             url: '/authorizeComplete',
             cache: 'false',
             templateUrl: 'html/home/authorizedApplyCert/authorizeComplete.html',
             controller: 'authorizeComplete'
        })
        //邮寄材料--生成付费业务单
        .state('mailPayInvoice', {
             url: '/mailPayInvoice',
             cache: 'false',
             templateUrl: 'html/home/confirmInvoiceInfoV2.html',
             controller: 'mailPayInvoice'
        })
        //邮寄材料--生成付费业务单
        .state('authenticationResult', {
             url: '/authenticationResult',
             cache: 'false',
             templateUrl: 'html/authorizationRecord/authenticationResult.html',
             controller: 'authenticationResult',
             params:{
                 isAuthSuccess:false
             }
        })
        // 经办人选择申领方式
        .state('chooseApplyWay', {
             url: '/chooseApplyWay',
             cache: 'false',
             templateUrl: 'html/home/authorizedApplyCert/chooseApplyWay.html',
             controller: 'chooseApplyWay'
        })
        // 授权书预览
        .state('authorizationBook', {
            url: '/authorizationBook',
            cache: 'false',
            templateUrl: 'html/authorizationRecord/authorizationBook.html',
            controller: 'authorizationBook',
            params:{
                authorizationDetail:null
            }
        })
        // 上传材料领证
        .state('uploadApplyMaterials', {
              url: '/uploadApplyMaterials',
              cache: 'false',
              templateUrl: 'html/home/autoApply/uploadApplyMaterials.html',
              controller: 'uploadApplyMaterials'
        })
        // 消息中心
        .state('helpCenter', {
              url: '/helpCenter',
              cache: 'false',
              templateUrl: 'html/account/helpCenter.html',
              controller: 'helpCenter'
        })
        // 关于版本
        .state('aboutVersion', {
            url: '/aboutVersion',
            cache: 'false',
            templateUrl: 'html/account/aboutVersion.html',
            controller: 'aboutVersion'
        })
        // 输入验证码
        .state('enterVerifyCode', {
            url: '/enterVerifyCode',
            cache: 'false',
            templateUrl: 'html/account/enterVerifyCode.html',
            controller: 'enterVerifyCode'
        })
        // 首页搜索
        .state('searchEnterprise', {
            url: '/searchEnterprise',
            cache: 'false',
            templateUrl: 'html/home/searchEnterprise.html',
            controller: 'searchEnterprise'
        })

        //----证书年费流程 end-------


        // if none of the above states are matched, use this as the fallback
        //$urlRouterProvider.otherwise('/home');

        $ionicConfigProvider.platform.ios.tabs.style('standard');

        $ionicConfigProvider.platform.ios.tabs.position('bottom');

        $ionicConfigProvider.platform.android.tabs.style('standard');

        $ionicConfigProvider.platform.android.tabs.position('standard');

        $ionicConfigProvider.platform.ios.navBar.alignTitle('center');

        $ionicConfigProvider.platform.android.navBar.alignTitle('left');

        $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');

        $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

        $ionicConfigProvider.platform.ios.views.transition('ios');

        $ionicConfigProvider.platform.android.views.transition('android');

        $ionicConfigProvider.views.swipeBackEnabled(false);//禁止侧滑后退事件

        //$ionicConfigProvider.views.transition('no');
    }]);


