(function () {
    "use strict"

    angular.module('starter')
    .controller('deviceManage', ['$rootScope', '$scope', 'nav', 'control', 'localStorage', '$ionicHistory', 'requestWrapper', 'utility', 'md5', function ($rootScope, $scope, nav, control, localStorage, $ionicHistory, requestWrapper, utility, md5) {

        $scope.isAuth = ("1" == $rootScope.loginInfo.realNameGrade);
        $scope.deviceList = [];
        $scope.hasData = true;

        // 获取设备
        var getMobileDeviceList = function() {
            control.showLoading();
            var time = utility.getCurrentTime();
            var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
            var params = {
                'appid': $rootScope.appid,
                'time': time,
                'hashdata': hashdata,
                'mobilePhone': $rootScope.loginInfo.mobile,
                'idCard': $rootScope.loginInfo.idCard
            }
            requestWrapper.doGetMobileDeviceList({data: params, refresh: true})
                .then(function (result) {
                    control.hideLoading();
                    console.log("doGetMobileDeviceCount" + JSON.stringify(result));
                    if (result.success) {
                        $scope.deviceList = result.value;
                        if(Array.isArray($scope.deviceList)  && $scope.deviceList.length > 0){
                            $scope.hasData = true;  
                        }else{
                            $scope.hasData = false;  
                        }
                    } else {
                        control.showPopup(result.msg, 2000);
                    }
                });
        }
        if ($scope.isAuth) {
            getMobileDeviceList();
        }else{
            $scope.hasData = false;
        }

        var removeMobileDevice = function(keySerial) {
            control.showLoading();
            var time = utility.getCurrentTime();
            var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
            var temp = {
                'mobilePhone': $rootScope.loginInfo.mobile,
                'idCard': $rootScope.loginInfo.idCard,
                'keySerial': keySerial,
                'keyNo':$rootScope.uuid,
                "token" : $rootScope.loginInfo.token
            }

            var reqParams = DES3.encrypt(hashdata.substring(0,24), 'ZJHUIXIN', angular.toJson(temp))
            
            var params = {
                "appid": $rootScope.appid,
                "time": time,
                "hashdata": hashdata,
                "reqParams": reqParams
            };

            requestWrapper.doRemoveMobileDevice({data: params, refresh: true})
                .then(function (result) {
                    control.hideLoading();
                    console.log("doRemoveMobileDevice" + JSON.stringify(result));
                    if (true == result.success) {
                        control.showPopup("移除成功", 2000);
                        for (let index in $scope.deviceList) {
                            if ($scope.deviceList[index].keySerial == keySerial) {
                                $scope.deviceList.splice(index, 1);
                                break;
                            }
                        }

                        if(Array.isArray($scope.deviceList) && $scope.deviceList.length < 1){
                            $scope.hasData = false;
                        }
                    } else {
                        control.showPopup(result.msg, 2000);
                    }
                });
        }

        $scope.removeClick = function (keySerial) {
            var okFunc = function() {
                removeMobileDevice(keySerial);
            }
            var cancelFunc = function() {
            }
            var template = "<div class='device-alert'><h3>提示</h3><p><span class='color-333'>确定要移除该设备吗？移除后在该设备下载证书时需要进行身份认证</span></p></div>"
            control.showConfirm3(okFunc, cancelFunc, '取消', '确定', 'check-information', template);
        }

        $scope.navigate = function (state) {
            nav.navigate(state);
        };
    }]);
})();