﻿(function () {
    "use strict"
    angular.module('starter')
    .controller('enterVerifyCode', ['$rootScope', '$scope', '$ionicLoading', 'nav', 'nativeHelper', 'control', 'validate', '$filter','verifyIdentity', function ($rootScope, $scope, $ionicLoading, nav, nativeHelper, control, validate, $filter,verifyIdentity) {

        $scope.verify = {
            authCode: ''
        }
        $scope.erroCode = '0';
        $scope.btnColor = '0';
        $scope.showBtn = true;

        $scope.$watch('verify.authCode', function(newValue, oldValue) {
            $scope.verify.authCode = newValue
            console.log("$scope.verify.authCode="+$scope.verify.authCode)
            if('' != $scope.verify.authCode){
                $scope.btnColor = '1';
            }else{
                $scope.btnColor = '0';
            }
        });

        $scope.verifySmsCode = function () {
            if($scope.btnColor == '0'){
                return;
            }
            if (validate.nullOrEmpty($scope.verify.authCode)) {
                control.showPopup('请输入验证码', 3000);
                return;
            }
            control.showLoading();
            var params = [$rootScope.loginInfo.mobile,$scope.verify.authCode];
            var successFunc = function (result) {
                control.hideLoading();
                if (result == null || angular.equals({}, result)) {
                    control.showPopup('服务出错啦', 3000);
                    return;
                }
                switch (result.success) {
                    case true:
                        // 0 正常申领  1.申领短信验证返回  2.申领短信验证通过  3.正常授权 4.授权短信验证返回  5.授权短信验证通过
                         if($rootScope.verifyCodeType=='3'){
                            $rootScope.verifyCodeType = '5';
                            nav.navigate('authorizationRecord');
                         }else if($rootScope.verifyCodeType=='0'){
                            $rootScope.verifyCodeType = '2';
                            nav.navigate('chooseIdentity');
                         }
                        break;
                    case false:
                        control.showPopup(result.msg, 3000);
                        break;
                }
            }

            var failFunc = function (error) {
                    control.hideLoading();
            };
            nativeHelper.verifySmsCode({ data: params, success: successFunc, fail: failFunc });

        }

        $scope.navigateBack = function () {
            // 0 正常申领  1.申领短信验证返回  2.申领短信验证通过  3.正常授权 4.授权短信验证返回  5.授权短信验证通过
            if($rootScope.verifyCodeType=='3'){
                $rootScope.verifyCodeType = '4';
                nav.navigate('authorizationRecord');
            }else if($rootScope.verifyCodeType=='0'){
                $rootScope.verifyCodeType = '1';
                nav.navigate('chooseIdentity');
            }else{
                $rootScope.verifyCodeType = '';
                nav.navigate('tab/home');
            }
        };
        var doIdentityVerifyRes = function(result){
            if (result.code == 200) {
                var verifyResult = result.data.verifyResult
                // 法人身份核验判断 verifyResult  0：核验通过/无需核验 1：未核验 2：核验待确认
                if (verifyResult == '0'){
                     if($rootScope.verifyCodeType=='3'){
                        $rootScope.verifyCodeType = '5';
                        nav.navigate('authorizationRecord');
                     }else if($rootScope.verifyCodeType=='0'){
                        $rootScope.verifyCodeType = '2';
                        nav.navigate('chooseIdentity');
                     }
                }else if (verifyResult == '1'){
                    $rootScope.autoApplyInfo = {
                        businessLicensePic: '',
                        businessLicenseEntName: '',
                        businessLicenseOrgCode: '',
                        authorizationPic: '',
                        authorizationEntName: '',
                        authorizationPerson: '',
                        authorizationID: '',
                        authorizationTel: '',
                        authorizationExpDate: '',
                        IDCardFrontPic: '',
                        IDCardBackPic: '',
                        IDCardName: $rootScope.loginInfo.userName ? $rootScope.loginInfo.userName: '',
                        IDCardNumber: $rootScope.loginInfo.idCard ? $rootScope.loginInfo.idCard: '',
                        IDCardIndate: '',
                    };
                    $rootScope.certApplyNoticeParent = 'doIdentityVerifyToUploadPic';
                    nav.navigate('uploadApplyMaterials');
                }else if (verifyResult == '2'){
                    nav.navigate('businessManage')
                }
            }else{
                control.showPopup(result.message, 2000);
            }
        }
        // 材料核验
        $scope.uploadApplyMaterials = function () {
           verifyIdentity.doIdentityVerify($rootScope.certUnderwayInfo.corpid,
               $rootScope.loginInfo.idCard,$rootScope.loginInfo.accountId,$rootScope.loginInfo.mobile,doIdentityVerifyRes);
        };
    }]);
})();