(function () {
    "use strict"

    angular.module('starter')
    .controller('security', ['$rootScope', '$scope', 'nav', 'control', 'localStorage', '$ionicHistory', 'requestWrapper', 'utility', 'md5','nativeHelper', function ($rootScope, $scope, nav, control, localStorage, $ionicHistory, requestWrapper, utility, md5,nativeHelper) {

        $scope.isAuth = ("1" == $rootScope.loginInfo.realNameGrade);
        $scope.userName = $scope.isAuth?$rootScope.loginInfo.userName:'—';
        $scope.deviceCount = 0;

        //配置未开启，则不显示生物识别设置
        $scope.showBiometry = '0';
        // 暂时先去掉
        if(($rootScope.openBiometryAndroid == '1'  && 'android' == cordova.platformId) || ($rootScope.openBiometryIOS == '1' && 'ios' == cordova.platformId)){
            $scope.showBiometry = '1';
        }

        // 获取设备数量
        var getMobileDeviceCount = function() {
            control.showLoading();
            var time = utility.getCurrentTime();
            var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
            var params = {
                'appid': $rootScope.appid,
                'time': time,
                'hashdata': hashdata,
                'mobilePhone': $rootScope.loginInfo.mobile,
                'idCard': $rootScope.loginInfo.idCard
            }
            requestWrapper.doGetMobileDeviceCount({data: params, refresh: true})
                .then(function (result) {
                    control.hideLoading();
                    console.log("doGetMobileDeviceCount" + JSON.stringify(result));
                    if (true == result.success) {
                        $scope.deviceCount = result.value;
                    }else {
                        control.showPopup(result.msg, 2000);
                    }
                });
        }
        if ($scope.isAuth) {
            getMobileDeviceCount();
        }

        $scope.logOff = function () {
             nav.navigate('logOff');
//            var confirm = function () {
//                localStorage.setObject('logOff', '1');
//
//                $rootScope.localCertList = [];
//                localStorage.deleteItem('loginInfo');
//                PushAgent.delAlias(function(){},$rootScope.loginInfo.userId,'userUniqueId')
//                $ionicHistory.clearHistory();
//                nav.navigate('signIn');
//            };
//            var cancel = function () { };
//
//            control.showConfirm('确定要注销当前账号吗？', confirm, cancel);
        };

        // 是否显示注销
        $scope.showLogOff = true;
//        var showLogOffFunc = function () {
//            console.log('$rootScope.loginInfo.mobile - ' + $rootScope.loginInfo.mobile);
//            if ('18324450217' == $rootScope.loginInfo.mobile) {
//                $scope.showLogOff = true;
//            }
//        }
//        showLogOffFunc();


        var verifySwitch = function() {
            let ele = document.getElementById('switch-verify');
            // let openVerify = localStorage.getObject('openVerify');
            let authInfo = localStorage.getObject('authInfo' + $rootScope.loginInfo.accountId);
            // alert('openVerify:' + JSON.stringify(openVerify))
            if ('1' == authInfo.openVerify) {
                // alert('ele.checked = true')
                ele.checked = true;
            } else {
                ele.checked = false;
            }
        }

        verifySwitch();

        let curVerify = document.getElementById('switch-verify');
        $scope.curVerifyState = curVerify.checked;

        $scope.verifyClick = function() {
            console.log('verifyClick')
            let ele = document.getElementById('switch-verify');
            console.log($scope.curVerifyState)
            if($scope.curVerifyState){
                var msg = '确定要关闭指纹验证吗？';
                if($rootScope.deviceAuthenticationType == '1'){
                    msg = '确定要关闭面容验证吗？';
                }
                //已开启，尽心关闭
                control.showConfirm5("<div class='tbtx-cont'><p>" + msg + "</p></div>", "提示信息",
                function() {
                    //关闭生物验证
                    $scope.curVerifyState = ele.checked;
                    var authConfigInfo = {
                        openVerify:'0',
                        isFirstVerify:'0'
                    }
                    localStorage.setObject('authInfo' + $rootScope.loginInfo.accountId, authConfigInfo);
                },
                function() {
                    ele.checked = $scope.curVerifyState;
                },
                "取消", "关闭", 'check-information');
            }else{
                // let isFirstVerify = localStorage.getObject('isFirstVerify');
                let authInfo = localStorage.getObject('authInfo' + $rootScope.loginInfo.accountId);
                console.log('authInfo: ' + JSON.stringify(authInfo))
                if(JSON.stringify(authInfo) == '{}' || !ele.checked){
                    if ('0' != $rootScope.deviceAuthenticationType) {
                        // 如果指纹已打开且可用 用指纹校验
                        var successFunc = function(res) {
                            console.log('success - ' + JSON.stringify(res));
                            if (1 == res.code) {
                                // localStorage.setObject('isFirstVerify', '0');
                                $scope.curVerifyState = ele.checked;

                                var authConfigInfo = {
                                    openVerify:'1',
                                    isFirstVerify:'0'
                                }
                                if(ele.checked == true){
                                    // localStorage.setObject('openVerify', '1');
                                    authConfigInfo.openVerify = '1';
                                } else {
                                    // localStorage.setObject('openVerify', '0');
                                    authConfigInfo.openVerify = '0';
                                }
                                localStorage.setObject('authInfo' + $rootScope.loginInfo.accountId, authConfigInfo);
                            } else if(2 == res.code) {
                                ele.checked = $scope.curVerifyState;
                                //用户选择了取消
                                return;
                            }else if(3 == res.code) {
                                //连续失败次数操作系统规定次数，5次左右，锁定
                                ele.checked = $scope.curVerifyState;
    
                                var msg = '操作太频繁，请稍后再试';
                                if($rootScope.deviceAuthenticationType == '1'){
                                    msg = '操作太频繁，请稍后再试';
                                }
                                control.showPopup(msg, 2000);
                                return;
                            }else if(4 == res.code) {
                                //用户未录入指纹
                                ele.checked = $scope.curVerifyState;
                                var msg = '你尚未设置设备指纹，请先在手机系统设置中录入指纹';
                                if($rootScope.deviceAuthenticationType == '1'){
                                    msg = '你尚未设置面容ID，请先在手机系统设置中录入面容';
                                }
                                control.showCustomAlert6(msg,'check-information');
                                return;
                            }else if(5 == res.code) {
                                //连续错误3次
                                ele.checked = $scope.curVerifyState;
                                var msg = '指纹不匹配';
                                if($rootScope.deviceAuthenticationType == '1'){
                                    msg = '面容不匹配';
                                }
                                control.showPopup(msg, 2000);
                                return;
                            }else if(6 == res.code) {
                                //权限未打开
                                ele.checked = $scope.curVerifyState;
                                var msg = '需要开启设备指纹权限才能使用';
                                if($rootScope.deviceAuthenticationType == '1'){
                                    msg = '需要开启设备面容ID权限才能使用';
                                }
                                control.showPopup(msg, 2000);
                                return;
                            }else {
                                ele.checked = $scope.curVerifyState;
                                // 密码校验
                                // $rootScope.pwdPopupFrom = 'security';
                                // control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopup.html');

                                return;
                            } 
                        }
                        var failFunc = function(res) {
                            console.log('fail - ' + JSON.stringify(res));
                        }
                        nativeHelper.deviceAuthentication({
                            data: [''], 
                            success: successFunc, 
                            fail: failFunc 
                        });
                    } else {
                        ele.checked = $scope.curVerifyState;
                        // 密码校验
                        $rootScope.pwdPopupFrom = 'security';
                        // control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopup.html');
                        var msg = '你尚未设置设备指纹，请先在手机系统设置中录入指纹';
                        if($rootScope.deviceAuthenticationType == '1'){
                            msg = '你尚未设置面容ID，请先在手机系统设置中录入面容';
                        }
                        control.showCustomAlert6(msg,'check-information');
                        return;
                    }
                }else{
                    $scope.curVerifyState = ele.checked;
                    var authConfigInfo = {
                        openVerify:'0',
                        isFirstVerify:'0'
                    }
                    
                    if(ele.checked == true){
                        // localStorage.setObject('openVerify', '1');
                        authConfigInfo.openVerify = '1';
                    }else {
                        // localStorage.setObject('openVerify', '0');
                        authConfigInfo.openVerify = '0';
                    }
                    localStorage.setObject('authInfo' + $rootScope.loginInfo.accountId, authConfigInfo);
                } 
            }
        }

        $rootScope.popupPwdHidden = true;
        $rootScope.userNameForPwdPopup = $rootScope.loginInfo.userName;
        $rootScope.userPhoneForPwdPopup  = $rootScope.loginInfo.mobile;
        $rootScope.pwdPopup = {userPassword: ''};
        $rootScope.passwordPopupCloseClick = function() {
            let ele = document.getElementById('switch-verify');
            ele.checked = $scope.curVerifyState;
            control.hideCustomPopup();
        }
        $rootScope.passwordPopupConfirmClick = function () {
            if('' == $rootScope.pwdPopup.userPassword){
                return;
            }

            var time = utility.getCurrentTime();
            var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
            var temp = {
                'mobile': $rootScope.loginInfo.mobile,
                'password': $rootScope.pwdPopup.userPassword,
                'keyNo':$rootScope.uuid,
                "token" : $rootScope.loginInfo.token
            }

            var reqParams = DES3.encrypt(hashdata.substring(0,24), 'ZJHUIXIN', angular.toJson(temp))
            
            var params = {
                "appid": $rootScope.appid,
                "time": time,
                "hashdata": hashdata,
                "reqParams": reqParams
            };

            console.log('params - ' + JSON.stringify(params));
            control.showLoading();
            requestWrapper.verifyPassword({data: params, refresh: true})
                .then(function (result) {
                    control.hideLoading();
                    console.log("doGetMobileDeviceCount" + JSON.stringify(result));
                    $rootScope.pwdPopup = {userPassword: ''};
                    if (true == result.success) {
                        control.hideCustomPopup();
                        let ele = document.getElementById('switch-verify');
                        ele.checked = !$scope.curVerifyState;
                        // localStorage.setObject('isFirstVerify', '0');
                        var authConfigInfo = {
                            openVerify:'0',
                            isFirstVerify:'0'
                        }
                        
                        if(ele.checked == true){
                            // localStorage.setObject('openVerify', '1');
                            authConfigInfo.openVerify = '1';
                        } else {
                            // localStorage.setObject('openVerify', '0');
                            authConfigInfo.openVerify = '0';
                        }
                        localStorage.setObject('authInfo' + $rootScope.loginInfo.accountId, authConfigInfo);
                    } else {
                        control.showPopup(result.msg, 2000);
                    }
                });
        }
        $rootScope.passwordPopupForgetClick = function () {
            control.hideCustomPopup();

            nav.navigate('retrievePasswordForPwdPopup');
        }

        $rootScope.popupPwdIconClick = function() {
            console.log($rootScope.popupPwdHidden);
            if ($rootScope.popupPwdHidden) {
                console.log('ss=' + $rootScope.popupPwdHidden);
                let input = document.getElementById("pwdpopup-pwdinput");
                console.log(input);
                input.setAttribute("type", "text");
                let icon = document.getElementById("pwdpopup-pwdicon");
                icon.setAttribute("class", "pwdpopup-show-icon");
            } else {
                let input = document.getElementById("pwdpopup-pwdinput");
                input.setAttribute("type", "password");
                let icon = document.getElementById("pwdpopup-pwdicon");
                icon.setAttribute("class", "pwdpopup-hide-icon");
            }
            $rootScope.popupPwdHidden = !$rootScope.popupPwdHidden;
            console.log($rootScope.popupPwdHidden);
        }

        $rootScope.popupPwdClearClick = function() {
            $rootScope.pwdPopup = {userPassword: ''};
        }

        $scope.deviceManageClick = function() {
            nav.navigate('deviceManage');
        }


        $scope.navigate = function (state) {
            nav.navigate(state);
        };
    }]);
})();