(function () {
    "use strict"
    angular.module('starter')
        .controller('signIn', ['$rootScope', '$scope', 'nav', 'validate', 'localStorage', 'control', 'nativeHelper', function ($rootScope, $scope, nav, validate, localStorage, control, nativeHelper) {
//        $rootScope.user = { name: '18616916715', password: '111111' };
            $rootScope.user = {name: '', password: ''};
            $scope.isPwd = true;
            $rootScope.isGetHomeCertApi = true;

             // 获取native基础数据配置，安卓需要登录之后才能获取设备唯一标识
             var getBaseConfig = function() {
                var returnFunc = function(baseData) {
                    $rootScope.uuid = baseData.uuid;
                }
                nativeHelper.getBaseConfig({
                    data:[],
                    success: returnFunc
                });
            }

            $rootScope.isHomePage = false;
            var usageConfirm = function() {
                var confirm = function () {
                    $scope.isAgreeApplyAgreement = true;
                    localStorage.set('isfirstInstall', true);
                   
                    if ('android' == cordova.platformId) {
                        var failFunc = function (error) {};

                        var successFunc = function (result) {}
    
                        var params = [];
                        nativeHelper.applyPermission({data: params, success: successFunc, fail: failFunc});
                    }
                };
                var cancel = function () {
                    // $rootScope.rejectPolicy = true;
                    $rootScope.cancelSecond = true;
                    nav.navigate('tab/home');
                };

                // if ($rootScope.rejectPolicy) {
                //     control.showConfirm7(confirm, cancel, '同意', '不同意', '', 'html/other/agreementConfirm.html');
                // } else {
                //     control.showConfirm7(confirm, cancel, '同意', '不同意', '', 'html/other/usageConfirm.html');
                // }

                control.showConfirm7(confirm, cancel, '同意', '不同意', '', 'html/other/agreementConfirm.html');
            }

            var firstInstall=localStorage.get('isfirstInstall');
            if(!firstInstall){
                usageConfirm();
            }

            $scope.signIn = function () {
                if($scope.btnColor == '0'){
                    return;
                }
                $rootScope.buttonStatus = true;
                if (!validate.nullOrEmpty($rootScope.user.name) && validate.loginPassword($rootScope.user.password)) {
                    var logOff = localStorage.getObject('logOff');
                    if(!$scope.isAgreeApplyAgreement){
                        control.showConfirm7(function () {
                            $scope.isAgreeApplyAgreement = true;
                            $scope.signIn();
                        }, function () {},'同意并继续', '取消',  '', 'html/other/agreementConfirmV2.html');
                        return
                    }
                    var params = [$rootScope.user.name, $rootScope.user.password];
                    control.showLoading();
                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup("failFunc:"+error.msg, 2000);
                    };

                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }

                        if ('1' == logOff && '18324450217' == $rootScope.user.name) {
                            control.showPopup('此账号已被注销', 2000);
                            return;
                        }

                        switch (result.success) {
                            case true:
                                getBaseConfig();
                                $scope.$apply(function () {
                                    $rootScope.loginInfo = {
                                        accountId: result.value.accountId,
                                        mobile: result.value.mobile,
                                        userId: result.value.userUniqueId,
                                        token: result.value.token,
                                        idCard:result.value.idCard,
                                        userName:result.value.userName,
                                        realNameGrade:result.value.realNameGrade,
                                        //base64格式（实人认证使用）
                                        firstLoginDate: new Date().getTime()
                                    };
                                    localStorage.setObject('loginInfo', $rootScope.loginInfo);
                                    PushAgent.setAlias(function(){},result.value.userUniqueId,'userUniqueId')
                                    nav.navigate('tab/home');
                                });


                                //解决部分android手机登录报重定向的问题 保险起见 先观察一下线上用户机型问题在适配对应机型
                                // setTimeout(function(){
                                //      nav.navigate('tab/home');
                                // },1500);
                                break;
                            case false:
                                control.hideLoading();
                                control.showPopup(result.msg, 2000);
                                break;
                        }
                    };

                    nativeHelper.signIn({data: params, success: successFunc, fail: failFunc});
                }
                else {
                    control.showPopup('请输入正确的账号和密码', 2000);
                    return;
                }
            };

            $scope.doeyeclick = function () {
                $scope.isPwd = !$scope.isPwd;
            }

            $scope.navigate = function (state) {
                nav.navigate(state);
            };

            $rootScope.agreementClick = function(type) {
                if (type === 'appagreement') {
                    var url = window.currentUrl + '/app/api/appagreement';
                } else if(type == 'appprivacy'){
                    var url = window.currentUrl + '/app/api/appprivacy';
                }else{
                    var url = window.currentUrl + '/app/third-party-information-sharing.html';
                }

                var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                cordova.InAppBrowser.open(url, '_blank', operation);
            }

            $scope.agreement = function(type) {
                if (type === 'appagreement') {
                    var url = window.currentUrl + '/app/api/appagreement';
                } else {
                    var url = window.currentUrl + '/app/api/appprivacy';
                }

                var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                cordova.InAppBrowser.open(url, '_blank', operation);
            }

            $scope.isBlur = true;
            $scope.btnColor = '0';
            $scope.getBlur = function(id) {
                $scope.isBlur = true;
                var ele = document.getElementById(id);
                ele.className = ele.className.replace(' border-red','')
                ele.className = ele.className.replace('border-red',' ');

                if('' != $rootScope.user.tel && '' != $rootScope.user.password){
                    $scope.btnColor = '1';
                }else{
                    $scope.btnColor = '0';
                }

                //软键盘遮挡问题
                if(cordova.platformId === 'ios' && 'input-password' == id){
                    var curPageBody = document.getElementById('login');
                    curPageBody.className = ele.className.replace(' unmt-110','');
                    curPageBody.className +=  " mt-0";
                }
            }
            $scope.getFocus = function(id) {
                $scope.isBlur = false;

                var ele = document.getElementById(id);
                ele.className +=  " border-red";

                //软键盘遮挡问题
                if(cordova.platformId === 'ios' && 'input-password' == id){
                    var curPageBody = document.getElementById('login');
                    curPageBody.className +=  " unmt-110";
                }
            }

             $scope.eyeStatus = 'password';
             $scope.eyeClick = function(){
              if($scope.eyeStatus == 'password'){
               $scope.eyeStatus = 'text';
              }else{
               $scope.eyeStatus = 'password';
              }
             }


            var pwdHidden = true;
                $scope.pwdIconClick = function() {
                if (pwdHidden) {
                      let input = document.getElementById("login-pwdinput");
                      input.setAttribute("type", "text");
                      let icon = document.getElementById("login-pwdicon");
                      icon.setAttribute("class", "pwd-show-icon");
                } else {
                      let input = document.getElementById("login-pwdinput");
                      input.setAttribute("type", "password");
                      let icon = document.getElementById("login-pwdicon");
                      icon.setAttribute("class", "pwd-hide-icon");
                }
                pwdHidden = !pwdHidden;
            }

            $scope.isAgreeApplyAgreement=false;
            $scope.agree=function(){
                $scope.isAgreeApplyAgreement=!$scope.isAgreeApplyAgreement;
            }
        }]);
})();
