﻿(function () {
    "use strict"

    angular.module('starter')
    .controller('signUp', ['$rootScope', '$scope', '$ionicLoading', 'nav', 'nativeHelper', 'control', 'validate', '$filter', function ($rootScope, $scope, $ionicLoading, nav, nativeHelper, control, validate, $filter) {
        $scope.signUpInfo = {
            tel: '',
            authCode: '',
            password: '',
            verifyPassword: ''
        };

        $scope.erroTel = '0'
        $scope.erroCode = '0'
        $scope.erroPassword = '0'
        $scope.erroVerifyPassword = '0'
        $scope.btnColor = '0';
        $scope.showBtn = true;
        $scope.getBlur = function(id) {
            $scope.showBtn = true;
            var ele = document.getElementById(id);
            ele.className = ele.className.replace(' border-red','');
            ele.className = ele.className.replace('border-red',' ');

            if('' != $scope.signUpInfo.tel && '' != $scope.signUpInfo.authCode && '' != $scope.signUpInfo.password && '' != $scope.signUpInfo.verifyPassword){
                $scope.btnColor = '1';
            }else{
                $scope.btnColor = '0';
            }

            if('input-tel' == id){
                if (!validate.mobile($scope.signUpInfo.tel)) {
                    $scope.erroTel = '1';
                }else{
                    $scope.erroTel = '0';
                }
            }

            if('input-code' == id){
                if (validate.nullOrEmpty($scope.signUpInfo.authCode)) {
                    $scope.erroCode = '1';
                }else{
                    $scope.erroCode = '0';
                }
            }

            if('input-password' == id){
                if (!validate.loginPasswordReg($scope.signUpInfo.password)) {
                    $scope.erroPassword = '1';
                }else{
                    $scope.erroPassword = '0';
                }
            }

            if('input-comfirm' == id){
                if (!validate.loginPasswordReg($scope.signUpInfo.verifyPassword)) {
                    $scope.erroVerifyPassword = '1';
                }else{
                    $scope.erroVerifyPassword = '0';
                }
            }
        }

        $scope.getFocus = function(id){
            $scope.showBtn = false;
            var ele = document.getElementById(id);
            ele.className +=  " border-red";
        }

        $scope.signUp = function () {
            if($scope.btnColor == '0'){
                return;
            }
            if (validate.nullOrEmpty($scope.signUpInfo.tel) || validate.nullOrEmpty($scope.signUpInfo.authCode)) {
                control.showPopup('请输入手机号、验证码', 3000);
                return;
            }

            if (validate.loginPasswordReg($scope.signUpInfo.verifyPassword)) {
            // if (validate.loginPassword($scope.signUpInfo.verifyPassword)) {
                if ($scope.signUpInfo.password === $scope.signUpInfo.verifyPassword) {
                    if(!$scope.isAgreeApplyAgreement){
                        control.showPopup("请先阅读协议并同意", 2000);
                    return
                    }
                    control.showLoading();
                    var params = [$scope.signUpInfo.tel, $scope.signUpInfo.password, $scope.signUpInfo.authCode, '1'];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 3000);
                            return;
                        }
                        switch (result.success) {
                            case true:
                                control.showPopup('注册成功', 2000);
                                nav.navigate('signIn');
                                break;
                            case false:
                                control.showPopup(result.msg, 3000);
                                break;
                        }
                    }

                    var failFunc = function (error) {
                        control.hideLoading();
                    };

                    nativeHelper.signUp({ data: params, success: successFunc, fail: failFunc });
                }
                else {
                    $rootScope.buttonStatus = false;
                    control.showPopup('您输入的两次密码不相同', 3000);
                }
            }else {
                $rootScope.buttonStatus = false;
                // control.showPopup('密码为6-16位字符。可使用字母、数字和符号任意组合', 2000);
                control.showPopup('8-32位字符，至少包含数字、大小写字母及特殊符号中的三种', 2000);
            }
        }

        $scope.navigate = function (state) {
            nav.navigate(state);
        };

         $scope.isAgreeApplyAgreement=false;
            $scope.agree=function(){
            $scope.isAgreeApplyAgreement=!$scope.isAgreeApplyAgreement;
         }


    }]);
})();