﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('annualFeeInvoice', ['$rootScope', '$scope', 'nav'
            , 'control', 'nativeHelper', '$state','validate', function ($rootScope, $scope, nav, control,
                nativeHelper, $state,validate) {
                // 续费 确认发票
                $scope.invoice = {
                    header: $rootScope.certAnnualFeeInfo.entName.replace(/\(副本.*?\)/g,''),
                    taxNo: $rootScope.certAnnualFeeInfo.uniscid,
                    email: ''
                }

                $scope.certInfo = {
                    entName: $rootScope.certAnnualFeeInfo.entName.replace(/\(副本.*?\)/g,''),
                    uniscid: $rootScope.certAnnualFeeInfo.uniscid,
                    type: "证书年费"
                }

                $scope.$watch('invoice.header', function(newValue, oldValue) {
                    //当value改变时执行的代码
                    $scope.invoice.header = newValue
                    if(newValue==''){
                        $scope.invoice.taxNo = ''
                    }
                });

                $scope.$watch('invoice.taxNo', function(newValue, oldValue) {
                    $scope.invoice.taxNo = newValue
                    if(newValue==''){
                        $scope.invoice.header = ''
                    }
                });

                //生成年费业务单
                $scope.confirmInvoice = function (header, taxNo,email) {
                    if (header == '') {
                        control.showPopup("发票抬头不能为空", 2000);
                        return;
                    }
                    if (taxNo == '') {
                        control.showPopup("统一信用代码不能为空", 2000);
                        return;
                    }
                    if (email != ''&& !validate.email(email)) {
                        control.showPopup("邮箱名称格式不符,请确认邮箱名称是否正确", 2000);
                        return;
                    }
                    control.showLoading();
                    var params = [$rootScope.certAnnualFeeInfo.operator,
                    $rootScope.certAnnualFeeInfo.operatorid,
                    $rootScope.loginInfo.mobile,
                    $rootScope.loginInfo.accountId,
                    $rootScope.certAnnualFeeInfo.corpid,
                    $rootScope.certAnnualFeeInfo.count,
                        header,
                        taxNo,
                        email];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }
                        if (result.success) {
                            var item = {
                                orderNo: result.value.orderNo, payType: result.value.payType, allFee: result.value.allFee,
                                entName: $scope.invoice.header
                            };
                            $state.go('annualOrderDetails', { orderInfo: item });
                        }
                        if (!result.success) {
                            control.showPopup(result.msg, 2000);
                        }
                    }

                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                    };
                    nativeHelper.doSaveAnnualFeeNetOrderInfo({ data: params, success: successFunc, fail: failFunc });
                }
                $scope.showBtn=true
                $scope.getBlur=function(){
                    $scope.showBtn=true;
                }
                $scope.getFocus=function(){
                    $scope.showBtn=false;
                }

                $scope.navigate = function (state) {
                    nav.navigate(state);
                };
            }]);
})();