﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('annualOrderDetails', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', '$stateParams','$state','verifyIdentity',
            function ($rootScope, $scope, nav, control, nativeHelper, $stateParams, $state,verifyIdentity) {
                control.hideLoading();

                // 续费 支付订单
                // 获取订单号
                $scope.orderInfo = $stateParams.orderInfo;

                //支付订单
                $scope.paymentOrder = function () {
                    control.showLoading();
                    /**
                     * userId	用户ID
                     * categoryBh	类目编号
                     * type	类型   1：新领费用；2：年费
                     * 
                     * */
                    var params = [$rootScope.loginInfo.accountId,
                        $scope.orderInfo.orderNo];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }
                        if (result.resultStatus == 9000) {
                            if($rootScope.certAnnualFeeInfo.parentPage == "ableMakeUpCertInfoV2"||$rootScope.certAnnualFeeInfo.parentPage == "ableApplyCertInfoV2"){
                                // 支付成功后 设置免费
                                if($rootScope.applyCertType==2){
                                    doSaveNoAuthNetOrderInfo();
                                }else if( $rootScope.certAnnualFeeInfo.isUploadMaterials){
                                   	nav.navigate('userNotice');
                                }else{
                                    checkIdentityType();
                                }
                            }else{
                                $state.go('annualPaymentSuccess');
                            }
                        }
                        if (result.resultStatus != 9000) {
                            if (cordova.platformId === 'android') {
                                control.showPopup('支付失败：' + result.resultMsg, 2000);
                            }else
                            control.showPopup('支付失败：' + result.resultStatus, 2000);
                        }
                    }

                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup(error.memo, 2000);
                    };

                    nativeHelper.paymentOrder({ data: params, success: successFunc, fail: failFunc });
                }

                var payCallback = function (e) {
                    control.hideLoading();
                    if (e.resultStatus == 9000) {
                        if($rootScope.certAnnualFeeInfo.parentPage == "ableMakeUpCertInfoV2"||$rootScope.certAnnualFeeInfo.parentPage == "ableApplyCertInfoV2"){
                            if($rootScope.applyCertType==2){
                                doSaveNoAuthNetOrderInfo();
                            }else if( $rootScope.certAnnualFeeInfo.isUploadMaterials){
                               	nav.navigate('userNotice');
                            }else{
                                checkIdentityType();
                            }
                        }else{
                            $state.go('annualPaymentSuccess', { orderNo: $scope.orderInfo.orderNo });
                        }

                    }
                    if (e.resultStatus != 9000) {
                        control.showPopup(e.memo + e.resultStatus, 2000);
                    }
                };

                window.broadcaster.addEventListener("payCallback", payCallback);

                var hideLoading = function (e) {
                    control.hideLoading();
                };

                window.broadcaster.addEventListener("hideLoading", hideLoading);

                //检查经办人身份类型
                var checkIdentityType=function(){
                    $rootScope.certUnderwayInfo.isFree = true;
                    verifyIdentity.checkIdentity($rootScope.searchResult.uniscid,$rootScope.loginInfo.idCard,'2',checkIdentityTypeRes);
                }
                var checkIdentityTypeRes = function(result) {

                	if (result.rslt == 'success') {
                		$rootScope.certUnderwayInfo.systemTime = result.systemTime;
                		$rootScope.certUnderwayInfo.identityType = result.identityType; //0法定代表人1管理员2经办人
                		$rootScope.certUnderwayInfo.identityId = result.identityId;
                		// 0 正常申领  1.申领短信验证返回  2.申领短信验证通过  3.正常授权 4.授权短信验证返回  5.授权短信验证通过
                        $rootScope.verifyCodeType = '0';
                		nav.navigate('chooseIdentity');
                	}
                	if (result.rslt == 'fail') {
                		$scope.$apply(function() {
                			if ("ERROR_027" == result.errorCode) {
                				//表示法定代表人身份证无法通过校验
                				control.showCustomAlert3('知道了', 'check-information');
                				return;
                			}
                			if ("ERROR_028" == result.errorCode) {
                				//法人身份与主体法人不符
                				control.showCustomAlert4('知道了', 'check-information');
                				return;
                			}
                			if ("ERROR_029" == result.errorCode) {
                				//法定代表人身份证不属于中国大陆
                				nav.navigate('userNotice');
                				return;
                			}
                			if ("ERROR_038" == result.errorCode) {
                				nav.navigate('userNotice');
                				return;
                			}
                			if ("ERROR_023" == result.errorCode) {
                				nav.navigate('userNotice');
                				return;
                			}

                			control.showPopup(result.errorMsg, 2000);
                		});
                	}
                }

                 // 续费完 邮寄领证生成免费业务单
                 var doSaveNoAuthNetOrderInfo = function() {
                 	control.showLoading();
                 	var params = [
                 		$rootScope.loginInfo.mobile,
                 		$rootScope.loginInfo.accountId,
                 		$rootScope.certUnderwayInfo.categoryBh,
                 		$rootScope.certUnderwayInfo.businessCode,
                 		'5',
                 		$rootScope.certUnderwayInfo.netType,
                 		$rootScope.certUnderwayInfo.entName,
                 		$rootScope.certUnderwayInfo.uniscid,
                 		$rootScope.certUnderwayInfo.corpid,
                 		'0', //是否通过ocr校验0：不通过，1：已通过
                 		'1', //人脸识别是否通过状态：0通过，1不通过
                 		$rootScope.loginInfo.userName ? $rootScope.loginInfo.userName : '',
                 		$rootScope.loginInfo.idCard ? $rootScope.loginInfo.idCard : ''
                 	];
                 	console.log("doSaveNoAuthNetOrderInfo info:" + JSON.stringify(params));

                 	var successFunc = function(result) {
                 		control.hideLoading();
                 		if (result == null || angular.equals({}, result)) {
                 			control.showPopup('服务出错啦', 2000);
                 			return;
                 		}
                 		if (result.success) {
                 			//订单号
                 			$scope.$apply(function() {
                 				$rootScope.curAutoApplyOrderNo = result.value.orderNo;
                 				$state.go('postIntroduction', {
                 					orderNo: result.value.orderNo
                 				});
                 			});
                 		} else {
                 			control.showPopup(result.msg, 2000);
                 		}
                 	}
                 	var failFunc = function(result) {
                 		control.hideLoading();
                 		control.showPopup(result.msg, 2000);
                 	};
                 	nativeHelper.doSaveNoAuthNetOrderInfo({
                 		data: params,
                 		success: successFunc,
                 		fail: failFunc
                 	});
                 };

                $scope.navigate = function (state) {
                    nav.navigate(state);
                };

            }]);
})();
