(function() {
    "use strict"
    angular.module('starter')
    .controller('authenticationInfo', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', 'verifyIdentity', '$state', 'validate','localStorage',
    function($rootScope, $scope, nav, control, nativeHelper, verifyIdentity, $state, validate,localStorage) {

//        $rootScope.authentication = {
//            name:'',
//            card:''
//        };
//        //实人检测错误提示
        var detectionError = function(resultMsg) {
            control.showPopup(resultMsg, 2000);
        }

        var authLivingFailEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "活体识别失败";
            MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
        }

        //开启活体静默检测
        var startLiveDetection = function() {
            var eventCounter = new Object();
            eventCounter.page = "活体检测-实名认证";
            MobclickAgent.onEventWithParameters("authLivingRealNameEvent", eventCounter);
            verifyIdentity.startLiveDetection($rootScope.authentication.name, $rootScope.authentication.card, $rootScope.loginInfo.userId,liveDetectionResult);
        };
        
        //人脸识别结果
        var liveDetectionResult = function(res) {
            $scope.$apply(function() {
                $scope.alert_applicant_info=false;
                if (res.rslt == 'success') {
                    if (res.data.result == 'success') {
                        $rootScope.isIdentityAuth = false;
                        $rootScope.loginInfo.idCard=$rootScope.authentication.card;
                        $rootScope.loginInfo.realNameGrade='1';
                        $rootScope.loginInfo.userName=$rootScope.authentication.name;
                        localStorage.setObject('loginInfo', $rootScope.loginInfo);
                        control.showPopup("实名认证成功", 2000);
                        $state.go('authenticationResult', {
                            isAuthSuccess: true
                        });
                        $rootScope.setAuthSuccessTime()
                    }else{
                        if (res.data.authResult == '5XXX' || res.data.authResult == '6XXX') {
                            if(!$rootScope.isIdentityAuth){
                                $state.go('authenticationResult', {
                                    isAuthSuccess: false
                                });
                                detectionError('姓名或身份证号码有误，错误代码'+res.data.authResult);
                            }else if(!$rootScope.isOpenFaceAuthFail()){
                                detectionError('姓名或身份证号码有误，错误代码'+res.data.authResult);
                            }
                            return;
                        } else if(res.data.authResult == '01XX' || res.data.authResult == '02XX' || res.data.authResult == '02XX'){
                            if(!$rootScope.isIdentityAuth){
                                $state.go('authenticationResult', {
                                    isAuthSuccess: false
                                });
                                detectionError('人脸比对失败，错误代码'+res.data.authResult);
                            }else if(!$rootScope.isOpenFaceAuthFail()){
                                detectionError('人脸比对失败，错误代码'+res.data.authResult);
                            }
                            return;
                        } else {
                            if(!$rootScope.isIdentityAuth){
                                $state.go('authenticationResult', {
                                    isAuthSuccess: false
                                });
                                control.showPopup(res.data.authResultMsg, 2000);
                            } else if(!$rootScope.isOpenFaceAuthFail()){
                                control.showPopup(res.data.authResultMsg, 2000);
                            }
                        }
                    }
                }else{
                    authLivingFailEvent();
                    $state.go('authenticationResult', {
                        isAuthSuccess: false
                    });
                    control.showPopup(res.errorMsg, 2000);
                }
            });
        };
        $scope.mailingMaterialsClick =  function(){
             $rootScope.mailApply();
        }
        // 判断字符串是否全是中文
        function isAllChinese(str) {
            //V2.9.2 新增适配新疆身份证名称带符号
            return /^[\u4E00-\u9FA5]+$/.test(str) || /^[\u4e00-\u9fa5]+·[\u4e00-\u9fa5]+$/.test(str)
        }
        //经办人身份信息和授权信息核验
        $scope.startAuthentication = function() {
            if (validate.nullOrEmpty($rootScope.authentication.name)) {
                return;
            }
            if (validate.nullOrEmpty($rootScope.authentication.card)) {
                return;
            }
            if (!isAllChinese($rootScope.authentication.name)) {
                control.showPopup('仅支持中文姓名，若您为海外用户请点击「邮寄材料申领证书」', 2000);
                return;
            }
            if ($rootScope.authentication.card.length!=15&&$rootScope.authentication.card.length!=18) {
                   control.showPopup('身份证号码格式错误，请重新输入', 2000);
                   return;
            }
            $scope.acShowAuthConfirm = true;
        };

        // 人脸再试一次
        $scope.faceAuthTryAgain = function(){
            $scope.acShowAuthConfirm = true;
            $rootScope.closeFaceAuthFail();
        }
        $scope.acShowAuthConfirm = false;
        $scope.acCloseClick = function() {
            $scope.acShowAuthConfirm = false;
        }

        $scope.acIsAgreeApplyAgreement = false;
        $scope.acAgree = function() {
            $scope.acIsAgreeApplyAgreement = !$scope.acIsAgreeApplyAgreement;
        }
        $scope.acAgreement = function() {
            var url = window.currentUrl + '/app/ezt/faceAgreement.html';
            var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
            cordova.InAppBrowser.open(url, '_blank', operation);
        }
        $scope.acNext = function() {
            if (!$scope.acIsAgreeApplyAgreement) {
                control.showPopup("请确认同意《人脸认证功能协议》", 2000);
                return;
            }
            $scope.acShowAuthConfirm = false;
            startLiveDetection();
        }



        $scope.navigate = function(state) {
            nav.navigate(state);
        };
    }]);
})();
