(function() {
    "use strict"
    angular.module('starter')
    .controller('authorizationBook', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', '$stateParams','$state','validate','verifyIdentity',
    function($rootScope, $scope, nav, control, nativeHelper, $stateParams,$state,validate,verifyIdentity) {
        screen.orientation.unlock();
        screen.orientation.lock('portrait');
        var approvalDetail=$stateParams.authorizationDetail;
        $scope.countDown = -1;

        function intervalBySigning(){
            $scope.$apply(function () {
                $scope.countDown--
            })
            if($scope.countDown==0){
                clearInterval($scope.setIntervalBySigning);
            }
        }

        // 确定签署
        $scope.confirmSigning = function() {
            if($scope.countDown>0){
                return
            }
            if($rootScope.isAuthFace()){
                $scope.alert_applicant_info = true;
            }else{
                $state.go('signatureAuthorization',{'authorizationDetail':approvalDetail});
                if (cordova.platformId === 'ios') {
                    nativeHelper.setOrientation({ data: ['LandscapeRight'], success: null, fail: null });
                }
            }
            if($rootScope.applyCertType == 0){
                var eventCounter = new Object();
                eventCounter.page = "证书申领-签署授权书页面-确认签署";
                MobclickAgent.onEventWithParameters("applySignAuthorizationEvent", eventCounter);
            }else if($rootScope.applyCertType == 1){
                var eventCounter = new Object();
                eventCounter.page = "证书补办-签署授权书页面-确认签署";
                MobclickAgent.onEventWithParameters("makeUpSignAuthorizationEvent", eventCounter);
            }
        }


         $scope.bookPicList = [];
        //  授权书预览
        var doAuthorizeBook = function() {

        	control.showLoading();
        	var params = [
        	    approvalDetail.name,
        	    approvalDetail.cert,
        	    approvalDetail.mobile,
        	    approvalDetail.uniscid,
        	    $rootScope.curAuthCode,
        	    approvalDetail.startTime + ' 00:00:00',
        	    approvalDetail.endTime + '23:59:59',
        	    {
                     'certName': approvalDetail.certName,
                     'categoryBh': approvalDetail.categoryBh,
                     'netType': approvalDetail.netType,
                     'corpid': approvalDetail.corpid,
                     'businessType':approvalDetail.businessType,
                }
            ];
        	var successFunc = function(result) {
        		control.hideLoading();
        		if (result == null || angular.equals({},
        		result)) {
        			control.showPopup('服务出错啦', 2000);
        			return;
        		}

        	    if (result.rslt == 'success') {
        	        $scope.countDown = 5;
                    $scope.setIntervalBySigning = setInterval(() => {
                        intervalBySigning()
                    }, 1000);
        			$scope.bookPicList = result.data
        		}
        		if (result.rslt == 'fail') {
        			control.showPopup(result.msg, 2000);
        		}
        	}

        	var failFunc = function(result) {
        		control.hideLoading();
        		control.showPopup(result.msg, 2000);
        	};

        	nativeHelper.doAuthorizeBook({
        		data: params,
        		success: successFunc,
        		fail: failFunc
        	});
        }

        doAuthorizeBook();
        // 采集人脸提示
        $scope.alert_applicant_info = false;
        $scope.closeApplicantInfoAlert = function () {
            $scope.alert_applicant_info = false;
        }

        // 开始活体检测
        $scope.startBiopsy = function () {
            $scope.acShowAuthConfirm = true;
            $scope.alert_applicant_info = false;
        }
        $scope.acShowAuthConfirm = false;
        $scope.acCloseClick = function() {
        	$scope.acShowAuthConfirm = false;
        }
        // 人脸再试一次
        $scope.faceAuthTryAgain = function(){
            $scope.acShowAuthConfirm = true;
            $rootScope.closeFaceAuthFail();
        }
        $scope.acIsAgreeApplyAgreement = false;
        $scope.acAgree = function() {
        	$scope.acIsAgreeApplyAgreement = !$scope.acIsAgreeApplyAgreement;
        }
        $scope.acAgreement = function() {
        	var url = window.currentUrl + '/app/ezt/faceAgreement.html';
        	var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
        	cordova.InAppBrowser.open(url, '_blank', operation);
        }

        $scope.acNext = function() {
        	if (!$scope.acIsAgreeApplyAgreement) {
        		control.showPopup("请确认同意《人脸认证功能协议》", 2000);
        		return;
        	}
        	$scope.acShowAuthConfirm = false;
        	var eventCounter = new Object();
        	eventCounter.page = "活体检测-签署授权书";
        	MobclickAgent.onEventWithParameters("authLivingAuthorizationRecordEvent", eventCounter);
        	verifyIdentity.startLiveDetection($rootScope.loginInfo.userName, $rootScope.loginInfo.idCard, $rootScope.loginInfo.userId,liveDetectionResult);
        }
        //人脸识别结果监听
        var liveDetectionResult = function(res) {
            $scope.$apply(function() {
                $scope.alert_applicant_info=false;
                 if (res.rslt == 'success') {
                     if (res.data.result == 'success') {
                        $rootScope.setAuthSuccessTime();
                        $state.go('signatureAuthorization',{'authorizationDetail':approvalDetail});
                        if (cordova.platformId === 'ios') {
                            nativeHelper.setOrientation({ data: ['LandscapeRight'], success: null, fail: null });
                        }
                     }else{
                        if (res.data.authResult == '5XXX' || res.data.authResult == '6XXX') {
                            if(!$rootScope.isOpenFaceAuthFail()){
                                detectionError('姓名或身份证号码有误，错误代码' + res.data.authResult);
                            }
                             return;
                        } else if(res.data.authResult == '01XX' || res.data.authResult == '02XX' || res.data.authResult == '02XX'){
                             if(!$rootScope.isOpenFaceAuthFail()){
                                 detectionError('人脸比对失败，错误代码' + res.data.authResult);
                             }
                             return;
                        } else {
                             if(!$rootScope.isOpenFaceAuthFail()){
                                control.showPopup(res.data.authResultMsg, 2000);
                             }
                        }
                     }
                 }else{
                    authLivingFailEvent();
                    control.showPopup(res.errorMsg, 2000);
                 }
            });

        };

        var authLivingFailEvent = function() {
        	var eventCounter = new Object();
        	eventCounter.page = "活体识别失败";
        	MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
        }
        //实人检测错误提示
        var detectionError = function(resultMsg) {
        	control.showPopup(resultMsg, 2000);
        }
        $scope.backBtn = function(){
            try{
                if($scope.countDown!=0){
                    clearInterval($scope.setIntervalBySigning);
                }
            }catch(e){}

            $rootScope.goBackV2()
        }

        $scope.navigate = function(state) {
            nav.navigate(state);
        };
    }]);
})();
