(function () {
    "use strict"
    angular.module('starter')
        .controller('authorizationRecord', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', '$state', '$stateParams', 'verifyIdentity', '$filter', 'utility', 'md5', 'requestWrapper', 'localStorage','validate',
            function ($rootScope, $scope, nav, control, nativeHelper, $state, $stateParams, verifyIdentity, $filter, utility, md5, requestWrapper, localStorage,validate) {
                    $rootScope.curAuthCode = '20191016172831442090';
                    screen.orientation.unlock();
                    screen.orientation.lock('portrait');
                    var pageNum = 1;//页码
                    var pageSize = 5;
                    $scope.can_loadmore = true;
                    $scope.isloadmore = false;// 没有更多了
                    $scope.isloading = true;
                    $scope.keyword = '';


                    if ($stateParams.authStatus != "") {
                        $rootScope.recordType = $stateParams.authStatus;
                    }

                    var authRecordListRes = function (result) {
                        if (result == null || angular.equals({},result)) {
                            control.showPopup('服务出错啦', 3000);
                        }
                        if (result.success) {
                            $scope.isloading = false;
                            $scope.can_loadmore = true;
                            $scope.recordsTotal = result.value.total;
                            if(pageNum==1){
                                $scope.recordLists = result.value.authRecordList;
                            }else{
                                $scope.recordLists = $scope.recordLists.concat(result.value.authRecordList)
                            }
                       }
                       if (!result.success) {
                            if(pageNum>1){
                                pageNum--
                            }
                            $scope.can_loadmore = true;
                            control.showPopup(result.msg, 2000);
                       }
                    }

                    //授权记录,type 0:未授权，1：已授权
                    var getAuthRecordList = function (type) {
                        $scope.isloading = true;
                        if(pageNum==1){
                           $scope.$apply(function () {
                                $scope.recordLists = [];
                                window.scrollTop();
                           });
                        }
                        verifyIdentity.checkAuthorization($rootScope.loginInfo.idCard, type, $scope.keyword,pageNum,pageSize, authRecordListRes);
                    }

                    $("#searchKeyword").keypress(function(e){
                          // 搜索关键字
                         //var key = $.trim($(this).val());
                        //  console.log(e.keyCode);
                         if(cordova.platformId === 'ios'){
                            if(e.keyCode === 13) {
                                $scope.loadFirstPage()
                                cordova.plugins.Keyboard.close();
                            }

                            // if(e.keyCode === 104){
                            //     $scope.keyword = '';
                            //     cordova.plugins.Keyboard.close();
                            // }
                         }else{
                            if(e.keyCode === 13) {
                                $scope.loadFirstPage()
                           }
                           //关闭软键盘
                           cordova.plugins.Keyboard.close();
                         }
                    })
                    $scope.loadFirstPage = function () {
                        pageNum = 1;
                        if ($rootScope.loginInfo.realNameGrade == "1") {
                             getAuthRecordList($rootScope.recordType);
                        } else {
                             $rootScope.identityAuthRootPage = "authorizationRecord";
                             nav.go('authorizationFace');
                        }
                    }
                    $scope.loadFirstPage();

                    $scope.getAuthRecordByType = function (status) {
                        pageNum = 1;
                        $rootScope.recordType = status;
                        getAuthRecordList(status);
                    }

                    //查看详情
                    $scope.recordDetails = function (item) {
                        $state.go('authorizationDetails', {
                            'authorizationDetail': item
                        });
                    }

                    //脱敏处理方法
                    function maskName(str) {
                        if (null != str && str != undefined) {
                            if (2 == str.length) {
                                return str.substring(0, 1) + '*'; //截取name 字符串截取第一个字符，
                            } else if (3 == str.length) {
                                return str.substring(0, 1) + "*" + str.substring(2, 3); //截取第一个和第三个字符
                            } else if (str.length > 3) {
                                return str.substring(0, 1) + "*" + '*' + str.substring(3, str.length); //截取第一个和大于第4个字符
                            }
                        } else {
                            return str;
                        }
                    }
                   //法人授权操作说明
                   $scope.helpExplain =function() {
                       utility.helpExplain(window.authorizationHelp,"法人授权操作说明","helpAuthorizationEvent");
                   };
                    // 生成授权领证业务单
                    var doNetOrderInfo = function (item) {
                        control.showLoading();

                        var params = [item.agenter, item.cert, $rootScope.loginInfo.mobile, $rootScope.loginInfo.accountId, item.extendDataJson.corpid, item.extendDataJson.categoryBh, item.extendDataJson.netType, {
                            'letter': item.letter,
                            'idCardFace': "data:image/png;base64," + photoData
                        },
                            'EPASSAPP', item.authId, '1'];
                        var successFunc = function (result) {
                            control.hideLoading();

                            if (result == null || angular.equals({},
                                result)) {
                                control.showPopup('服务出错啦', 2000);
                                return;
                            }

                            if (result.success) {
                                //0：法人 1:经办人
                                $state.go('downloadCert', {
                                    'downloadCertInfo': {
                                        'srcPage': 'authorizationRecord',
                                        'entName': item.unitName,
                                        'uniscid': item.uniscid,
                                        'orderNo': result.value.orderNo,
                                        'corpid': item.extendDataJson.corpid,
                                        'orderType': '1',
                                        'businessCode': item.extendDataJson.netType == '8' ? 'B03' : 'P012',
                                        'operatorId': item.cert,
                                    }
                                });
                            }
                            if (!result.success) {
                                if (result.hasOwnProperty('value')) {
                                    if (null != result.value && result.value.hasOwnProperty('busiHistoryDataJson')) {
                                        let resValueBusi = result.value.busiHistoryDataJson;
                                        if (resValueBusi) {
                                            // 判断是否为同一个人
                                            if (resValueBusi.proxIdNo == $rootScope.loginInfo.idCard) {
                                                if (false == resValueBusi.isDown) {
                                                    // 未下载跳转业务管理
                                                    $state.go('businessManage', {
                                                        businessManageSearchKey: item.uniscid
                                                    });
                                                } else {
                                                    // 已下载提示信息
                                                    control.showPopup('您已下载该证书，请至【首页-我的证书】中查看', 2000);
                                                }

                                            } else {
                                                // 姓名脱敏
                                                var secName = resValueBusi.proxName;
                                                if (resValueBusi.proxName.length > 1) {
                                                    secName = maskName(secName);
                                                }

                                                control.showPopup('证书已被其他用户（' + secName + '）申领下载，同一张证书同时只能一名用户使用  ', 2000);
                                            }
                                            return;
                                        }
                                    }
                                }

                                control.showPopup(result.msg, 2000);
                            }
                        }
                        var failFunc = function (error) {
                            control.hideLoading();
                            control.showPopup(error.msg, 2000);
                        };

                        nativeHelper.doSaveAuthNetOrderInfo({
                            data: params,
                            success: successFunc,
                            fail: failFunc
                        });
                    }

                    //实人检测错误提示
                    var detectionError = function (resultMsg) {
                         control.showPopup(resultMsg, 2000);
                    }
                    //采集人脸提示
                    $scope.alert_applicant_info = false;
                    $scope.closeApplicantInfoAlert = function () {
                        $scope.alert_applicant_info = false;
                    }
                    //记录刷脸次数
                    var liveDetectionNum = 0;

                    //点击同意授权
                    var isAuth = false;

                    //开始活体检测
                    $scope.startBiopsy = function () {
                        $scope.acShowAuthConfirm = true;
                        $scope.alert_applicant_info = false;
                    }
                    // 人脸再试一次
                    $scope.faceAuthTryAgain = function(){
                        $scope.acShowAuthConfirm = true;
                        $rootScope.closeFaceAuthFail();
                    }
                    var authLivingFailEvent = function () {
                        var eventCounter = new Object();
                        eventCounter.page = "活体识别失败";
                        MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
                    }

                    var photoData;
                    //人脸识别结果监听
                    var liveDetectionResult = function (res) {
                        $scope.$apply(function () {
                            if (res.rslt == 'success') {
                               IdentityAuthenticationRes(res.data)
                            }else{
                               authLivingFailEvent();
                               detectionError(res.resultMsg);
                            }
                        });
                    };

                    //人脸信息和身份信息对比结果
                    var IdentityAuthenticationRes = function (data) {

    //                    $scope.$apply(function () {
                            if (data.result == 'fail') {

                                if (data.authResult == '5XXX' || data.authResult == '6XXX') {
                                    if(!$rootScope.isOpenFaceAuthFail()){
                                        detectionError('姓名或身份证号码有误，错误代码' + data.authResult);
                                    }
                                    return;
                                } else if (data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '02XX') {
                                    if(!$rootScope.isOpenFaceAuthFail()){
                                        detectionError('人脸比对失败，错误代码' + data.authResult);
                                    }
                                    return;
                                } else {
                                   if(!$rootScope.isOpenFaceAuthFail()){
                                        control.showPopup(data.authResultMsg, 2000);
                                   }
                                }
                            }
                            if (data.result == 'success') {
                                $rootScope.setAuthSuccessTime();
                                getFeeInfo();
                                //生成业务单
                                // doNetOrderInfo(authorizationItemInfo);
                            }
    //                    });
                    }

                    // 付费提醒
                    var paymentApply = function(item) {
                        $rootScope.paymentWay = '1'// 经办人下载
                        $scope.okFunc = function() {
                            var operatorType;
                            switch (item.identityType) {
                            case '0':
                                operatorType = '0'
                                break;
                            case '1':
                                operatorType = '2';
                                break;
                            case '2':
                                operatorType = '1';
                                break;
                            }
                            $state.go('confirmCertInvoice', {
                                'netOrderInfoWithInvoice': {
                                    'entName': item.unitName,
                                    'uniscid': item.uniscid,
                                    'agenter': $rootScope.loginInfo.userName,
                                    'cert': item.cert,
                                    //'mobile': item.mobile,
                                    //v2.9.7 经办人手机号使用登录人的手机号
                                    'mobile': $rootScope.loginInfo.mobile,
                                    'corpid': item.extendDataJson.corpid,
                                    'categoryBh': item.extendDataJson.categoryBh,
                                    'netType': item.extendDataJson.netType,
                                    'letter': item.letter,
                                    'idCardFace': '',
                                    'authId': item.authId,
                                    'operatorType': operatorType,
                                    'orderType': '1',
                                    'businessCode': item.extendDataJson.netType == '8' ? 'B03': 'P012',
                                }
                            });
                            $scope.showTimeConfirm = false;
                        }
                        $scope.cancelClick2 = function() {
                                        $scope.showTimeConfirm = false;
                        }
                        $scope.showTimeConfirm = true;
                        return;
                    }


                    // 只处理年费 付费在paymentApply方法
                    var certFeeTip = function (item, type, btnLeft, fee) {
                        var tipContent = '';
                        var btnRight = '';
                        if (type == '年费') {
                            //tipContent = '证书年费<p>证书年费服务期已于' + item.endDate + '过期请先缴纳证书年费后再办理证书相关维护业务。<p>'
                            tipContent = '证书年费<p>证书年费服务期已于' + item.endDate + '过期,请先缴纳证书年费后再办理证书相关维护业务,证书使用年费'+item.fee+'元/张/年。<p>'
                            btnRight = "取消";
                        } else if (type == '子证书') {
                              paymentApply(item);
                              return;
    //                        var category = $filter('categoryType')(item.extendDataJson.categoryBh);
    //                        tipContent = '新领证书:<p>这是申领' + category + '，证书服务费用<span>' + fee + '元/年</span>，确定要申领请点“申领”。若是补办首张免费省法人证书请点“取消”后去补办省法人证书。</p > '
    //                        btnRight = "申领";
                        }

                        control.showConfirm(tipContent,

                            function () {
                                //生成业务单：经办人类型 0法定代表人 1经办人 2管理员
                                //授权记录："0法定代表人 1管理员 2经办人"
                                if (type == '子证书') {
                                    var operatorType;
                                    switch (item.identityType) {
                                        case '0':
                                            operatorType = '0'
                                            break;
                                        case '1':
                                            operatorType = '2';
                                            break;
                                        case '2':
                                            operatorType = '1';
                                            break;
                                    }

                                    $state.go('confirmCertInvoice', {
                                        'netOrderInfoWithInvoice': {
                                            'entName': item.unitName,
                                            'uniscid': item.uniscid,
                                            'agenter': $rootScope.loginInfo.userName,
                                            'cert': item.cert,
                                            //'mobile': item.mobile,
                                            //v2.9.7 经办人手机号使用登录人的手机号
                                            'mobile': $rootScope.loginInfo.mobile,
                                            'corpid': item.extendDataJson.corpid,
                                            'categoryBh': item.extendDataJson.categoryBh,
                                            'netType': item.extendDataJson.netType,
                                            'letter': item.letter,
                                            'idCardFace': '',
                                            'authId': item.authId,
                                            'operatorType': operatorType,
                                            'orderType': '1',
                                            'businessCode': item.extendDataJson.netType == '8' ? 'B03' : 'P012',
                                        }
                                    });
                                    return;
                                }
                            },

                            function () {

                                if (type == '年费') {
                                    //封装证书年费所需信息
                                    $rootScope.certAnnualFeeInfo = {
                                        entName: item.entName,
                                        uniscid: item.uniscid,
                                        categoryBh: item.extendDataJson.categoryBh,
                                        isFree: item.isFree,
                                        corpid: item.extendDataJson.corpid,
                                        businessCode: type,
                                        operator: item.agenter,
                                        operatorid: item.cert,
                                        parentPage: "authorizationRecord"
                                    }
                                    nav.navigate('confirmPayInfo');
                                    return;
                                }
                            },
                            btnLeft, btnRight, 'cusClass');
                    }


                    //下载证书--生成业务单
                    var authorizationItemInfo;


                    //下载证书
                    $scope.downloadCert = function (item) {
                        var eventCounter = new Object();
                        eventCounter.page = "业务管理-证书安装";
                        MobclickAgent.onEventWithParameters("businessManageCertInstallEvent", eventCounter);
                        control.showLoading();
                        if(validate.isStrEmpty(item.uniscid)){
                            createBusinessOrder(item);
                            return;
                        }
                        var params = [item.uniscid,'2',item.authId];
                        var successFunc = function (result) {
                            if(result.success){
                                 createBusinessOrder(item);
                            }else{
                                control.hideLoading();
                                control.showPopup(result.msg, 2000);
                                setTimeout(function () {
                                    pageNum = 1;
                                    pageSize = 5;
                                    getAuthRecordList($rootScope.recordType);
                                }, 2000);
                            }
                        }
                        var failFunc = function (e) {
                            control.hideLoading();
                            control.showPopup(e.msg, 2000);

                        };
                        nativeHelper.checkEntState({ data: params, success: successFunc, fail: failFunc });
                    }

                    var createBusinessOrder = function (item) {
                        control.showLoading();
                        authorizationItemInfo = item;

                        if ($rootScope.loginInfo.realNameGrade == "1") {
                            control.showLoading();
                            var time = utility.getCurrentTime();
                            var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
                            var params = {
                                'appid': $rootScope.appid,
                                'time': time,
                                'hashdata': hashdata,
                                'mobilePhone': $rootScope.loginInfo.mobile,
                                'idCard': $rootScope.loginInfo.idCard
                            }
                            requestWrapper.doGetMobileDeviceList({
                                data: params,
                                refresh: true
                            }).then(function(result2) {
                                control.hideLoading();
                                console.log("doGetMobileDeviceCount" + JSON.stringify(result2));
                                if (true == result2.success) {
                                    var deviceList = result2.value;
                                    var isTrustedDevice = false;
                                    for (let index in deviceList) {
                                        if (deviceList[index].keySerial == $rootScope.uuid) {
                                            isTrustedDevice = true;
                                            break;
                                        }
                                    }
                                    // 是否是信任设备
                                    if (isTrustedDevice) {
                                        //生物识别开关是否打开, 不同系统不同开关
                                        if (($rootScope.openBiometryAndroid == '1' && 'android' == cordova.platformId) || ($rootScope.openBiometryIOS == '1' && 'ios' == cordova.platformId)) {
                                            var authInfo = localStorage.getObject('authInfo' + $rootScope.loginInfo.accountId);
                                            var openVerify = authInfo.openVerify;
                                            //是否开启指纹
                                            if (JSON.stringify(authInfo) == '{}' || openVerify == '0') {

                                                // 密码校验
                                                $rootScope.pwdPopupFrom = 'authorizationRecord';
                                                control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopup.html');
                                                return;
                                            } else {
                                                // 用指纹/登录密码校验
                                                if ('0' != $rootScope.deviceAuthenticationType) {
                                                    // 如果指纹已打开且可用 用指纹校验
                                                    var successFunc = function(res) {
                                                        console.log('success - ' + JSON.stringify(res));
                                                        if (1 == res.code) {
    //                    									doNetOrderInfo(item);
                                                            getFeeInfo();
                                                        } else if (2 == res.code) {
                                                            //用户选择了取消
                                                            if (cordova.platformId === 'android' && $rootScope.deviceAuthenticationType === '1') {
                                                                //安卓面容验证点击取消出现密码验证
                                                                $rootScope.pwdPopupFrom = 'businessManage';
                                                                control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopup.html');
                                                            }
                                                            return;
                                                        } else if (3 == res.code) {
                                                            //连续失败5次，锁定
                                                            // control.showPopup('操作太频繁，需验证账号密码', 3000);
                                                            $rootScope.pwdPopupFrom = 'authorizationRecord';
                                                            control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopup.html');
                                                            return;
                                                        } else if (4 == res.code) {
                                                            //用户未录入指纹
                                                            // var msg = '你尚未设置设备指纹，请先在手机系统设置中录入指纹';
                                                            // if($rootScope.deviceAuthenticationType == '1'){
                                                            //     msg = '你尚未设置面容ID，请先在手机系统设置中录入面容';
                                                            // }
                                                            // control.showCustomAlert6(msg,'check-information');
                                                            $rootScope.pwdPopupFrom = 'authorizationRecord';
                                                            control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopup.html');
                                                            return;
                                                        } else if (5 == res.code) {
                                                            //连续错误3次
                                                            $rootScope.pwdPopupFrom = 'businessManage';
                                                            control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopup.html');
                                                            return;
                                                        } else {
                                                            //authorizationItemInfo = item;
                                                            // 密码校验
                                                            $rootScope.pwdPopupFrom = 'authorizationRecord';
                                                            control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopup.html');
                                                            return;
                                                        }

                                                    }
                                                    var failFunc = function(res) {
                                                        console.log('fail - ' + JSON.stringify(res));
                                                    }
                                                    nativeHelper.deviceAuthentication({
                                                        data: ['输入登录密码'],
                                                        success: successFunc,
                                                        fail: failFunc
                                                    });
                                                } else {
                                                    //authorizationItemInfo = item;
                                                    // 密码校验
                                                    $rootScope.pwdPopupFrom = 'authorizationRecord';
                                                    control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopup.html');
                                                    return;
                                                }
                                            }
                                        } else {
    //                    					doNetOrderInfo(item);
                                            getFeeInfo();
                                        }
                                    } else {
                                        // ctid认证流程
                                        authorizationItemInfo = item;
                                        if ($rootScope.isAuthFace()) {
                                            $scope.alert_applicant_info = true;
                                        } else {
                                            getFeeInfo();                                          //生成业务单
                                        }
                                    }
                                } else {
                                    control.showPopup(result2.msg, 2000);
                                }
                            });
                        } else {
                            $rootScope.identityAuthRootPage = "authorizationRecord";
                            nav.go('authorizationFace');
                        }

                    }

                    var getFeeInfo = function(){

                        var params = [authorizationItemInfo.extendDataJson.categoryBh, authorizationItemInfo.extendDataJson.corpid, authorizationItemInfo.extendDataJson.netType,];
                        var successFunc = function (result) {
                            control.hideLoading();

                            if (result == null || angular.equals({},
                                result)) {
                                control.showPopup('服务出错啦', 2000);
                                return;
                            }

                            if (result.success) {
                                if (!result.value.isFree) {
                                    $rootScope.certCharge = result.value.fee;
    //                                certFeeTip(authorizationItemInfo, '子证书', '取消', result.value.fee);
                                    paymentApply(authorizationItemInfo)
                                    return;
                                }
                                if (!result.value.inService) {
                                    item.endDate = result.endDate;
                                    item.fee = result.fee;
                                    certFeeTip(authorizationItemInfo, '年费', '缴费', result.value.fee);
                                } else {
                                    doNetOrderInfo(authorizationItemInfo)
                                }
                            }
                            if (!result.success) {
                                control.showPopup(result.msg, 2000);
                            }
                        }
                        var failFunc = function (error) {

                            control.hideLoading();
                            control.showPopup(error.msg, 2000);
                        };

                        nativeHelper.getFeeInfo({
                            data: params,
                            success: successFunc,
                            fail: failFunc
                        });
                    }
                    //        //同意授权
                    $scope.agreeAuthorization = function (item) {
                        $state.go('authenticationApproval', {
                            'authorizationDetail': {
                                'srcPage': 'authorizationRecord',
                                name: item.agenter,
                                cert: item.cert,
                                mobile: item.mobile,
                                'authId': item.authId,
                                identityId: item.identityId,
                                uniscid: item.uniscid,
                                startTime: item.startTime,
                                'certName': item.extendDataJson.certName,
                                'categoryBh': item.extendDataJson.categoryBh,
                                'netType': item.extendDataJson.netType,
                                'corpid': item.extendDataJson.corpid,
                            }
                        });
                    }
                    var selectedItem;
                    // 三要素校验
                    $scope.mobileCheck = function(item){
                        selectedItem = item;
                        $rootScope.selectedItem = item;
                        verifyIdentity.mobileCheck(item.extendDataJson.corpid,$rootScope.loginInfo.userName,
                            $rootScope.loginInfo.idCard,$rootScope.loginInfo.mobile,$rootScope.loginInfo.accountId,mobileCheckRes);
                    }

//                    $scope.isIdentityVerifyPop = false;
                    var mobileCheckRes = function(result){
                         console.log('mobileCheckRes - ' + JSON.stringify(result));
                         if (result.success) {
                            $scope.verifyResult = result.value.verifyResult
                            // 0.核验通过 1.三要素核验通过发短信 2.核验不通过 3.设备换过发短信 4.核验业务单待确认 5.无核验业务单
                            if ($scope.verifyResult == '0'){
                                   checkIsRepeatAuth();
                            } else if ($scope.verifyResult == '1'){
                                // 0 正常申领  1.申领短信验证返回  2.申领短信验证通过  3.正常授权 4.授权短信验证返回  5.授权短信验证通过
                                 $rootScope.verifyCodeType = '3';
                                 $rootScope.certUnderwayInfo = {
                                    entName: selectedItem.unitName,
                                    uniscid: selectedItem.uniscid,
                                    categoryBh: selectedItem.extendDataJson.categoryBh,
                                    corpid: selectedItem.extendDataJson.corpid,
                                    certName:selectedItem.extendDataJson.certName ,
                                 }
                                 nav.navigate('enterVerifyCode')
                            } else if ($scope.verifyResult == '2'){
                                  $scope.verifyMsg = result.value.verifyMsg+"您也可通知经办人通过材料领证";
                                  $scope.isShowNotVerifyMobilePop = true;
                            } else if ($scope.verifyResult == '3'){
                                // 0 正常申领  1.申领短信验证返回  2.申领短信验证通过  3.正常授权 4.授权短信验证返回  5.授权短信验证通过
                                 $rootScope.verifyCodeType = '3';
                                 $rootScope.certUnderwayInfo = {
                                    entName: selectedItem.unitName,
                                    uniscid: selectedItem.uniscid,
                                    categoryBh: selectedItem.extendDataJson.categoryBh,
                                    corpid: selectedItem.extendDataJson.corpid,
                                    certName:selectedItem.extendDataJson.certName ,
                                 }
                                 nav.navigate('enterVerifyCode')
                            } else if ($scope.verifyResult == '4'){ // 核验业务单待确认
                                 $scope.identityVerifyClick();
                            } else if ($scope.verifyResult == '5'){ // 无核验业务单
                                 $scope.identityVerifyClick();
                            }
                        }else{
                            control.showPopup(result.msg, 2000);
                        }
                    }
                    $scope.isShowNotVerifyMobilePop = false;
                    $scope.notVerifyMobileComfire =  function(){
                        $scope.isShowNotVerifyMobilePop = false;
                    }

                // 判断是否存在重复授权
                var checkIsRepeatAuth = function(){
                    var time = utility.getCurrentTime();
                    var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
                    var temp = {
                        "idcard": $rootScope.loginInfo.idCard,
                        "uniscid": selectedItem.uniscid,
                        "netType": selectedItem.extendDataJson.netType,
                        "corpid": selectedItem.extendDataJson.corpid,
                        "categoryBh":selectedItem.extendDataJson.categoryBh
                    }
                    console.log("checkIsRepeatAuth temp :" + JSON.stringify(temp));
                    var reqParams = DES3.encrypt(hashdata.substring(
                    0,24), 'ZJHUIXIN', angular.toJson(temp))

                    var params = {
                        "appid": $rootScope.appid,
                        "time": time,
                        "hashdata": hashdata,
                        "keyNo": $rootScope.uuid,
                        "token": $rootScope.loginInfo.token,
                        "reqParams": reqParams
                    };
                    console.log("checkIsRepeatAuth params :" + JSON.stringify(params));
                    control.showLoading();
                    requestWrapper.checkIsRepeatAuth({ data: params, refresh: true })
                        .then(function (result) {
                            control.hideLoading();
                            if (result == null || angular.equals({}, result)) {
                                control.showPopup('服务出错啦', 2000);
                                return;
                            };
                    console.log("checkIsRepeatAuth temp :" + JSON.stringify(result));
                            if (true == result.success) {
                                //v2.9.2 新增参数belongMe："1" 业务单或授权单在自己手里  ，"0"  业务单或授权单在其他人手里
                                // 有业务单
                                if ("2" == result.value.type) {//有授权
                                       if(result.value.belongMe=='0'){//有授权单在其他人手里
                                            var template = "<h3>该证书已有授权记录且证书未下载，若继续授权且证书下载后则原授权记录将失效，请确认该授权是否继续。</h3>"
                                            control.showConfirm3(function() {
                                                doGetUserFace();
                                            },function() {},'', '继续', 'check-information', template);
                                             return;
                                       }
                                }else{
                                    doGetUserFace();
                                }
                            } else {
                                 doGetUserFace();
                            }
                        }).catch(function (e) {
                            control.hideLoading();
                            control.showPopup('网络请求失败：' + e.status, 2000);
                        });
                    }

                    // 同意
                    var doGetUserFace = function () {
                        $rootScope.curAuthCode = selectedItem.itemCode;
                        control.showLoading();
                        var params = [$rootScope.loginInfo.idCard];
                        var successFunc = function (result) {
                            control.hideLoading();
                            console.log('doGetUserFace result.data.hasFaceImg -- ' + JSON.stringify(result.data.hasFaceImg));
                            if ('success' == result.rslt) {
                                let hasFaceImg = String(result.data.hasFaceImg);
                                if ('0' == hasFaceImg) {
                                     isAuth = true;
                                     if($rootScope.isAuthFace()){
                                         $scope.alert_applicant_info = true;
                                     }else{
                                         //生成业务单
                                         $scope.agreeAuthorization(selectedItem);
                                     }
                                } else if ('1' == hasFaceImg) {
                                    $scope.agreeAuthorization(selectedItem);
                                }
                            }
                        }
                        var failFunc = function (error) {
                            control.hideLoading();
                            control.showPopup(error, 3000);
                        };
                        nativeHelper.getUserFace({
                            data: params,
                            success: successFunc,
                            fail: failFunc
                        });
                    }
                    // 三要素短信校验通过
                    if($rootScope.verifyCodeType=='5'){
                        $rootScope.verifyCodeType='3'
                        selectedItem = $rootScope.selectedItem;
                        checkIsRepeatAuth();
                    }
                    $scope.identityVerifyClick =  function(){
                        if($scope.verifyResult == '5'){
                            //封装身份验证提交资料参数
                            $rootScope.certUnderwayInfo = {
                                 entName: selectedItem.unitName,
                                 uniscid: selectedItem.uniscid,
                                 categoryBh: selectedItem.extendDataJson.categoryBh,
                                 corpid: selectedItem.extendDataJson.corpid,
                                 certName:selectedItem.extendDataJson.certName ,
                            }
                            console.log("certUnderwayInfo:"+JSON.stringify($rootScope.certUnderwayInfo))
                            $rootScope.autoApplyInfo = {
                                businessLicensePic: '',
                                businessLicenseEntName: '',
                                businessLicenseOrgCode: '',
                                authorizationPic: '',
                                authorizationEntName: '',
                                authorizationPerson: '',
                                authorizationID: '',
                                authorizationTel: '',
                                authorizationExpDate: '',
                                IDCardFrontPic: '',
                                IDCardBackPic: '',
                                IDCardName: $rootScope.loginInfo.userName ? $rootScope.loginInfo.userName: '',
                                IDCardNumber: $rootScope.loginInfo.idCard ? $rootScope.loginInfo.idCard: '',
                                IDCardIndate: '',
                            };
                            $rootScope.certApplyNoticeParent = 'doIdentityVerifyToUploadPic';
                            nav.navigate('uploadApplyMaterials');
                        }else if($scope.verifyResult == '4'){
                            nav.navigate('businessManage')
                        }
                    }

                    //开始活体检测
                    var startBiopsyForAuthorization = function () {
                        $scope.alert_applicant_info = false;
                        verifyIdentity.startLiveDetection($rootScope.loginInfo.userName, $rootScope.loginInfo.idCard, $rootScope.loginInfo.userId,liveDetectionResultForAuthorization);
                    }
                    var photoData;
                    //人脸识别结果监听
                    var liveDetectionResultForAuthorization = function (res) {
                        $scope.$apply(function () {
                            if (res.rslt == 'success') {
                                photoData = res.photoData;
                                IdentityAuthenticationResForAuthorization(res.data);
                            }else{
                                authLivingFailEvent();
                                detectionErrorForAuthorization(res.resultMsg);
                            }
                        });
                    };
                    var authLivingFailEvent = function () {
                        var eventCounter = new Object();
                        eventCounter.page = "活体识别失败";
                        MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
                    }
                    //实人检测错误提示
                    var detectionErrorForAuthorization = function (resultMsg) {
                        control.showPopup(resultMsg, 2000);
                    }
                    //人脸信息和身份信息对比结果
                    var IdentityAuthenticationResForAuthorization = function (data) {
    //                    $scope.$apply(function () {
                            if (data.result == 'fail') {
                                if (data.authResult == '5XXX' || data.authResult == '6XXX') {
                                    if(!$rootScope.isOpenFaceAuthFail()){
                                        detectionErrorForAuthorization('姓名或身份证号码有误，错误代码' + data.authResult);
                                    }
                                    return;
                                } else if (data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '02XX') {
                                     if(!$rootScope.isOpenFaceAuthFail()){
                                        detectionErrorForAuthorization('人脸比对失败，错误代码' + data.authResult);
                                     }
                                    return;
                                } else {
                                    if(!$rootScope.isOpenFaceAuthFail()){
                                        control.showPopup(data.authResultMsg, 2000);
                                    }
                                }
                            }

                            $rootScope.setAuthSuccessTime();
                            $scope.agreeAuthorization(selectedItem);
    //                    });
                    }





                    var refuse = function (authId, identityId) {
                        control.showLoading();
                        var params = [authId, identityId];
                        var successFunc = function (result) {
                            control.hideLoading();
                            if (result == null || angular.equals({},
                                result)) {
                                control.showPopup('服务出错啦', 3000);
                                return;
                            }
                            if (result.rslt == 'success') {
                                //                            $scope.$apply(function() {
                                getAuthRecordList($rootScope.recordType)
                                //                            });
                            }
                            if (result.rslt == 'fail') {
                                control.showPopup(result.errorMsg, 2000);
                            }
                        }
                        var failFunc = function (error) {
                            control.hideLoading();
                            control.showPopup(error.msg, 2000);
                        };
                        nativeHelper.refuseAuthorization({
                            data: params,
                            success: successFunc,
                            fail: failFunc
                        });
                    }

                    // 拒绝授权
                    $scope.refuseAuthorization = function (authId, identityId) {
                        control.showConfirm("确认是否拒绝？",

                            function () {
                                refuse(authId, identityId);
                            },

                            function () {

                            },
                            "取消", "确认", 'cusClass');
                    }
                    //  查看详情
                    $scope.detail = function (item) {
                        $state.go('authorizationDetails', {
                            authorizationDetail: item
                        });
                    }

                    // 点击撤销授权按钮
                    $scope.revokeAuthorize = function (item) {
                        control.showConfirm5("<div class='tbtx-cont'><p>确定要撤销该授权申请吗？</p></div>", "<div class='popup-new-title'>撤销确认</div>",
                            function() {
                                 doInvalidAuth(item)
                            },
                            function() {},
                            "再想想", "确定", 'check-information');
                    }
                    // 撤销授权网络请求
                    var doInvalidAuth = function(item){
                        control.showLoading();
                        var params = [item.authId,$rootScope.loginInfo.userName];
                        var successFunc = function (result) {
                            control.hideLoading();
                            if (result.success) {
                                control.showPopup("撤销成功", 2000);
                                 var timeout = setTimeout(function () {
                                     clearTimeout(timeout)
                                     $scope.loadFirstPage();
                                 },2000);
                            }
                        }
                        var failFunc = function (error) {
                            control.hideLoading();
                            control.showPopup(error, 3000);
                        };
                        nativeHelper.doInvalidAuth({
                            data: params,
                            success: successFunc,
                            fail: failFunc
                        });
                    }

                    $scope.isShowShare = false;
                    $scope.isShowCopy = false;
                    $scope.linkContent = "";

                    $scope.showShare = function (item) {
                        console.log('linkInfo: ' + JSON.stringify(item));
                        // 1: 短地址  2: 小程序
                        if ('2' == item.shareContentType) {
                            $scope.isShowCopy = true;
                            $scope.linkContent = item.xcxContent;

                            nativeHelper.socialAgent({
                                data: [$scope.linkContent, 1,''],
                                success: () => { },
                                fail: () => { },
                            });
                        } else {
                            $scope.isShowShare = true;
                            $scope.linkContent = item.shareContent;
                            $scope.url = item.shortUrl;
                            //jbr：经办人申请授权，分享弹窗新增查看法人授权流程入口；fr：法人主动授权，分享弹窗不显示查看法人授权流程入口；
                            $scope.type = "jbr";
                        }

                        if (!$scope.linkContent) {
                            control.showPopup('授权地址为空', 3000);
                            return;
                        }
                    }

                    $scope.cancel = function () {
                        $scope.isShowShare = false;
                        $scope.isShowCopy = false;
                    }

                    $scope.cancelShare = function () {
                        $scope.isShowShare = false;
                        $scope.isShowCopy = false;
                    }

                    $scope.navigate = function (state) {
                        nav.navigate(state);
                    };

                    $scope.acShowAuthConfirm = false;
                    $scope.acCloseClick = function () {
                        $scope.acShowAuthConfirm = false;
                    }
                    $scope.acIsAgreeApplyAgreement = false;
                    $scope.acAgree = function () {
                        $scope.acIsAgreeApplyAgreement = !$scope.acIsAgreeApplyAgreement;
                    }
                    $scope.acAgreement = function () {
                        var url = window.currentUrl + '/app/ezt/faceAgreement.html';
                        var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                        cordova.InAppBrowser.open(url, '_blank', operation);
                    }
                    $scope.backBtn = function () {
                        if ($stateParams.authStatus != "") {
                            nav.navigate($stateParams.parentPage);
                        } else {
                            nav.navigate('tab/home');
                        }
                    };
                    $scope.acNext = function () {
                        if (!$scope.acIsAgreeApplyAgreement) {
                            control.showPopup("请确认同意《人脸认证功能协议》", 2000);
                            return;
                        }
                        $scope.acShowAuthConfirm = false;


                        var eventCounter = new Object();
                        eventCounter.page = "活体检测-授权记录";
                        MobclickAgent.onEventWithParameters("authLivingAuthorizationRecordEvent", eventCounter);

                        if (isAuth) {
                            startBiopsyForAuthorization();
                        } else {
                            $scope.alert_applicant_info = false;
                            liveDetectionNum++;
                            verifyIdentity.startLiveDetection($rootScope.loginInfo.userName, $rootScope.loginInfo.idCard, $rootScope.loginInfo.userId,liveDetectionResult);
                        }
                    }


                    $rootScope.popupPwdHidden = true;
                    $rootScope.userNameForPwdPopup = $rootScope.loginInfo.userName;
                    $rootScope.userPhoneForPwdPopup = $rootScope.loginInfo.mobile;
                    $rootScope.pwdPopup = { userPassword: '' };
                    $rootScope.passwordPopupCloseClick = function () {
                        control.hideCustomPopup();
                    }
                    $rootScope.passwordPopupConfirmClick = function () {
                        if ('' == $rootScope.pwdPopup.userPassword) {
                            return;
                        }

                        var time = utility.getCurrentTime();
                        var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
                        var temp = {
                            'mobile': $rootScope.loginInfo.mobile,
                            'password': $rootScope.pwdPopup.userPassword,
                            'keyNo': $rootScope.uuid,
                            "token": $rootScope.loginInfo.token
                        }

                        var reqParams = DES3.encrypt(hashdata.substring(0, 24), 'ZJHUIXIN', angular.toJson(temp))

                        var params = {
                            "appid": $rootScope.appid,
                            "time": time,
                            "hashdata": hashdata,
                            "reqParams": reqParams
                        };
                        console.log('params - ' + JSON.stringify(params));
                        control.showLoading();
                        requestWrapper.verifyPassword({ data: params, refresh: true })
                            .then(function (result) {
                                control.hideLoading();
                                $rootScope.pwdPopup = { userPassword: '' };
                                console.log("doGetMobileDeviceCount" + JSON.stringify(result));
                                if (true == result.success) {
                                    control.hideCustomPopup();
                                    getFeeInfo();
    //                                doNetOrderInfo(authorizationItemInfo)
                                } else {
                                    control.showPopup(result.msg, 2000);
                                }
                            });
                    }

                    $rootScope.passwordPopupForgetClick = function () {
                        control.hideCustomPopup();
                        var hideMobile = $rootScope.loginInfo.mobile;
                        if(hideMobile == undefined || hideMobile == null || hideMobile == ''){
                            hideMobile = ''
                        }
                        if (!isNaN(parseFloat(hideMobile)) && isFinite(hideMobile)) {
                            var prefix = hideMobile.slice(0, 3);
                            var suffix = hideMobile.slice(7)
                            hideMobile = prefix + "****" + suffix;
                        }
                        var template = "<h4 style='word-break:break-all;'>找回密码需要短信验证，确定要给您的手机号"+hideMobile+ "发送验证码短信吗？</h4>"
                        control.showConfirm3(function() {
                             nav.navigate('retrievePasswordForPwdPopup');
                         },function() {},'', '确定', 'check-information', template);
                    }

                    $rootScope.popupPwdIconClick = function () {
                        console.log($rootScope.popupPwdHidden);
                        if ($rootScope.popupPwdHidden) {
                            console.log('ss=' + $rootScope.popupPwdHidden);
                            let input = document.getElementById("pwdpopup-pwdinput");
                            console.log(input);
                            input.setAttribute("type", "text");
                            let icon = document.getElementById("pwdpopup-pwdicon");
                            icon.setAttribute("class", "pwdpopup-show-icon");
                        } else {
                            let input = document.getElementById("pwdpopup-pwdinput");
                            input.setAttribute("type", "password");
                            let icon = document.getElementById("pwdpopup-pwdicon");
                            icon.setAttribute("class", "pwdpopup-hide-icon");
                        }
                        $rootScope.popupPwdHidden = !$rootScope.popupPwdHidden;
                        console.log($rootScope.popupPwdHidden);
                    }

                    $rootScope.popupPwdClearClick = function () {
                        $rootScope.pwdPopup = { userPassword: '' };
                    }
                     //获取下拉刷新数据
                     $scope.doRefresh = function() {
                        pageNum = 1;
                        getAuthRecordList($rootScope.recordType);
                        $scope.$broadcast('scroll.refreshComplete');
                     };

                     //点击加载更多
                     $scope.loadMore = function() {
                        console.log("suligen = loadMore")
                        if ($scope.recordsTotal > pageNum*pageSize) {
                            pageNum++;
                            getAuthRecordList($rootScope.recordType);
                            $scope.isloadmore = false;
                        } else {
                            $scope.isloadmore = true;
                        }
                        $scope.can_loadmore = false;
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        return;
                     };


            }]);
})();
