(function() {
    "use strict"

    angular.module('starter')
    .controller('signatureAuthorization', ['$rootScope', '$scope', '$timeout', '$stateParams', '$ionicLoading', '$filter', 'nav', 'control', 'nativeHelper', '$state',
    function($rootScope, $scope, $timeout, $stateParams, $ionicLoading, $filter, nav, control, nativeHelper, $state) {
        control.hideLoading();
        var approvalDetail = $stateParams.authorizationDetail;
        var wrapper = document.getElementById("signature-pad"),
        canvas = wrapper.querySelector("canvas"),
        signaturePad;
        var imageBox = document.getElementById("mergeImg");

        var resizeCanvas = function() {
            var ratio = Math.max(window.devicePixelRatio || 1, 1);
            canvas.width = canvas.offsetHeight * ratio;
            canvas.height = canvas.offsetHeight * ratio;
            canvas.style="margin:0 calc(50vw - 118px);width: 236px !important;";
            canvas.getContext("2d").scale(ratio, ratio);
            signaturePad = new SignaturePad(canvas,{
               backgroundColor: "rgba(255,255,255,0.48)",
               penColor: 'rgb(0, 0, 0)' ,
               minWidth: 4,
               maxWidth: 4,
            });
        }

        var setLandscape = function() {
            screen.orientation.unlock();
            screen.orientation.lock('portrait');
            screen.orientation.lock('landscape');
        }

        //设置横屏
        setLandscape();

        $timeout(function() {
            resizeCanvas();
        },
        1000);

        $scope.clearSignature = function() {
            signaturePad.clear();
        }
        //授权记录同意
        var checkPass = function(signnatureBase) {
            control.showLoading();
            var signerId = approvalDetail.authId;
            var params = [approvalDetail.authId, approvalDetail.identityId, signnatureBase, approvalDetail.startTime + ' 00:00:00', approvalDetail.endTime + '23:59:59'];

            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 3000);
                    return;
                }
                switch (result.rslt) {
                case "success":
                    control.showPopup('保存成功', 2000,
                    function() {
                        $scope.$apply(function() {
                            $scope.clearSignature();
                            screen.orientation.unlock();
                            screen.orientation.lock('portrait');
                            nav.navigate('authorizationRecord');
                        });
                    });

                    if (cordova.platformId === 'ios') {
                        nativeHelper.setOrientation({
                            data: ['Portrait'],
                            success: null,
                            fail: null
                        });
                    }
                    break;
                case "fail":
                    control.showPopup(result.errorMsg, 3000);
                    break;
                }
            }

            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error, 3000);
            };

            nativeHelper.checkPass({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }

        var addAuthInfoByFr = function(signatureImage) {
            control.showLoading();
            var code = $rootScope.curAuthCode || '20191016172831442090';
            var params = [approvalDetail.uniscid, approvalDetail.name, approvalDetail.cert,approvalDetail.mobile, code, approvalDetail.startTime + ' 00:00:00', approvalDetail.endTime + '23:59:59', signatureImage,'EPASSAPP',{
                    'certName': approvalDetail.certName,
                    'categoryBh': approvalDetail.categoryBh,
                    'netType': approvalDetail.netType,
                    'corpid': approvalDetail.corpid,
                    'businessType':approvalDetail.businessType,
                }];

            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 3000);
                    return;
                }
                switch (result.rslt) {
                case "success":
                    if($rootScope.applyCertType == 0){
                        var eventCounter = new Object();
                        eventCounter.page = "证书申领-证书授权成功";
                        MobclickAgent.onEventWithParameters("applyAuthorizationSuccessEvent", eventCounter);
                    }else if($rootScope.applyCertType == 1){
                        var eventCounter = new Object();
                        eventCounter.page = "证书补办-证书授权成功";
                        MobclickAgent.onEventWithParameters("makeUpAuthorizationSuccessEvent", eventCounter);
                    }
                    control.showPopup('保存成功', 2000,
                    function() {
                        $scope.$apply(function() {
                            $scope.clearSignature();
                            screen.orientation.unlock();
                            screen.orientation.lock('portrait');
                            nav.navigate('authorizeComplete');
                        });
                    });
                    if (cordova.platformId === 'ios') {
                        nativeHelper.setOrientation({
                            data: ['Portrait'],
                            success: null,
                            fail: null
                        });
                    }
                    break;
                case "fail":
                    control.showPopup(result.errorMsg, 3000);
                    break;
                }
            }

            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error, 3000);
            };

            nativeHelper.addAuthInfoByFr({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }


        $scope.submitSignature = function() {
            if($rootScope.applyCertType == 0){
                var eventCounter = new Object();
                eventCounter.page = "证书申领-授权书签名页面-提交";
                MobclickAgent.onEventWithParameters("applysubmitAuthorizationEvent", eventCounter);
            }else if($rootScope.applyCertType == 1){
                var eventCounter = new Object();
                eventCounter.page = "证书补办-授权书签名页面-提交";
                MobclickAgent.onEventWithParameters("makeUpsubmitAuthorizationEvent", eventCounter);
            }
            var imgBase64 =$('#mergeImg').attr('src').split(',')[1];
            if (approvalDetail.srcPage == 'approvallnfoV2') {
                addAuthInfoByFr(imgBase64);
            } else checkPass(imgBase64);
        }

        $scope.navigate = function() {
            if (cordova.platformId === 'ios') {
                nativeHelper.setOrientation({
                    data: ['Portrait'],
                    success: null,
                    fail: null
                });
            }
            nav.goBack();
        };

//        var eventWithParameters = function() {
//            var eventCounter = new Object();
//            eventCounter.page = "授权审批";
//            MobclickAgent.onEventWithParameters("behaviorTracking", eventCounter);
//        }


        $scope.index = 0; //签字的下标
        $scope.errorNum = 0; //失败的次数 2次之后不再识别
        //点击下一步 提交orc接口做图片识别
        $scope.submitNext = function() {

            if (signaturePad.isEmpty()) {
                control.showPopup("请设置签名", 1000);
                return;
            }
            //失败2次之后不再识别直接通过
            if($scope.errorNum>=2){
                $scope.mergeImg();
                $scope.errorNum=0;
                return;
            }
            var imgBase64 = signaturePad.toDataURL().split(',')[1];
            control.showLoading();
            var params = [imgBase64, $rootScope.loginInfo.userName.charAt($scope.index)];
            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 3000);
                    return;
                }

                switch (result.rslt) {
                case "success":
                    $scope.mergeImg();
                    $scope.errorNum=0;
                    break;
                case "fail":
                    $scope.errorNum++;
                    signaturePad.clear();
                    control.showPopup(result.errorMsg, 3000);
                    break;
                }
            }

            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error, 3000);
            };

            nativeHelper.ocrDiscern({
                data: params,
                success: successFunc,
                fail: failFunc
            });

        }

        var canvas2 = document.createElement("canvas");
        canvas2.width = 236*($rootScope.loginInfo.userName.length);
        canvas2.height = 236;
        var cxt =  canvas2.getContext("2d");
        $scope.mergeImg = function(){
        var img = new Image();
        var src = $('#mergeImg').attr('src');
        img.src = src;
        img.src = signaturePad.toDataURL('image/png');
        var dx = $scope.index * 236;
        img.onload = () => {
             // 画图(这里画布与图片等宽高)
             cxt.drawImage(img, dx, 0,236,236);
             imageBox.src = canvas2.toDataURL("image/png");
             //判断是否最后一次签字  最后一次签完提交签名
             if($scope.index!=$rootScope.loginInfo.userName.length-1){
                 signaturePad.clear();
                 $scope.$apply(function () {
                     $scope.index++;
                 });
             }else{
                 $scope.submitSignature();
             }
        }

    }



    }]);
})();
