(function () {
    "use strict"

    angular.module('starter')
        .controller('delayOrChangeDwnCert', ['$rootScope', '$scope', '$filter', 'nav', 'utility', 'control', 'nativeHelper', 'validate', 'localStorage', '$stateParams','requestWrapper',
            function ($rootScope, $scope, $filter, nav, utility, control, nativeHelper, validate, localStorage, $stateParams,requestWrapper) {
                $scope.downloadCertInfo = { password: '', confirmPwd: '' };
                $scope.canClick = false;
                // 延期生成延期变更业务单
                $rootScope.isGetHomeCertApi = true;
                $scope.delayOrChangeDwnCertLastPage = $stateParams.lastPage;
                var entName = $stateParams.entName;
                var uniscid = $stateParams.uniscid;
                var orderNo = $stateParams.orderNo;
                var corpid = $stateParams.corpid;
                var type = $stateParams.type;
                var certId = $stateParams.certId;
                var containerName = $stateParams.containerName;
            setTimeout(function() {
                 let input=document.getElementById("inputPassword");
                 input.focus();
                        }, 500);

            var downloadCertEvent = function() {
                var eventCounter = new Object();
                eventCounter.page = "下载证书";
                MobclickAgent.onEventWithParameters("downloadCertEvent", eventCounter);
            }
            
            var downloadCertCompletedEvent = function() {
                var eventCounter = new Object();
                eventCounter.page = "证书下载成功";
                MobclickAgent.onEventWithParameters("downloadCertCompletedEvent", eventCounter);
            }
            
                $scope.downloadCert = function () {
                    if (!validate.certPassword($scope.downloadCertInfo.password) || !validate.certPassword($scope.downloadCertInfo.confirmPwd)) {
                        control.showPopup('请输入6位数字密码', 2000);
                        return;
                    }

                    if ($scope.downloadCertInfo.password !== $scope.downloadCertInfo.confirmPwd) {
                        control.showPopup('您输入的两次密码不相同', 3000);
                        return;
                    }
                    if(containerName==null|| containerName==''||containerName==undefined||containerName=="undefined"){
                        control.showPopup("延期变更的containerId为空->"+containerName, 3000);
                        return;
                    }
                    $scope.canClick = true;
                    control.showLoading();
                    downloadCertEvent();//监听下载
                    
                    var timeout = setTimeout(function () {
                        var params = [
//                            entName,
//                            uniscid,
                            orderNo,
                            corpid,
                            type,
//                            certId,
                            $scope.downloadCertInfo.password,
                            cordova.platformId,
                            containerName,
                            $rootScope.SDKVersion,//V1：旧版密码模块，V2：新版密码模块
                            $rootScope.loginInfo.accountId,
                            "1",//自启用
                            "EPASSAPP"
                        ];
                        var successFunc = function (result) {
                            clearTimeout(timeout)
                            control.hideLoading();
                            if (result == null || angular.equals({}, result)) {
                                return;
                            }
                            switch (result.success) {
                                case true:
                                    downloadCertCompletedEvent();//监听下载成功

                                     control.showPopup('下载成功', 2000);
                                     $scope.canClick = false;
                                     nav.navigate('tab/home');
                                    break;
                                case false:
                                    control.hideLoading();
                                    $scope.canClick = false;
                                    control.showPopup(result.msg, 3000);
                                    nav.navigate($scope.delayOrChangeDwnCertLastPage);
                                    break;
                            }
                        };

                        var failFunc = function (result) {
                            $scope.canClick = false;
                            control.hideLoading();
                            control.showPopup(result.msg, 3000);
                            clearTimeout(timeout)
                            requestWrapper.sendMesToDingTalk("密码模块错误","证书下载",result.alarmMsg)
                        };
                        nativeHelper.downloadCert({ data: params, success: successFunc, fail: failFunc });
                    }, 500);
                }

                $scope.navigate = function (state) {
                    nav.navigate(state);
                };

               $scope.$watch('downloadCertInfo.password', function(newValue, oldValue) {
                            //当第一次确认输入完成，自动跳到第二次输入 光标移动到第二个input
                            if($scope.downloadCertInfo.password.length==6){
                                 setTimeout(function() {
                                     let input=document.getElementById("inputConfirmPwd");
                                         input.focus();
                                  }, 500);
                              }
                            });
               $scope.$watch('downloadCertInfo.confirmPwd', function(newValue, oldValue) {
                             //当第二次确认输入完成，自动开始验证
                              if($scope.downloadCertInfo.confirmPwd.length==6){
                              //移除焦点，取消软键盘
                               let input=document.getElementById("inputConfirmPwd");
                                   input.blur();
                                  $scope.downloadCert();
                                  }
                              });
               //第二次输入密码时点返回  返回到第一次输入密码页面  第一次输入密码返回  返回上一页
               $rootScope.backClick = function(){
                 if($scope.downloadCertInfo.password.length==6){
                      $scope.downloadCertInfo.password="";
                      $scope.downloadCertInfo.confirmPwd="";
                  }else{
                      nav.navigate($scope.delayOrChangeDwnCertLastPage);
                  }
               }


            }]);
})();
