(function () {
    "use strict"

    angular.module('starter')
    .controller('retrievePasswordForPwdPopup', ['$rootScope', '$scope', '$ionicLoading', 'nav', 'nativeHelper', 'control', 'validate','localStorage','$ionicHistory',
    function ($rootScope, $scope, $ionicLoading, nav, nativeHelper, control, validate,localStorage,$ionicHistory) {
        $scope.retrievePasswordInfo = {
            tel: $rootScope.loginInfo.mobile,
            authCode: '',
            password: '',
            verifyPassword: ''
        };

        $scope.retrievePassword = function () {
            if (validate.nullOrEmpty($scope.retrievePasswordInfo.tel) || validate.nullOrEmpty($scope.retrievePasswordInfo.authCode)) {
                control.showPopup('请输入手机号、验证码', 3000);
                return;
            }

            if (validate.loginPasswordReg($scope.retrievePasswordInfo.verifyPassword)) {
            // if (validate.loginPassword($scope.retrievePasswordInfo.verifyPassword)) {
                if ($scope.retrievePasswordInfo.password === $scope.retrievePasswordInfo.verifyPassword) {
                    control.showLoading();
                    var params = [$scope.retrievePasswordInfo.tel, $scope.retrievePasswordInfo.password, $scope.retrievePasswordInfo.authCode, '2'];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 3000);
                            return;
                        }
                        switch (result.success) {
                            case true:
                                control.showPopup('密码设置成功', 3000);
                                
                                $rootScope.localCertList = [];
                                localStorage.deleteItem('loginInfo');

                                PushAgent.delAlias(function(){},$rootScope.loginInfo.userId,'userUniqueId')
                                $ionicHistory.clearHistory();
                                nav.navigate('signIn');

                                if ('android' == cordova.platformId) {
                                    var params = [];
                                    var successFunc = function (result) {}
                                    var failFunc = function (error) {}
                                    nativeHelper.signOut({data: params, success: successFunc, fail: failFunc});
                                }
                                
                                break;
                            case false:
                                control.showPopup(result.msg, 3000);
                                break;
                        }
                    }

                    var failFunc = function (error) {
                      control.hideLoading();
                    };

                    nativeHelper.signUp({ data: params, success: successFunc, fail: failFunc });
                }
                else {
                    control.showPopup('您输入的两次密码不相同', 3000);
                }
            }
            else {
                // control.showPopup('6-16位字符。可使用字母、数字和符号任意组合', 2000);
                control.showPopup('8-32位字符，至少包含数字、大小写字母及特殊符号中的三种', 2000);
            }
        }

        $scope.btnColor = '0';
        $scope.showBtn = true;
        $scope.getBlur = function(id) {
                    $scope.showBtn = true;
                    console.log(id);
                    var ele = document.getElementById(id);
                    ele.className = ele.className.replace(' border-red','')
                    ele.className = ele.className.replace('border-red',' ');

                    if('' != $scope.retrievePasswordInfo.tel && '' != $scope.retrievePasswordInfo.authCode && '' != $scope.retrievePasswordInfo.password && '' != $scope.retrievePasswordInfo.verifyPassword){
                        $scope.btnColor = '1';
                    }else{
                        $scope.btnColor = '0';
                    }

                    if('input-tel' == id){
                        if (!validate.mobile($scope.retrievePasswordInfo.tel)) {
                            $scope.erroTel = '1';
                        }else{
                            $scope.erroTel = '0';
                        }
                    }

                    if('input-code' == id){
                        if (validate.nullOrEmpty($scope.retrievePasswordInfo.authCode)) {
                            $scope.erroCode = '1';
                        }else{
                            $scope.erroCode = '0';
                        }
                    }

                    if('input-password' == id){
                        if (!validate.loginPasswordReg($scope.retrievePasswordInfo.password)) {
                            $scope.erroPassword = '1';
                        }else{
                            $scope.erroPassword = '0';
                        }
                    }

                    if('input-comfirm' == id){
                        if (!validate.loginPasswordReg($scope.retrievePasswordInfo.verifyPassword)) {
                            $scope.erroVerifyPassword = '1';
                        }else{
                            $scope.erroVerifyPassword = '0';
                        }
                    }
                }
        $scope.getFocus = function(id){
                    $scope.showBtn = false;
                    var ele = document.getElementById(id);
                    ele.className +=  " border-red";
                }

        $scope.eyeStatusPassword = 'password';
        $scope.eyeStatusVerifyPassword = 'password';
        $scope.eyeClickPassword = function(){
            if($scope.eyeStatusPassword == 'password'){
                 $scope.eyeStatusPassword = 'text';
               }else{
                  $scope.eyeStatusPassword = 'password';
            }
             }
        $scope.eyeClickVerifyPassword = function(){
            if($scope.eyeStatusVerifyPassword == 'password'){
                 $scope.eyeStatusVerifyPassword = 'text';
               }else{
                  $scope.eyeStatusVerifyPassword = 'password';
            }
             }

        $scope.backClick = function () {
            nav.navigate($rootScope.pwdPopupFrom);
        }

        $scope.navigate = function (state) {
            nav.navigate(state);
        };
    }]);
})();