(function() {
    "use strict"
    angular.module('starter').controller('applyCertSearchV2', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', 'localStorage','verifyIdentity', '$stateParams','utility',
    function($rootScope, $scope, nav, control, nativeHelper,localStorage, verifyIdentity, $stateParams, utility) {


        $scope.showFrozenTip=false;//是否显示被加入黑名单提示弹窗
        $scope.frozenTipDec='';//被加入黑名单提示内容
//        $rootScope.applyCertType = 1; // 0 可申领的证书   1 可补办的证书  2邮寄材料
        $rootScope.applyCertInfo = { uniscid: '' };
        $scope.searchInfo = {
            'key':''
        };
        $scope.errMsg = ''
        $scope.searchHistoryLists = localStorage.getObject('searchHistoryInfoLists');
        if (JSON.stringify($scope.searchHistoryLists) == '{}') $scope.searchHistoryLists = [];
        //存储搜索历史记录
        var storageSearch=function(sName){
            if($scope.searchHistoryLists.length<6&&$scope.searchHistoryLists.indexOf(sName)<0){
            $scope.searchHistoryLists.unshift(sName);
            }else if($scope.searchHistoryLists.length>=6&&$scope.searchHistoryLists.indexOf(sName)<0){
            $scope.searchHistoryLists.pop();
            $scope.searchHistoryLists.unshift(sName);

            }else if($scope.searchHistoryLists.indexOf(sName)>=0){
                $scope.searchHistoryLists.splice($scope.searchHistoryLists.indexOf(sName),1);
                $scope.searchHistoryLists.unshift(sName);
            }
            localStorage.setObject('searchHistoryLists', $scope.searchHistoryLists);
        }

        //存储搜索历史记录 携带搜索信息
        var storageSearchInfo=function(searchInfo){
            // 去重
            $scope.searchHistoryLists = $scope.searchHistoryLists.filter(searchHistory => {
                return searchHistory.entName != searchInfo.entName;
            });
            console.log('after fiter - ' + JSON.stringify($scope.searchHistoryLists));
            console.log('after fiter length - ' + $scope.searchHistoryLists.length);
            // 限制6个
            if ($scope.searchHistoryLists.length >= 6) {
                $scope.searchHistoryLists.pop();
                $scope.searchHistoryLists.unshift(searchInfo);
            } else {
                $scope.searchHistoryLists.unshift(searchInfo);
            }

            localStorage.setObject('searchHistoryInfoLists', $scope.searchHistoryLists);
        }
        //搜索授权企业
        $scope.searchAuthorizeEnt = function(key) {
            try{

                control.showLoading();
                var containCategory = [];
                var params = [key,containCategory];
                var successFunc = function(result) {
                    control.hideLoading();
                    if (result == null || angular.equals({},
                    result)) {
                        control.showPopup('服务出错啦', 2000);
                        return;
                    }
                    if (result.success) {
                        $scope.errMsg = ''
                        $rootScope.searchResult = result.value;
                        toApplyCert()
                        //v3.0.0 新增地区参数 将地区参数配置到证书列表中携带到申请证书流程
                        if($rootScope.searchResult!=null){
                             $rootScope.searchResult.alreadyReceived.forEach(function(l) {
                                l.entProvince=result.value.entProvince;
                             })
                             $rootScope.searchResult.canReceived.forEach(function(l) {
                                 l.entProvince=result.value.entProvince;
                              })
                        }
                    }
                    if (!result.success) {
                        $scope.errMsg = result.msg
                        //v2.9.8版本新增  黑名单用户不允许下载证书，提示找客服处理
                        if(result.msgType=='error_black'){
                           if( $rootScope.applyCertType==0){
                               $scope.errMsg='因违规操作，当前用户已被禁止申领非法定代表人企业证书，如有疑问请联系客服';
                               $scope.frozenTipDec='因违规操作，当前用户已被禁止申领非法定代表人企业证书，如有疑问请联系客服';
                           }else if( $rootScope.applyCertType==1){
                               $scope.errMsg='因违规操作，当前用户已被禁止补办非法定代表人企业证书，如有疑问请联系客服';
                               $scope.frozenTipDec='因违规操作，当前用户已被禁止补办非法定代表人企业证书，如有疑问请联系客服';
                           }else if( $rootScope.applyCertType==2){
                               $scope.errMsg='因违规操作，当前用户已被禁止邮寄申领非法定代表人企业证书，如有疑问请联系客服';
                               $scope.frozenTipDec='因违规操作，当前用户已被禁止邮寄申领非法定代表人企业证书，如有疑问请联系客服';
                           }
                           $scope.showFrozenTip=true;
                           return;
                        }
                    }
                }

                var failFunc = function(error) {
                    control.hideLoading();
                    control.showPopup(error.msg, 2000);
                };
                nativeHelper.searchAuthorizeEnt({
                    data: params,
                    success: successFunc,
                    fail: failFunc
                });
            }catch(e){
//                alert(JSON.stringify(e))
            }
        }
        //模糊查询企业列表
        $scope.companyList = [];
        //获取模糊查询企业列表
       var fuzzyQueryForSubject = function(key){
                if(key==''){
                     $scope.$apply(function() {
                         $scope.companyList = [];
                     });
                     return
                }
                $scope.companyList = [];
                var params = [key];
                var successFunc = function(result) {
                    if (result == null || angular.equals({},result)) {
                        control.showPopup('服务出错啦', 2000);
                        return;
                    }
                    if (result.success) {
                        if(result.value!=null){
                            $scope.$apply(function() {
                               $scope.companyList=result.value;
                            });
                        }else{
                            $scope.$apply(function() {
                               $scope.companyList = [];
                            });
                        }
                    }
                }

                var failFunc = function(error) {
                    //control.showPopup(error.msg, 2000);
                };
                nativeHelper.fuzzyQueryForSubject({
                    data: params,
                    success: successFunc,
                    fail: failFunc
                });
        }
        //当选中列表中的值时，不触发模糊搜索
        $scope.isSelectCompany=false;
        $scope.$watch('searchInfo.key', function(newValue, oldValue) {
            if($scope.isSelectCompany){
                $scope.isSelectCompany=false;
                return
            }
            if(newValue==''){
                $scope.companyList = [];
            }else{
                fuzzyQueryForSubject($scope.searchInfo.key);
            }
         });
        $scope.getBlur = function() {
            $scope.companyList = [];
        }
        //选中模糊查询列表数据
        $scope.selectCompany = function(company) {
            $scope.isSelectCompany=true;
            $scope.companyList = [];
            $scope.searchInfo.key = company;
        }
        //证书申领操作说明
        $scope.helpExplain =function() {
            if( $rootScope.applyCertType==0){
                utility.helpExplain(window.certApply,"证书申领操作说明","helpCertApplyEvent");
            } else if( $rootScope.applyCertType==1){
                utility.helpExplain(window.certMakeUp,"证书补办操作说明","helpCertMakeUpEvent");
            }
        };
        $scope.navigate = function(state) {
            nav.navigate(state);
        };
                                                             
         $scope.navToAuthRecord = function(){
            $rootScope.recordType = '0';
            nav.navigate('authorizationRecord');
         }

    $scope.cleanClick = function() {
        var confirm = function () {
            localStorage.deleteItem('searchHistoryInfoLists');
            $scope.searchHistoryLists = [];
        };
        var cancel = function () {};
        control.showConfirm('确定要清空当前的搜索记录吗？', confirm, cancel);
    }

    $scope.$watch('applyCertInfo.uniscid', function(newValue, oldValue) {
        $rootScope.applyCertInfo.uniscid = newValue.replace(/\s+/g,"");
    });
    $scope.showCheckUniscid = false;
    var toApplyCert = function(){
        if( $rootScope.applyCertType==0){
            storageSearchInfo($rootScope.searchResult);
            nav.navigate('ableApplyCertInfoV2');
            var eventCounter = new Object();
            eventCounter.page = "证书申领-主体信息查询";
            MobclickAgent.onEventWithParameters("applySubjectInformationQueryEvent", eventCounter);
        } else if( $rootScope.applyCertType==1){
            storageSearchInfo($rootScope.searchResult);
            nav.navigate('ableMakeUpCertInfoV2');
            var eventCounter = new Object();
            eventCounter.page = "证书补办-主体信息查询";
            MobclickAgent.onEventWithParameters("makeUpSubjectInformationQueryEvent", eventCounter);
        } else if( $rootScope.applyCertType==2){
            $scope.showCheckUniscid = true;
            $scope.checkUniscidFunc = function() {
                if ($rootScope.applyCertInfo.uniscid.length!==4) {
                    control.showPopup('请输入统一社会信用代码后4位!' +$rootScope.applyCertInfo.uniscid , 2000);
                    return;
                }
                if ($rootScope.applyCertInfo.uniscid.toUpperCase() !== $rootScope.searchResult.uniscid.substr(-4)) {
                    control.showPopup("信息校验未通过，请确认后再次尝试", 2000);
                    return;
                }
                storageSearchInfo($rootScope.searchResult);
                var isMakeUp = true; // 是否补办
                var isMakeUp060 = false;// 省外证书是否补办过
                // 补办
                $rootScope.searchResult.alreadyReceived.forEach(function(v) {
                     if (v.categoryBh == '060' ) {
                          isMakeUp060 = true;
                     }
                 });
                 // 新领
                 $rootScope.searchResult.canReceived.forEach(function(v) {
                     if (v.categoryBh == '010') {
                         isMakeUp = false;
                     } else if (v.categoryBh ==('060')&&!isMakeUp060) {
                         isMakeUp = false;
                     }
                 });
                 if(isMakeUp){
                    nav.navigate('ableMakeUpCertInfoV2');
                 }else{
                    nav.navigate('ableApplyCertInfoV2');
                 }
                 $scope.showCheckUniscid = false;
            }
            $scope.hideCheckUniscid = function() {
                $scope.showCheckUniscid = false;
            }
            $scope.getUniscid = function(i) {
                if($rootScope.applyCertInfo.uniscid.length>i){
                    return $rootScope.applyCertInfo.uniscid.substring(i, i+1);
                }else{
                    return ''
                }
            }
        } else {
            storageSearchInfo($rootScope.searchResult);
            var isMakeUp = true; // 是否补办
            var isMakeUp060 = false;// 省外证书是否补办过
             // 补办
             $rootScope.searchResult.alreadyReceived.forEach(function(v) {
                 if (v.categoryBh == '060' ) {
                      isMakeUp060 = true;
                 }
             });
             // 新领
             $rootScope.searchResult.canReceived.forEach(function(v) {
                  if (v.categoryBh == '010') {
                      isMakeUp = false;
                  } else if (v.categoryBh ==('060')&&!isMakeUp060) {
                      isMakeUp = false;
                  }
             });
             if(isMakeUp){
                 $rootScope.applyCertType=1
                  nav.navigate('ableMakeUpCertInfoV2');
             }else{
                $rootScope.applyCertType=0
                nav.navigate('ableApplyCertInfoV2');
             }
        }

    }
    $scope.colseFrozenTip = function(){
        $scope.showFrozenTip=false;
    }
    }]);
})();
