(function() {
    "use strict"
    angular.module('starter')
    .controller('confirmCertInvoice', ['$rootScope','$stateParams', '$scope', 'nav', 'control', 'nativeHelper', '$state','verifyIdentity','validate',
    function($rootScope,$stateParams, $scope, nav, control, nativeHelper, $state,verifyIdentity,validate) {



    /**
    *授权申领法人或经办人生成付费业务单、授权记录生成付费业务单
    **/

    var netOrderInfoWithInvoice=$stateParams.netOrderInfoWithInvoice;
        $scope.invoice = {
            header: netOrderInfoWithInvoice.entName.replace(/\(副本.*?\)/g,''),
            taxNo: netOrderInfoWithInvoice.uniscid,
            email: ''
        }
        $scope.certInfo = {
            entName: netOrderInfoWithInvoice.entName.replace(/\(副本.*?\)/g,''),
            uniscid: netOrderInfoWithInvoice.uniscid,
            type: "证书新领"
        }
        $scope.canClick=false;
        $scope.$watch('invoice.header', function(newValue, oldValue) {
           console.log($scope.invoice.header);
            //当value改变时执行的代码
             $scope.invoice.header = newValue
            if(newValue==''){
                 $scope.invoice.taxNo = ''
            }
        });

        $scope.$watch('invoice.taxNo', function(newValue, oldValue) {
            console.log($scope.invoice.taxNo);
            $scope.invoice.taxNo = newValue
            if(newValue==''){
                 $scope.invoice.header = ''
            }
        });
        //生成授权付费业务单
        $scope.confirmInvoice = function(header, taxNo,email) {
            $scope.canClick=true;
            if (header == '') {
                control.showPopup("发票抬头不能为空", 2000);
                return;
            }
            if (taxNo == '') {
                control.showPopup("统一信用代码不能为空", 2000);
                return;
            }
             if (email != ''&& !validate.email(email)) {
                 control.showPopup("邮箱名称格式不符,请确认邮箱名称是否正确", 2000);
                 return;
            }
            $scope.invoice.header=header;
            $scope.invoice.taxNo=taxNo;
            $scope.invoice.email=email;
            $scope.userName=netOrderInfoWithInvoice.agenter;
            $scope.userCert=netOrderInfoWithInvoice.cert;
            //生成付费业务单
            doSaveAuthNetOrderInfoWithInvoice();
        }


        //脱敏处理方法
        function maskName(str){
            if(null != str && str != undefined){
                if (2 == str.length){
                    return str.substring(0, 1)+'*'; //截取name 字符串截取第一个字符，
                } else if (3 == str.length){
                    return str.substring(0, 1)+"*"+str.substring(2, 3); //截取第一个和第三个字符
                } else if (str.length > 3){
                    return str.substring(0, 1)+"*"+'*'+str.substring(3, str.length); //截取第一个和大于第4个字符
                }
            } else {
                return str;
            }
        }

        var doSaveAuthNetOrderInfoWithInvoice=function(){
                    control.showLoading();
                    var params = [netOrderInfoWithInvoice.agenter,
                    netOrderInfoWithInvoice.cert,
                    netOrderInfoWithInvoice.mobile,
                    $rootScope.loginInfo.accountId,
                    netOrderInfoWithInvoice.corpid,
                    netOrderInfoWithInvoice.categoryBh,
                    netOrderInfoWithInvoice.netType,
                    {
                        'letter':netOrderInfoWithInvoice.letter?netOrderInfoWithInvoice.letter:'',
                        'idCardFace':netOrderInfoWithInvoice.idCardFace?"data:image/png;base64,"+netOrderInfoWithInvoice.idCardFace:''
                    },
                     $scope.invoice.header, $scope.invoice.taxNo,'EPASSAPP',netOrderInfoWithInvoice.authId,
                     netOrderInfoWithInvoice.operatorType,
                     $scope.invoice.email
                     ];
                    var successFunc = function(result) {
                        $scope.canClick=false;
                        control.hideLoading();
                        if (result == null || angular.equals({},
                        result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }

                        console.log("doSaveAuthNetOrderInfoWithInvoice :" + JSON.stringify(result));


                        if (result.success) {

        //                    var item = {
                                netOrderInfoWithInvoice.orderNo= result.value.orderNo,
                                netOrderInfoWithInvoice.payType= result.value.payType,
                                netOrderInfoWithInvoice.allFee= result.value.allFee,
        //                        netOrderInfoWithInvoice.entName= $scope.header
        //                    };
                            $state.go('orderInfoConfirm', {
                                orderInfo: netOrderInfoWithInvoice
                            });
                            
                            
                        }
                        if (!result.success) {
                            if (result.hasOwnProperty('value')) {
                                if (null != result.value && result.value.hasOwnProperty('busiHistoryDataJson')) {
                                    let resValueBusi = result.value.busiHistoryDataJson;
                                    if (resValueBusi) {
                                        // 判断是否为同一个人
                                        if (resValueBusi.proxIdNo == $rootScope.loginInfo.idCard) {
                                            if (false == resValueBusi.isDown) {
                                                // 未下载跳转业务管理
                                                $state.go('businessManage', {
                                                    businessManageSearchKey: netOrderInfoWithInvoice.uniscid
                                                });
                                            } else {
                                                // 已下载提示信息
                                                control.showPopup('您已下载该证书，请至【首页-我的证书】中查看', 2000);
                                            }
                                        } else {
                                            // 姓名脱敏
                                            var secName = resValueBusi.proxName;
                                            if (resValueBusi.proxName.length > 1) {
                                                secName = maskName(secName);
                                            }
                                            control.showPopup('证书已被其他用户（' + secName + '）申领下载，同一张证书同时只能一名用户使用', 2000);
                                        }
                                        return;
                                    }
                                }
                            }

                            //$rootScope.OCRFailMsg =result.msg;
                            //$rootScope.OCRFail();
                            control.showPopup(result.msg, 2000);
                        }
                    }

                    var failFunc = function(result) {
                        $scope.canClick=false;
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                    };

                    nativeHelper.doSaveAuthNetOrderInfoWithInvoice({
                        data: params,
                        success: successFunc,
                        fail: failFunc
                    });
        }

//        //实人检测错误提示
//        var detectionError = function(resultMsg) {
//            control.showPopup(resultMsg, 2000);
//        }
//
//        var authLivingFailEvent = function() {
//            var eventCounter = new Object();
//            eventCounter.page = "活体识别失败";
//            MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
//        }
//
//          //采集人脸提示
//          $scope.alert_applicant_info = false;
//          $scope.closeApplicantInfoAlert = function() {
//              $scope.alert_applicant_info = false;
//          }
//            var liveDetectionNum=0;
//            //开始活体检测
//            $scope.startBiopsyClick=function(){
//                $scope.acShowAuthConfirm = true;
//                $scope.alert_applicant_info=false;
//            }
//            var photoData;
//            //人脸识别结果监听
//            var liveDetectionResult = function(res) {
//                $scope.$apply(function() {
//                    if (res.base64PhotoData) {
//                        photoData = res.base64PhotoData;
//                        verifyIdentity.startIdentityAuthenticationAction($rootScope.loginInfo.userName, $rootScope.loginInfo.idCard, photoData, $rootScope.loginInfo.userId, $rootScope.loginInfo.realNameGrade, IdentityAuthenticationRes);
//                    } else {
//                        authLivingFailEvent();
//                        detectionError(res.resultMsg);
//                    }
//                });
//            };
//
//            var startBiopsy = function() {
//                $scope.alert_applicant_info=false;
//                liveDetectionNum++;
//                verifyIdentity.startLiveDetection(liveDetectionResult);
//            }
//
//            $scope.acShowAuthConfirm = false;
//            $scope.acCloseClick = function() {
//                $scope.acShowAuthConfirm = false;
//            }
//            $scope.acIsAgreeApplyAgreement = false;
//            $scope.acAgree = function() {
//                $scope.acIsAgreeApplyAgreement = !$scope.acIsAgreeApplyAgreement;
//            }
//            $scope.acAgreement = function() {
//                var url = window.currentUrl + '/app/ezt/faceAgreement.html';
//                var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
//                cordova.InAppBrowser.open(url, '_blank', operation);
//            }
//            $scope.acNext = function() {
//                if (!$scope.acIsAgreeApplyAgreement) {
//                    control.showPopup("请确认同意《人脸认证功能协议》", 2000);
//                    return;
//                }
//                $scope.acShowAuthConfirm = false;
//                startBiopsy();
//            }
//
//
//            //人脸信息和身份信息对比结果
//            var IdentityAuthenticationRes = function(data) {
//                $scope.$apply(function() {
//                    if (data.result == 'fail') {
//
//                    if (data.authResult == '5XXX' || data.authResult == '6XXX') {
//                          if(!$rootScope.isOpenFaceAuthFail()){
//                             detectionError('姓名或身份证号码有误，错误代码'+data.authResult);
//                          }
//
//                         return;
//                    } else if(data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '02XX'){
//                         if(!$rootScope.isOpenFaceAuthFail()){
//                            detectionError('人脸比对失败，错误代码'+data.authResult);
//                         }
//
//                         return;
//                    } else {
//                      if(!$rootScope.isOpenFaceAuthFail()){
//                        control.showPopup(data.authResultMsg, 2000);
//                      }
//                    }
//
//                    }
//                    if (data.result == 'success') {
//                        $rootScope.setAuthSuccessTime();
//                        //生成付费业务单
//                        doSaveAuthNetOrderInfoWithInvoice();
//                    }
//                });
//            }

                $scope.showBtn=true
                $scope.getBlur=function(){
                    $scope.showBtn=true;
                }
                $scope.getFocus=function(){
                    $scope.showBtn=false;
                }


        $scope.navigate = function(state) {
            nav.goBack();
        };
    }]);
})();
