﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('checkAuthorization', ['$rootScope', '$scope', 'nav', 'control', 'utility', 'validate', 'nativeHelper','$ionicSlideBoxDelegate',  function ($rootScope, $scope, nav, control, utility, validate, nativeHelper,$ionicSlideBoxDelegate) {
            $scope.isShowPhotoRules = false;


            $scope.checkPicture = function (type) {
                var successFunc = function (pic) {
                    control.hideLoading();
                    if(type=="1"){
                        $scope.$apply(function () {
                            $rootScope.autoApplyInfo.authorizationPic = 'data:image/png;base64,'+pic;
                        });
                    }else if(type=="2"){
                        $scope.$apply(function () {
                            $rootScope.autoApplyInfo.serviceProtocolPic = 'data:image/png;base64,'+pic;
                        });
                    }

                };

                var failFunc = function (e) {
                    control.hideLoading();
                };

                control.camera(successFunc, failFunc, false,$rootScope.isDoIdentityVerify);
            }
            $scope.previewPicture = function (type) {
                if(type=="1"){
                    $scope.previewPic = $rootScope.autoApplyInfo.authorizationPic;
                    $scope.isPreviewPicture = true;
                }else if(type=="2"){
                    $scope.previewPic = $rootScope.autoApplyInfo.serviceProtocolPic;
                    $scope.isPreviewPicture = true;
                }
            }
            $scope.cancel = function () {
                $scope.isPreviewPicture = false;
            }

            $scope.next = function () {
                if ($rootScope.autoApplyInfo.authorizationPic == '') {
                    control.showPopup('请上传图片', 2000);
                    return;
                }
                if ($rootScope.autoApplyInfo.serviceProtocolPic == '') {
                    control.showPopup('请上传图片', 2000);
                    return;
                }

                nav.navigate('uploadApplyMaterials');
//                nav.navigate('checkIdentityCard');
            }


            $scope.showPhotoRules = function () {
                $scope.isShowPhotoRules = true;
            }

            $scope.hidePhotoRules = function () {
                $scope.isShowPhotoRules = false;
            }

            $scope.navToTrust = function () {
                $rootScope.entrustTemplateParent = 'checkAuthorization';
                nav.navigate('entrustTemplate');
            }

            $scope.showPic = false;
            $scope.showPicClick = function() {
                $scope.showPic = true;
                $scope.$apply();
            }
            $scope.picClick = function() {
                $scope.showPic = false;
                $scope.$apply();
            }

            $scope.copyText =function(text) {
                var successFunc = function() {
                    control.showPopup('复制成功', 2000);
                }

                var failFunc = function() {
                    control.showPopup('复制失败', 2000);
                }

                nativeHelper.socialAgent({
                    data: [text, 1,''],
                    success: successFunc,
                    fail: failFunc
                });
            }
            var getDate = function(time, day) {
            	time.setDate(time.getDate() + day);
            	var y = time.getFullYear();
            	var m = time.getMonth() + 1;
            	var d = time.getDate();
            	return y + "-" + (m < 10 ? "0" + m: m) + "-" + (d < 10 ? "0" + d: d);
            }

            $scope.copyDownUrl =function() {
                var linkContent = "https://zsfwpt.icinfo.cn/downfile/frzsywblsqwts(zjsw).pdf"
                if($rootScope.isProvinceCert){
                    var linkContent = "https://zsfwpt.icinfo.cn/downfile/frzsywblsqwts(zjs).pdf"
                }
                nativeHelper.socialAgent({
                    data: [linkContent, 1,''],
                    success: () => {
                        control.showPopup('复制成功', 2000);
                    },
                    fail: () => { },
                });
            }
            $scope.downFile =function() {
                control.showLoading();
                var startTime = getDate(new Date(), 0);
                var entTime = getDate(new Date(), 30);
                var params = [
                $rootScope.certUnderwayInfo.corpid,
                $rootScope.certUnderwayInfo.entName,
                $rootScope.loginInfo.userName,
                $rootScope.loginInfo.idCard,
                $rootScope.loginInfo.mobile,
                $rootScope.certUnderwayInfo.netType,
                startTime,
                entTime
                ];
                var successFunc = function(result) {
                    control.hideLoading();
                    if (result == null || angular.equals({},result)) {
                        control.showPopup('服务出错啦', 2000);
                        return;
                    }
                }

                var failFunc = function(error) {
                    control.hideLoading();
                };
                nativeHelper.downloadFileToWX({
                    data: params,
                    success: successFunc,
                    fail: failFunc
                });
            }
            $scope.slideIndex = '1/2';
            $scope.slideChanged = function (index) {
                if(index==0){
                    $scope.slideIndex = '1/2';
                }else{
                    $scope.slideIndex = '2/2';
                }
            };

            $scope.navigate = function (state) {
                nav.navigate(state);
            };
            //区分省内省外协议示例
            if($rootScope.isProvinceCert){
               //省内示例
               $scope.showProvinceimg1 = 'img/pic-example5.jpg';
               $scope.showProvinceimg2 = 'img/pic-example6.jpg';
            }else{
               //省外示例
               $scope.showProvinceimg1 = 'img/pic-example7.jpg';
               $scope.showProvinceimg2 = 'img/pic-example6.jpg';
            }
        }]);
})();