(function () {
    "use strict"
    angular.module('starter')
        .controller('checkIdentityCard', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', 'utility', 'verifyIdentity','$state','localStorage',function ($rootScope, $scope, nav, control, nativeHelper, utility,verifyIdentity,$state,localStorage) {

           if(cordova.platformId==='android'){
                $scope.isAndroid=true;
           }else{
                $scope.isAndroid=false;
           }
           if($rootScope.isDoIdentityVerify){
                $scope.title="法定代表人身份证";
           }else{
                $scope.title="经办人身份证";
           }
        $scope.checkPicture = function (type) {

                var successFunc = function (pic) {
                 control.hideLoading();
                    if(type=="1"){
                     $rootScope.autoApplyInfo.IDCardFrontPic = 'data:image/png;base64,' + pic;
                    }else if(type=="2"){
                      $scope.$apply(function () {
                        $rootScope.autoApplyInfo.IDCardBackPic = 'data:image/png;base64,' + pic;
                      });
                    }
                };

                var failFunc = function (e) {
                 control.hideLoading();
                };

                control.camera(successFunc, failFunc, false,$rootScope.isDoIdentityVerify);
            }

        $scope.previewPicture = function (type) {
            if(type=="1"){
                $scope.previewPic = $rootScope.autoApplyInfo.IDCardFrontPic;
                $scope.isPreviewPicture = true;
            }else if(type=="2"){
                $scope.previewPic = $rootScope.autoApplyInfo.IDCardBackPic;
                $scope.isPreviewPicture = true;
            }
        }
        $scope.cancel = function () {
            $scope.isPreviewPicture = false;
        }
        var OCRFail=function(card_type){
            var OCRFailMsg = '图像识别失败';
                control.showConfirm(OCRFailMsg,
                  function () {
                          return;
                          },
                       function () {
                         $scope.checkPicture(card_type);
                       return;
                          }, "重拍", "取消", 'cusClass');
                }

            var checkIdentityCard = function (image, card_type) {
                control.showLoading();
                var timeout = setTimeout(function () {
                    var time_stamp = Date.parse(new Date()).toString().substr(0, 10);
                    var nonce_str = utility.randomStr(true, 3, 32);
                    var sign = utility.getReqSign({
                        app_id: $rootScope.configInfo.ocrAppId,
                        time_stamp: time_stamp,
                        nonce_str: nonce_str,
                        image: image,
                        card_type: card_type
                    });
                    var params = [ image, card_type];
                    var successFunc = function (result) {
                        clearTimeout(timeout)
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            return;
                        }

                        if (result.retcode == "0") {
                            if (card_type == "1") {
                                $scope.$apply(function () {
                                    var pic =  image
                                    $rootScope.autoApplyInfo.IDCardFrontPic = 'data:image/png;base64,' + pic;
                                    $scope.checkIdentityCard.IDCardName = result.retvalue.name.replace(/\s+/g, '');
                                    $scope.checkIdentityCard.IDCardNumber = result.retvalue.cardno.replace(/\s+/g, '');
                                });
                            }
                            else {
                                $scope.$apply(function () {
                                    var pic =  image
                                    $rootScope.autoApplyInfo.IDCardBackPic = 'data:image/png;base64,' + pic;
                                    $rootScope.autoApplyInfo.IDCardIndate = result.retvalue.deadline.replace(/\s+/g, '');
                                });
                            }
                        }
                        else {
                            //$rootScope.OCRFailMsg = result.msg;
//                            $rootScope.OCRFailMsg = '图像识别失败，请重试';
//                            $rootScope.OCRFail();
//                                OCRFail(card_type);
                        }
                    }

                    var failFunc = function (result) {
                        clearTimeout(timeout)
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                    };

                    nativeHelper.checkIdentityCard({ data: params, success: successFunc, fail: failFunc });
                }, 500);
            };



//            var showAuthResult = function (e) {
//                if (cordova.platformId === 'ios' && e.ytErrorcode == 'back') return;
//                $scope.$apply(function () {
//                    if (e.ytErrorcode == "0") {
//                        doSaveAutoAuditNetOrderInfo();
//                    } else {
//                        control.showPopup(e.ytErrormsg, 2000);
//                    }
//                });
//            };
//
//            window.broadcaster.addEventListener("showAuthResult", showAuthResult);
//            var navToAuthView = function () {
//                var params = [
//                    $rootScope.autoApplyInfo.IDCardName,
//                    $rootScope.autoApplyInfo.IDCardNumber,
//                    $rootScope.loginInfo.mobile,
//                    $rootScope.loginInfo.userId,
//                    'showAuthResult',
//                ];
//                var successFunc = function (result) {
//
//                }
//                var failFunc = function (result) {
//                    control.showPopup(result.msg, 2000);
//                };
//
//                nativeHelper.navToAuthView({ data: params, success: successFunc, fail: failFunc });
//            }

            $scope.remake=function(){
                $rootScope.autoApplyInfo.IDCardFrontPic='',
                $rootScope.autoApplyInfo.IDCardBackPic='',
                $rootScope.autoApplyInfo.IDCardName='',
                $rootScope.autoApplyInfo.IDCardNumber=''
            }

            $scope.checkIdentityCard={IDCardName:$rootScope.loginInfo.userName?$rootScope.loginInfo.userName:'',IDCardNumber:$rootScope.loginInfo.idCard?$rootScope.loginInfo.idCard:''}
            $scope.inputable=false;//默认允许输入框可输入
            if($rootScope.loginInfo.userName){
                $scope.inputable=true;
            }
            //采集人脸提示
//            $scope.alert_applicant_info=false;
            $scope.next = function () {
                if ($rootScope.autoApplyInfo.IDCardFrontPic == '' || $rootScope.autoApplyInfo.IDCardBackPic == '') {
                    control.showPopup("请上传身份证正反面", 2000);
                    return;
                }


                if ($scope.checkIdentityCard.IDCardName == '') {
                    control.showPopup("姓名错误请修改", 2000);
                    $scope.isClicked = false;
                    return;
                }

                if ($scope.checkIdentityCard.IDCardNumber == '') {
                    control.showPopup("身份证号码错误请修改", 2000);
                    return;
                }
                if($scope.checkIdentityCard.IDCardNumber.length===17){
                    $scope.checkIdentityCard.IDCardNumber+="X";
                }

                if($rootScope.autoApplyInfo.IDCardIndate)
                var expireDate = $rootScope.autoApplyInfo.IDCardIndate;
                expireDate = expireDate + ' 23:59:59';
                expireDate = new Date(expireDate);
                if (expireDate < new Date()) {
                    $rootScope.OCRFailMsg = '身份证过期，请重新上传';
                    $rootScope.OCRFail();
                    $scope.isClicked = false;
                    return;
                }



                    $rootScope.autoApplyInfo.IDCardName=$scope.checkIdentityCard.IDCardName;
                    $rootScope.autoApplyInfo.IDCardNumber=$scope.checkIdentityCard.IDCardNumber;
//                    /**
//                     * 判断是否收费控制生成业务单流程
//                     **/
//                 if ($rootScope.certUnderwayInfo.businessCode === 'P012' && !$rootScope.certUnderwayInfo.isFree) {
//                     nav.navigate('autoApplyInvoice');
//                     return;
//                 }
                   nav.navigate('uploadApplyMaterials');

//                 doSaveAutoAuditNetOrderInfo();

         }

         $rootScope.autoApplyInfo.facePassState='0';


         $scope.showPhotoRules = function() {
             $scope.isShowPhotoRules = true;
         }

         $scope.hidePhotoRules = function() {
             $scope.isShowPhotoRules = false;
         }

         $scope.navigate = function(state) {
             nav.navigate(state);
         };

        $scope.showPic = false;
        $scope.showPicClick = function() {
            $scope.showPic = true;
        }
        $scope.picClick = function() {
            $scope.showPic = false;
        }
        }]);
})();
