(function () {
    "use strict"
    angular.module('starter')
        .controller('mailPayInvoice', ['$rootScope', '$scope', 'nav'
            , 'control', 'nativeHelper', '$state', 'verifyIdentity','localStorage','validate',function ($rootScope, $scope, nav, control,
                nativeHelper, $state,verifyIdentity,localStorage,validate) {
        var facePassState = '1';
        var photoData='';

        $scope.invoice = {
            header: $rootScope.certUnderwayInfo.entName,
            taxNo: $rootScope.certUnderwayInfo.uniscid,
            email: ''
        }
        $scope.certInfo = {
            entName: $rootScope.certUnderwayInfo.entName.replace(/\(副本.*?\)/g,''),
            uniscid: $rootScope.certUnderwayInfo.uniscid,
            type: "证书新领"
        }

        $scope.$watch('invoice.header', function(newValue, oldValue) {
            console.log($scope.invoice.header);
            //当value改变时执行的代码
            $scope.invoice.header = newValue
            if(newValue==''){
                 $scope.invoice.taxNo = ''
            }
        });

        $scope.$watch('invoice.taxNo', function(newValue, oldValue) {
            console.log($scope.invoice.taxNo);
            $scope.invoice.taxNo = newValue
            if(newValue==''){
                $scope.invoice.header = ''
            }
        });
        //生成申领业务单
        $scope.confirmInvoice = function(header, taxNo,email) {

            if (header == '') {
                control.showPopup("发票抬头不能为空", 2000);
                return;
            }
            if (taxNo == '') {
                control.showPopup("统一信用代码不能为空", 2000);
                return;
            }
             if (email != ''&& !validate.email(email)) {
                control.showPopup("邮箱名称格式不符,请确认邮箱名称是否正确", 2000);
                return;
            }

            $scope.invoice.header=header;
            $scope.invoice.taxNo=taxNo;
            $scope.invoice.email=email;

            facePassState = '1';
            doSaveNoAuthNetOrderInfoWithInvoice();

        }

        //  邮寄领证生成付费业务单
        var doSaveNoAuthNetOrderInfoWithInvoice = function () {
            control.showLoading();
            var params = [
                  $rootScope.loginInfo.mobile,
                  $rootScope.loginInfo.accountId,
                  $rootScope.certUnderwayInfo.categoryBh,
                  '5',
                  $rootScope.certUnderwayInfo.netType,
                  $rootScope.certUnderwayInfo.corpid,
                '0',
                $scope.invoice.header,
                $scope.invoice.taxNo,
                $scope.invoice.email,
                '1', //人脸识别是否通过状态：0通过，1不通过
                $rootScope.loginInfo.userName?$rootScope.loginInfo.userName:'',
                $rootScope.loginInfo.idCard?$rootScope.loginInfo.idCard:''
            ];
              var successFunc = function (result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                    result)) {
                    control.showPopup('服务出错啦', 2000);
                    return;
                }
                if (result.success) {
                    var item = {
                        orderNo: result.value.orderNo,
                        payType: result.value.payType,
                        allFee: result.value.allFee,
                        entName: $scope.invoice.header,
                        lastPage: 'mailPayInvoice',
                        facePassState: facePassState
                    };
                    $state.go('orderDetails', {
                        orderInfo: item
                    });
                }
                if (!result.success) {
                    control.showPopup(result.msg, 2000);
                }
            }

            var failFunc = function (result) {
                control.hideLoading();
                control.showPopup(result.msg, 2000);
            };

            nativeHelper.doSaveNoAuthNetOrderInfoWithInvoice({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }


            
          $scope.showBtn=true
          $scope.getBlur=function(){
              $scope.showBtn=true;
          }
          $scope.getFocus=function(){
              $scope.showBtn=false;
          }




        $scope.navigate = function(state) {
            nav.navigate(state);
        };
   }]);
})();
