(function () {
    "use strict"
    angular.module('starter')
        .controller('uploadApplyMaterials', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', '$state', '$filter','localStorage', '$ionicHistory','verifyIdentity',
        function ($rootScope, $scope, nav, control, nativeHelper, $state, $filter,localStorage, $ionicHistory,verifyIdentity) {

        $scope.uploadPic = function(state){
            if(state=='1'){
                if ($rootScope.certApplyNoticeParent == 'businessManage' && $rootScope.autoApplyInfo.businessLicensePic =='1') {
                  return
                }
                nav.navigate('checkBusinessLicense')
            }else if(state=='2'){
                if ($rootScope.certApplyNoticeParent == 'businessManage' && $rootScope.autoApplyInfo.IDCardFrontPic == '1' && $rootScope.autoApplyInfo.IDCardBackPic == '1') {
                  return
                }
                nav.navigate('checkIdentityCard')
            }else if(state=='3'){
                if ($rootScope.certApplyNoticeParent == 'businessManage' && $rootScope.autoApplyInfo.authorizationPic == '1' && $rootScope.autoApplyInfo.serviceProtocolPic == '1') {
                   return
                }
                nav.navigate('checkAuthorization')
            }
        }
        $scope.submit = function(){
            control.showLoading();
            if($rootScope.autoApplyInfo.businessLicensePic == ''||$rootScope.autoApplyInfo.IDCardFrontPic == ''||$rootScope.autoApplyInfo.IDCardBackPic == ''){
                control.hideLoading();
                return
            }
            if($rootScope.isDoIdentityVerify&&$rootScope.certApplyNoticeParent == 'doIdentityVerifyToUploadPic'){
                setTimeout(() => {
                   doSaveIdentityVerifyOrder()
                }, 1000);
                return
            }
            if($rootScope.autoApplyInfo.authorizationPic == ''||$rootScope.autoApplyInfo.serviceProtocolPic == ''){
                control.hideLoading();
                return
            }
            //判断是否是资料更新
            if($rootScope.certApplyNoticeParent == 'businessManage'){
                setTimeout(() => {
                   submitMaterialUpload();
                }, 1000);
                return
            }
            if($rootScope.autoApplyInfo.orderNo != null&&$rootScope.autoApplyInfo.orderNo != ''&&$rootScope.autoApplyInfo.orderNo != undefined){
                // 材料付费业务单 提交材料
                setTimeout(() => {
                   submitMaterial();
                }, 1000);
            }else{
                // 材料免费业务单
                setTimeout(() => {
                   doSaveAutoAuditNetOrderInfo();
                }, 1000);
            }
            var eventCounter = new Object();
            eventCounter.page = "材料领证-上传领证材料页面-提交";
            MobclickAgent.onEventWithParameters("materialCertificationSubmitEvent", eventCounter);
        }
        $scope.navigate = function (state) {
            nav.navigate(state);
        };

        //生成业务单
        var doSaveAutoAuditNetOrderInfo = function() {
        	//control.showLoading();
        	var params = [
        	     $rootScope.autoApplyInfo.IDCardName,
        	     $rootScope.autoApplyInfo.IDCardNumber,
        	     $rootScope.loginInfo.mobile,
        	     $rootScope.loginInfo.accountId,
        	     $rootScope.certUnderwayInfo.categoryBh,
        	     $rootScope.certUnderwayInfo.businessCode,
        	     '5',
        	     $rootScope.certUnderwayInfo.netType,
        	     $rootScope.certUnderwayInfo.entName,
        	     $rootScope.certUnderwayInfo.uniscid,
        	     $rootScope.certUnderwayInfo.corpid,
        	     {
        		    businessLicense: $rootScope.autoApplyInfo.businessLicensePic,
        		    letter: $rootScope.autoApplyInfo.authorizationPic,
        		    letter2: $rootScope.autoApplyInfo.serviceProtocolPic,
        		    idCardFace: $rootScope.autoApplyInfo.IDCardFrontPic,
        		    idCardBack: $rootScope.autoApplyInfo.IDCardBackPic,
        		    faceBase64: $rootScope.photoData == '' ? $rootScope.photoData: "data:image/png;base64," + $rootScope.photoData
        	    },
                '0', //是否通过ocr校验0：不通过，1：已通过
                '0' //人脸识别是否通过状态：0通过，1不通过
        	];
        	var successFunc = function(result) {
        		control.hideLoading();
        		if (result == null || angular.equals({},
        		result)) {
        			control.showPopup('服务出错啦', 2000);
        			return;
        		}
        		if (result.success) {
        			//订单号
        			$scope.$apply(function() {
        				$rootScope.curAutoApplyOrderNo = result.value.orderNo;
        				$state.go('businessCompleted', {
        					orderNo: result.value.orderNo,
        					sourceType:"2"
        				});
        			});
        		} else {
        			$rootScope.OCRFailMsg = result.msg;
        			$rootScope.OCRFail();
        		}
        	}
        	var failFunc = function(result) {
        		control.hideLoading();
        		control.showPopup(result.msg, 2000);
        	};
        	nativeHelper.doSaveAutoAuditNetOrderInfo({
        		data: params,
        		success: successFunc,
        		fail: failFunc
        	});
        };

        //材料付费上传资料
        var submitMaterial = function() {

        	//control.showLoading();
        	var params = [
        	    $scope.autoApplyInfo.IDCardFrontPic,
        	    $scope.autoApplyInfo.IDCardBackPic,
        	    $scope.autoApplyInfo.businessLicensePic,
        	    $scope.autoApplyInfo.authorizationPic,
        	    $rootScope.autoApplyInfo.orderNo,
        	    $rootScope.photoData == '' ? $rootScope.photoData: "data:image/png;base64," + $rootScope.photoData,
        	    '0',
        	     $scope.autoApplyInfo.serviceProtocolPic
        	];
        	var successFunc = function(result) {
        		control.hideLoading();
        		if (result == null || angular.equals({},
        		result)) {
        			control.showPopup('服务出错啦', 2000);
        			return;
        		}
        		if (result.success) {
        			$scope.$apply(function() {
        				$state.go('businessCompleted', {
        					orderNo: $rootScope.autoApplyInfo.orderNo,
        					sourceType:"1"
        				});

        			});
        		}
        		if (!result.success) {
        			control.showPopup(result.msg, 2000);
        		}
        	}

        	var failFunc = function(result) {
        		control.hideLoading();
        		control.showPopup(result.msg, 2000);
        	};

        	nativeHelper.submitMaterialPic({
        		data: params,
        		success: successFunc,
        		fail: failFunc
        	});
        };

        //业务管理更新资料  获取审核结果数据
        var doGetNetMarkAuditDetail = function () {

            control.showLoading();
            var params = [$rootScope.curBusinessInfo.orderNo];
            var successFunc = function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals({}, result)) {
                        control.showPopup('服务出错啦', 3000);
                        return;
                    }
                    if (result.success) {
                       //根据列表中缺少的资料，设置已经审核通过的资料数据为1 不需要重新上传
                        if (result.value.auditNotpassType.includes("businessLicense")) {
                             $rootScope.autoApplyInfo.businessLicensePic="";
                        }else{
                             $rootScope.autoApplyInfo.businessLicensePic="1";
                        }
                        if (result.value.auditNotpassType.includes("letter")) {
                              $rootScope.autoApplyInfo.authorizationPic="";
                        }else{
                              $rootScope.autoApplyInfo.authorizationPic="1";
                        }
                        if (result.value.auditNotpassType.includes("letter2")) {
                              $rootScope.autoApplyInfo.serviceProtocolPic="";
                        }else{
                              $rootScope.autoApplyInfo.serviceProtocolPic="1";
                        }
                        if (result.value.auditNotpassType.includes("idCardFace")) {
                              $rootScope.autoApplyInfo.IDCardFrontPic="";
                        }else{
                              $rootScope.autoApplyInfo.IDCardFrontPic="1";
                        }
                        if (result.value.auditNotpassType.includes("idCardBack")) {
                              $rootScope.autoApplyInfo.IDCardBackPic="";
                        }else{
                              $rootScope.autoApplyInfo.IDCardBackPic="1";
                        }

                        //审核不通过原因
                        $rootScope.autoApplyInfo.picErrorMsg=result.value.opioin+"";
                    }
                    if (!result.success) {
                        $rootScope.autoApplyInfo.businessLicensePic="";
        		        $rootScope.autoApplyInfo.authorizationPic="";
        		        $rootScope.autoApplyInfo.serviceProtocolPic="";
        		        $rootScope.autoApplyInfo.IDCardFrontPic="";
        		        $rootScope.autoApplyInfo.IDCardBackPic="";
                    }
                }

            var failFunc = function (result) {
                control.hideLoading();
                control.showPopup(result.msg, 3000);
            };

            nativeHelper.doGetNetMarkAuditDetail({ data: params, success: successFunc, fail: failFunc });
        };

        //从业务管理页面进入，继续办理、更新资料
        if ($rootScope.certApplyNoticeParent == 'businessManage' && $rootScope.autoApplyInfo.needGetInfo =='true') {
           //请求一次之后，从上传图片页面进入不再请求接口
           $rootScope.autoApplyInfo.needGetInfo=''
            doGetNetMarkAuditDetail();
        }
        //区分省内和省外证书  默认省内证书
        $rootScope.isProvinceCert =true;
        $rootScope.isDoIdentityVerify = false;
        //区分从业务管理更新资料进入 title显示更新资料  材料领证进入title显示上传领证材料
        if ($rootScope.certApplyNoticeParent == 'businessManage') {
            if($rootScope.certUnderwayInfo.businessCode=='TS03'){
                $scope.title='上传核验材料';
                $rootScope.isDoIdentityVerify = true;
            }else{
                $scope.title='更新资料';
                if($rootScope.curBusinessInfo.entProvince=='FZJS'){
                    $rootScope.isProvinceCert =false;
                }else{
                     $rootScope.isProvinceCert =true;
                }
            }

        }else if ($rootScope.certApplyNoticeParent == 'doIdentityVerifyToUploadPic') {
            $scope.title='上传核验材料';
            $rootScope.isDoIdentityVerify = true;
        }else{
            $scope.title='上传领证材料';
            if($rootScope.certUnderwayInfo.entProvince=='FZJS'){
                 $rootScope.isProvinceCert =false;
            }else{
                 $rootScope.isProvinceCert =true;
            }
        }

        //资料更新 材料提交
        var submitMaterialUpload = function () {
             //根据列表中缺少的资料，重新上传
               // control.showLoading();
                var params = [
                    $rootScope.autoApplyInfo.IDCardFrontPic!=='1' ? $rootScope.autoApplyInfo.IDCardFrontPic : '',
                    $rootScope.autoApplyInfo.IDCardBackPic!=='1' ? $rootScope.autoApplyInfo.IDCardBackPic : '',
                    $rootScope.autoApplyInfo.businessLicensePic!=='1' ? $rootScope.autoApplyInfo.businessLicensePic : '',
                    $rootScope.autoApplyInfo.authorizationPic!=='1' ? $rootScope.autoApplyInfo.authorizationPic : '',
                    $rootScope.curBusinessInfo.orderNo,
                    '',
                    $rootScope.curBusinessInfo.facePassState,
                    $rootScope.autoApplyInfo.serviceProtocolPic!=='1' ? $rootScope.autoApplyInfo.serviceProtocolPic : '',
                ];

                var successFunc = function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals({}, result)) {
                        control.showPopup('服务出错啦', 2000);
                        return;
                    }
                    if (result.success) {
                        $scope.$apply(function () {
                         if($rootScope.isDoIdentityVerify){
                              $state.go('businessCompleted',{
                                orderNo:$rootScope.curBusinessInfo.orderNo,
                                sourceType:"2"
                              });
                         }else if ($rootScope.curBusinessInfo.facePassState === '0'||$rootScope.curBusinessInfo.facePassState==null) {
                              $state.go('businessCompleted',{
                                orderNo:$rootScope.curBusinessInfo.orderNo,
                                sourceType:"1"
                              });
                         } else
                            $state.go('postIntroduction',{orderNo:$rootScope.curBusinessInfo.orderNo});
                        });
                    }
                    if (!result.success) {
                        control.showPopup(result.msg, 2000);
                    }
                }

                var failFunc = function (result) {
                    control.hideLoading();
                    control.showPopup(result.msg, 2000);
                };
                nativeHelper.submitMaterialPic({ data: params, success: successFunc, fail: failFunc });
        };

        // 法定代表人申领 核验身份的材料提交审核
        var doSaveIdentityVerifyOrder = function () {
                var params = [
                    $rootScope.loginInfo.userName,
                    $rootScope.loginInfo.idCard,
                    $rootScope.loginInfo.mobile,
                    $rootScope.loginInfo.accountId,
                    $rootScope.certUnderwayInfo.corpid,
                    $rootScope.certUnderwayInfo.categoryBh,
                    $rootScope.autoApplyInfo.businessLicensePic!=='1' ? $rootScope.autoApplyInfo.businessLicensePic : '',
                    $rootScope.autoApplyInfo.IDCardFrontPic!=='1' ? $rootScope.autoApplyInfo.IDCardFrontPic : '',
                    $rootScope.autoApplyInfo.IDCardBackPic!=='1' ? $rootScope.autoApplyInfo.IDCardBackPic : ''
                ];

                var successFunc = function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals({}, result)) {
                        control.showPopup('服务出错啦', 2000);
                        return;
                    }
                    if (result.success) {
                        console.log("result="+JSON.stringify(result))
                        $scope.$apply(function () {
                            $state.go('businessCompleted',{
                                orderNo:result.value,
                                sourceType:"2"
                            });
                        });
                    }
                    if (!result.success) {
                        control.showPopup(result.msg, 2000);
                    }
                }

                var failFunc = function (result) {
                    control.hideLoading();
                    control.showPopup(result.msg, 2000);
                };
                nativeHelper.doSaveIdentityVerifyOrder({ data: params, success: successFunc, fail: failFunc });
        };
    }]);
})();
