﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('certDetail', ['$rootScope', '$scope', 'nav','$stateParams', 'control', 'nativeHelper', 'validate', '$state', 'requestWrapper', 'md5', 'utility',
            function ($rootScope, $scope, nav, $stateParams, control, nativeHelper, validate, $state,requestWrapper,md5, utility) {
            //console.log("证书详情："+JSON.stringify($rootScope.curManagedCert));
            /*扫码使用*/
            $scope.scanFunc = function (){
                var eventCounter = new Object();
                eventCounter.page = "证书详情-立即使用";
                MobclickAgent.onEventWithParameters("certDetailUseEvent", eventCounter);
                //证书详情扫码不跳原来列表，当前页直接使用证书
                $rootScope.scanFromCertDetail = true;
                var params = [];
                var successFunc = function (result) {
                    }
                var failFunc = function (error) {
                       control.showPopup(error.msg, 2000);
                    };
                nativeHelper.navToScanView({ data: params, success: successFunc, fail: failFunc });
            }
            // 校验二维码是否可用
            var checkAppCanScanQrcode = function () {
                    control.showLoading();
                    var time = utility.getCurrentTime();
                    var hashdata = utility.sm3HashBase64('eztAppIos' + time + '182789798kljdskljfls887834783279');
                    var params = {
                        "appid": 'eztAppIos',
                        "time": time,
                        "hashdata": hashdata,
                        "app": "ezt",
                        "businessAppId": $rootScope.curQRCodeInfo.businessAppId
                    };
                    requestWrapper.checkAppCanScanQrcode({data: params, refresh: true})
                        .then(function (result) {
                            control.hideLoading();
                            if (result == null || angular.equals({}, result)) {
                                control.showPopup('服务出错啦', 2000);
                                return;
                            };
                            if ("success" == result.rslt) {
                                if (true == result.data.isAuth) {
                                    //有效二维码
                                    filterCert();
                                } else {
                                    control.showAlert1(result.data.falseMsg, function() {
                                        nav.navigate('tab/home');
                                    });
                                }
                            } else {
                                control.showPopup(result.msg, 2000);
                            }

                        })
                        .catch(function (e) {
                            control.hideLoading();
                            control.showPopup('网络请求失败：' + e.status, 3000);
                        });
                }
            var filterCert=function(){
                    //校彩云证书只能用于校彩云平台  appid:xcytbkhd
                    if($rootScope.curQRCodeInfo.businessAppId == 'xcytbkhd'){
                        if($rootScope.curManagedCert.certType.indexOf('校采云') == -1){
                           control.showPopup('您的证书和二维码不匹配', 2000);
                           return;
                        }
                    }else{
                        if($rootScope.curManagedCert.certType.indexOf('校采云') != -1){
                           control.showPopup('您的证书和二维码不匹配', 2000);
                            return;
                        }
                    }

                    if ($rootScope.curQRCodeInfo.type === 'decrypt' || $rootScope.curQRCodeInfo.type === 'mutildec') {
                        var reqData = $rootScope.curQRCodeInfo.reqData.replace(/\\/g,'');
                        var reqDataJson = JSON.parse(reqData);
                        var isVaild = false
                        reqDataJson.forEach(function(r){
                            if ($rootScope.curManagedCert.encSerialNum === r.certsn) {
                                isVaild=true;
                            }else{
                                if($rootScope.curManagedCert.uniscid === r.uniscid){
                                    isVaild=true;
                                }
                            }
                        })
                        if(!isVaild){
                            control.showPopup('证书不匹配', 2000);
                             return;
                        }
                        //证书匹配成功
                        selectCert($rootScope.curManagedCert);
                    }else if(!isEmpty($rootScope.curQRCodeInfo.certSn) &&($rootScope.curQRCodeInfo.type === 'sign' || $rootScope.curQRCodeInfo.type === 'mutilSign')){
                        if ($rootScope.curQRCodeInfo.certSn.indexOf($rootScope.curManagedCert.serialNum) == -1) {
                             control.showPopup('证书不匹配', 2000);
                              return;
                        }
                        //证书匹配成功
                        selectCert($rootScope.curManagedCert);
                    }else{
                        //证书匹配成功
                        selectCert($rootScope.curManagedCert);
                    }
                }
            var selectCert = function (curCert) {
                    if (curCert.SDKVersion !== "V2") {
                        control.showConfirm4('html/home/SDKVersionAlert.html', "特别提醒",
                        function() {
                            $scope.navigate("businessManage");
                            return;
                        },
                        function() {},
                        "取消", "去业务管理", 'cusClassTbtx');
                        return;
                    }

                    if($rootScope.curQRCodeInfo.type != 'decrypt' && !curCert.isValid){
                        control.showPopup('证书已失效', 2000);
                        return;
                    }

                    //判断二维码的证书序列号是否与选中的匹配
                    if ($rootScope.curQRCodeInfo.certSn && $rootScope.curQRCodeInfo.certSn !== '' && !$rootScope.curQRCodeInfo.certSn.indexOf(curCert.serialNum) == -1) {
                        control.showPopup('证书匹配失败', 2000);
                        return;
                    }
                        //V3.0.0版本去除前端判断证书在莫应用能否使用，使用后台判断
                        judgeCertAllowUseRange(curCert);
                }
            // 判断证书在某应用是否能使用
            var judgeCertAllowUseRange = function (curCert) {
                    control.showLoading();
                    /**
                     * appid         签章平台分配给招标平台的id
                     * time          时间戳，当前时间年月日时分秒 20091010121212
                     * hashdata      (appid+time+secret)将资源接入代码、发送时间、业务密钥按顺序连接并进行md5加密。
                     * certSn        签名证书序号
                     * businessAppId 二维码应用编号
                     */
                    var params = [curCert.serialNum, $rootScope.curQRCodeInfo];

                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result.success) {
                            //V2.9.7版本新增字段，用于跳转我的证书页面过啦证书
                            $rootScope.deleteCertSnfromPopup = curCert.serialNum;
                            $rootScope.localCert = { useCertPwd: '' };
                            control.showCustomPopup('html/home/popupUseCertFromCertDetail.html', '', '取消', '确认', 'popup-btn-default', 'popup-btn-light', function () { return; }, function () {
                                confirmPwd(curCert);
                            });
                        } else {
                            control.showPopup(result.msg, 2000);
                        }
                    };

                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                    };

                    setTimeout(function () {
                        nativeHelper.certAllowUseRange({ data: params, success: successFunc, fail: failFunc });
                    }, 1000);
                }
            var confirmPwd = function (curCert) {
                    if (!validate.certPassword($rootScope.localCert.useCertPwd)) {
                        control.showPopup('请输入6位数字密码', 2000);
                        return;
                    }

                    if ($rootScope.localCert.useCertPwd !== curCert.password) {
                        control.showPopup("证书密码不正确！", 2000);
                        return;
                    }

                    control.showLoading();
                    signEvent();//监听扫码签名

                    //param1:二维码扫描结果
                    //param2:选中证书对应的容器
                    //param3:证书base64,与对应容器里到处的校验下是否一致
                    //param4:用户输入的证书使用密码（容器PIN码）
                    var params = [$rootScope.curQRCodeInfo, curCert.containerName, curCert.certContent, $rootScope.localCert.useCertPwd,curCert.SDKVersion, $rootScope.loginInfo.userName, $rootScope.loginInfo.idCard, curCert.serialNum, curCert.encSerialNum,$rootScope.loginInfo.accountId,$rootScope.loginInfo.mobile,curCert.uniscid,curCert.CN];
                    console.log(params)
                    var successFunc = function (result) {
                        $rootScope.localCert = { useCertPwd: '' };
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }

                        signUploadEvent();//上传监听

                        if (result.rslt == 'success') {
                            if($rootScope.curQRCodeInfo.versions=="3"&&$rootScope.curQRCodeInfo.openSign=="1"){
                                $state.go('signCompleted',{cert:curCert});
                                return;
                            }else{
                                control.showPopup('扫码操作成功', 2000);
                            }
                        }
                        else {
                            if(result.errorMsg.includes("签名验证失败")){
                                control.showPopup(result.errorMsg + "，请重新下载证书后重试！", 2000);
                            }else{
                                control.showPopup(result.errorMsg, 2000);
                            }
                        }

                         nav.navigate('tab/home');
                    };

                    var failFunc = function (result) {
                        control.hideLoading();
                        if(result.errorMsg.includes("签名验证失败")){
                            control.showPopup(result.errorMsg+"请重新下载证书后重试！", 2000);
                            requestWrapper.sendMesToDingTalk("密码模块错误","扫码上传",result.alarmMsg+"请重新下载证书后重试！")
                        }else{
                            control.showPopup(result.errorMsg, 2000);
                            requestWrapper.sendMesToDingTalk("密码模块错误","扫码上传",result.alarmMsg)
                        }
                    };

                    setTimeout(function () {
                        nativeHelper.uploadinfo({ data: params, success: successFunc, fail: failFunc });
                    }, 1000);
                }
            var showUploadMsg = function (e) {
                control.showPopup(e.msg, 2000);
            }

            window.broadcaster.addEventListener("showUploadMsg", showUploadMsg);

            var signEvent = function() {
                    var eventCounter = new Object();
                    eventCounter.page = "扫码签名";
                    MobclickAgent.onEventWithParameters("signEvent", eventCounter);
                }
            var signUploadEvent = function() {
                    var eventCounter = new Object();
                    eventCounter.page = "签名上传";
                    MobclickAgent.onEventWithParameters("signUploadEvent", eventCounter);
                }
            var isEmpty = function(obj){
                    if(typeof obj == "undefined" || obj == null || obj == ""){
                        return true;
                    }else{
                        return false;
                    }
                }
            //扫码成功返回详情页
            $scope.$watch('certDetailScanResult', function(newValue, oldValue) {
               console.log($rootScope.certDetailScanResult);
                if(newValue=='true'){
                    $rootScope.certDetailScanResult="false";
                    checkAppCanScanQrcode();
                }
            });

            }]);
})();