(function () {
    "use strict"
    angular.module('starter')
        .controller('showLocalCertList', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', 'validate', '$filter','$state', 'utility', 'requestWrapper',
            function ($rootScope, $scope, nav, control, nativeHelper, validate, $filter,$state,utility,requestWrapper) {
                //初始化弹框中输入框数据
                $rootScope.localCert = { useCertPwd: '' };
                $scope.searchInfo = { key: '' };
                $scope.showList = false;
                $scope.showLocalCertList = [];
                $scope.zcyCertTip = "提示:可登录政采云平台在【CA管理-CA证书】功能下进行申领";

                var isEmpty = function(obj){
                    if(typeof obj == "undefined" || obj == null || obj == ""){
                        return true;
                    }else{
                        return false;
                    }
                }

                var getDate=function(date) {
                    var time=new Date(date)
                    time.setDate(time.getDate());
                    var y = time.getFullYear()-1;
                    var m = time.getMonth() + 1;
                    var d = time.getDate();
                    return y + "-" + (m<10?"0"+m:m) + "-" + (d<10?"0"+d:d);
                }

                var getCertList = function () {
                    var params = [$rootScope.loginInfo.accountId];
                    var successFunc = function (result) {
                        if (result == null || angular.equals({}, result)) {
                            $rootScope.localCertList = [];
                            return;
                        } else {
                            $rootScope.localCertList = result;
                            console.log('cert :'+JSON.stringify($rootScope.localCertList));
                            if ($rootScope.localCertList.length > 0){
                                filterCert()
                            }else{
                                checkZcyCertApplyWay();
                            }
                        }
                    }

                    var failFunc = function (e) {

                    };

                    nativeHelper.getLocalCertList({ data: params, success: successFunc, fail: failFunc });
                }

                var filterCert=function(){
                    var certSnList = [];
                    $scope.validLocalCertList=[];

                    //校彩云证书只能用于校彩云平台  appid:xcytbkhd
                    var temList = [];
                    if($rootScope.curQRCodeInfo.businessAppId == 'xcytbkhd'){
                        // for(var i = 0; i < $rootScope.localCertList.length; i++){
                        //     if($rootScope.localCertList[i].certType.indexOf('校采云') == -1){
                        //         $rootScope.localCertList.splice(i, 1);
                        //     }
                        // }
                        $rootScope.localCertList.forEach(v=>{
                            if(v.certType.indexOf('校采云') != -1){
                                temList.push(v);
                            }
                        })
                    }else{
                        $rootScope.localCertList.forEach(d=>{
                            if(d.certType.indexOf('校采云') == -1){
                                temList.push(d);
                            }
                        })
                    }
                    $rootScope.localCertList = temList;
                    if ($rootScope.curQRCodeInfo.type === 'decrypt' || $rootScope.curQRCodeInfo.type === 'mutildec') {
                        var reqData = $rootScope.curQRCodeInfo.reqData.replace(/\\/g,'');
                        var reqDataJson = JSON.parse(reqData);
                        reqDataJson.forEach(function(r){
                            $rootScope.localCertList.forEach(function(l){
                                if (l.encSerialNum === r.certsn) {
                                    certSnList.push(l.serialNum);
                                    $scope.validLocalCertList.push(l);
                                }else{
                                    if(l.uniscid === r.uniscid){
                                        certSnList.push(l.serialNum);
                                        $scope.validLocalCertList.push(l);
                                    }
                                }
                            })
                        })
                        getCertValidity(certSnList);
                    }else if(!isEmpty($rootScope.curQRCodeInfo.certSn) &&($rootScope.curQRCodeInfo.type === 'sign' || $rootScope.curQRCodeInfo.type === 'mutilSign')){
                        $rootScope.localCertList.forEach(function(l){
                            if ($rootScope.curQRCodeInfo.certSn.indexOf(l.serialNum) != -1) {
                                certSnList.push(l.serialNum);
                                $scope.validLocalCertList.push(l);
                            }
                        })
                        getCertValidity(certSnList);
                    }else {
                        $scope.validLocalCertList = angular.copy($rootScope.localCertList);
                        $rootScope.localCertList.forEach(function(v) {
                            certSnList.push(v.serialNum);
                        });
                        getCertValidity(certSnList);
                    }
                }

                let certCount = 10;
                var certSnForValidList = [];
                $scope.allLocalCertList=[];
                // 证书有效性接口验证
                var getCertSnListValidity = function() {
                    if (0 == certSnForValidList.length) {
                        return;
                    }
                    var params = [certSnForValidList[0]];
                    var successFunc = function (result) {
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        };

                        if (result.success) {
                            result.value.forEach(function (c) {
                                $scope.validLocalCertList.forEach(function (l) {
                                    if (l.serialNum == c.certSn) {
                                        l.isValid = c.valid;
                                        l.operation = c.operation;
                                        l.canPostpone = c.canPostpone;
                                        l.canModify=c.canModify;
                                        l.reason = c.reason;
                                        if (typeof l.category != 'undefined') {
                                          l.category = c.category;
                                        };
                                        if (typeof l.yearSerEnd != 'undefined') {
                                          l.yearSerEnd = c.yearSerEnd;
                                        };
                                        l.corpid = c.corpid;
                                        $scope.allLocalCertList.push(l);
                                    }
                                });
                            })
                            certSnForValidList.splice(0, 1);
                            if (0 != certSnForValidList.length) {
                                getCertSnListValidity();
                            } else {
                                $scope.showList = true;
                                control.hideLoading();
                            }
                            $scope.showLocalCertList = angular.copy($scope.allLocalCertList);
                        }
                        else {
                            control.showPopup(result.msg, 2000);
                        }
                    }

                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup(error.msg, 2000);
                    };

                    nativeHelper.getCertValidity({ data: params, success: successFunc, fail: failFunc });
                }

                //过滤本地证书
                var getCertValidity = function (certSnList) {
                    console.log('getCertValidity:' + JSON.stringify(certSnList))
                    if(certSnList.length === 0){
                        checkZcyCertApplyWay();
                        return;
                    }
                    control.showLoading();
                    // 证书分组
                    var tmpSubArr = [];
                    for (let index = 0; index < certSnList.length; index++) {
                        const element = certSnList[index];
                        tmpSubArr.push(element);
                        if (0 == (index+1)%certCount || index == certSnList.length-1) {
                            certSnForValidList.push(tmpSubArr);
                            tmpSubArr = [];
                        }
                    }
                    getCertSnListValidity();
                };


                //  getCertList();
                // 校验二维码是否可用
                var checkAppCanScanQrcode = function () {
                    control.showLoading();
                    var time = utility.getCurrentTime();
                    // var hashdata = utility.sm3HashBase64($rootScope.appid + time + $rootScope.secret);
                    // var params = {
                    //     "appid": $rootScope.appid,
                    //     "time": time,
                    //     "hashdata": hashdata,
                    //     "app": "ezt",
                    //     "businessAppId": $rootScope.curQRCodeInfo.businessAppId
                    // };

                    var hashdata = utility.sm3HashBase64('eztAppIos' + time + '182789798kljdskljfls887834783279');
                    var params = {
                        "appid": 'eztAppIos',
                        "time": time,
                        "hashdata": hashdata,
                        "app": "ezt",
                        "businessAppId": $rootScope.curQRCodeInfo.businessAppId
                    };

                    console.log("checkAppCanScanQrcode " + JSON.stringify(params));
                    requestWrapper.checkAppCanScanQrcode({data: params, refresh: true})
                        .then(function (result) {
                            control.hideLoading();
                            console.log("checkAppCanScanQrcode res:"+ JSON.stringify(result));
                            if (result == null || angular.equals({}, result)) {
                                control.showPopup('服务出错啦', 2000);
                                return;
                            };
                            if ("success" == result.rslt) {
                                if (true == result.data.isAuth) {
                                    getCertList();
                                } else {
                                    control.showAlert1(result.data.falseMsg, function() {
                                        nav.navigate('tab/home');
                                    });
                                }
                            } else {
                                control.showPopup(result.msg, 2000);
                            }

                        })
                        .catch(function (e) {
                            control.hideLoading();
                            control.showPopup('网络请求失败：' + e.status, 3000);
                        });

                }

                checkAppCanScanQrcode();
            
                var showUploadMsg = function (e) {
                    control.showPopup(e.msg, 2000);
                }

                window.broadcaster.addEventListener("showUploadMsg", showUploadMsg);

                var signEvent = function() {
                    var eventCounter = new Object();
                    eventCounter.page = "扫码签名";
                    MobclickAgent.onEventWithParameters("signEvent", eventCounter);
                }
            
                var signUploadEvent = function() {
                    var eventCounter = new Object();
                    eventCounter.page = "签名上传";
                    MobclickAgent.onEventWithParameters("signUploadEvent", eventCounter);
                }
            
                var confirmPwd = function (curCert) {
                    if (!validate.certPassword($rootScope.localCert.useCertPwd)) {
                        control.showPopup('请输入6位数字密码', 2000);
                        return;
                    }

                    if ($rootScope.localCert.useCertPwd !== curCert.password) {
                        control.showPopup("证书密码不正确！", 2000);
                        return;
                    }
                    if(curCert.containerName == "" || curCert.containerName == null || curCert.containerName == undefined || curCert.containerName == "undefined"){
                        getOrderNoByCertSerial(curCert);
                    }else{
                        uploadinfo(curCert);
                    }

                }


                $scope.selectCert = function (curCert) {
                    if (curCert.SDKVersion !== "V2") {
                        control.showConfirm4('html/home/SDKVersionAlert.html', "特别提醒",
                        function() {
                            $scope.navigate("businessManage");
                            return;
                        },
                        function() {},
                        "取消", "去业务管理", 'cusClassTbtx');
                        return;
                    }
                    
                    if($rootScope.curQRCodeInfo.type != 'decrypt' && !curCert.isValid){
                        control.showPopup('请选择有效证书', 2000);
                        return;
                    }
                    
                    //判断二维码的证书序列号是否与选中的匹配
                    if ($rootScope.curQRCodeInfo.certSn && $rootScope.curQRCodeInfo.certSn !== '' && !$rootScope.curQRCodeInfo.certSn.indexOf(curCert.serialNum) == -1) {
                        control.showPopup('请选择正确的证书', 2000);
                        return;
                    }
                    
                    // if(curCert.sourceClient === 'ZCY' && $rootScope.curQRCodeInfo.businessAppId != 'zcy-ztb'){
                    //     control.showPopup('该证书只能用于政采云相关应用', 2000);
                    //     return;
                    // }
                    
                    // if(curCert.sourceClient != 'ZCY' && $rootScope.curQRCodeInfo.businessAppId === 'zcy-ztb' && curCert.certType != '省法人数字证书'){
                    //     control.showPopup('该证书不可用于政采云相关应用', 2000);
                    //     return;
                    // }


                    let curQRCodeInfo = $rootScope.curQRCodeInfo;
                    // if ('3' == curQRCodeInfo.versions) {
                       judgeCertAllowUseRange(curCert);
                    // } else {
                    //     $rootScope.localCert = { useCertPwd: '' };
                    //     control.showCustomPopup('html/home/popupUseCert.html', '', '取消', '确认', 'popup-btn-default', 'popup-btn-light', function () { return; }, function () {
                    //         confirmPwd(curCert);
                    //     });
                    // }
                }

                // 判断证书在某应用是否能使用
                var judgeCertAllowUseRange = function (curCert) {
                    control.showLoading();
                    /**
                     * appid         签章平台分配给招标平台的id
                     * time          时间戳，当前时间年月日时分秒 20091010121212
                     * hashdata      (appid+time+secret)将资源接入代码、发送时间、业务密钥按顺序连接并进行md5加密。
                     * certSn        签名证书序号
                     * businessAppId 二维码应用编号
                     */
                    var params = [curCert.serialNum, $rootScope.curQRCodeInfo];
                    
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result.success) {
                            //V2.9.7版本新增字段，用于跳转我的证书页面删除证书
                            $rootScope.deleteCertSnfromPopup = curCert.serialNum;
                            $rootScope.localCert = { useCertPwd: '' };
                            control.showCustomPopup('html/home/popupUseCert.html', '', '取消', '确认', 'popup-btn-default', 'popup-btn-light', function () { return; }, function () {
                                confirmPwd(curCert);
                            });
                        } else {
                            control.showPopup(result.msg, 2000);
                        }
                    };

                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                    };

                    setTimeout(function () {
                        nativeHelper.certAllowUseRange({ data: params, success: successFunc, fail: failFunc });
                    }, 1000);
                }

//              // 判断政采云证书的申领方式(政采云,e照通)
                var checkZcyCertApplyWay = function () {
                    if($rootScope.curQRCodeInfo.type != 'decrypt' && $rootScope.curQRCodeInfo.versions == '3' && $rootScope.curQRCodeInfo.businessAppId == 'zcy-ztb'
                        && $rootScope.loginInfo.idCard!=''&& $rootScope.curQRCodeInfo.certSn!=''){
                        control.showLoading();
                        var params = [$rootScope.loginInfo.idCard, $rootScope.curQRCodeInfo.certSn,$rootScope.loginInfo.accountId];
                        var successFunc = function (result) {
                            control.hideLoading();
                            if (result.code == 200) {
                                $scope.showList = true;
                                // 0均无 1政采云app下载 2e照通app 下载3都有
                                if(result.data == '0'||result.data == '2'){
                                    $scope.zcyCertTip = "提示:可登录政采云平台在【CA管理-CA证书】功能下进行申领"
                                }else if(result.data == '1'||result.data == '3'){
                                    $scope.zcyCertTip = "您单位政采云专项证书安装在政采云APP ，请使用政采云APP扫码"
                                }
                            } else {
                                $scope.showList = true;
                                control.showPopup(result.message, 2000);
                            }
                        };
                        var failFunc = function (result) {
                            $scope.showList = true;
                            control.hideLoading();
                        };
                        nativeHelper.checkZcyCertApplyWay({ data: params, success: successFunc, fail: failFunc });
                    }else{
                        $scope.showList = true;
                    }
                }
                var getOrderNoByCertSerial = function(curCert) {
                    var params = [curCert.serialNum];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({},
                            result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }
                        if (result.code==200) {
                           curCert.containerName = result.data;
                           uploadinfo(curCert);
                        }else{
                            control.showPopup(result.message, 2000);
                        }
                    }
                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup(error.msg, 2000);
                    };

                    nativeHelper.getOrderNoByCertSerial({
                        data: params,
                        success: successFunc,
                        fail: failFunc
                    });

               }

                var uploadinfo = function (curCert) {
                    control.showLoading();
                    signEvent();//监听扫码签名

                    //param1:二维码扫描结果
                    //param2:选中证书对应的容器
                    //param3:证书base64,与对应容器里到处的校验下是否一致
                    //param4:用户输入的证书使用密码（容器PIN码）
                    var params = [$rootScope.curQRCodeInfo, curCert.containerName, curCert.certContent, $rootScope.localCert.useCertPwd,curCert.SDKVersion, $rootScope.loginInfo.userName, $rootScope.loginInfo.idCard, curCert.serialNum, curCert.encSerialNum,$rootScope.loginInfo.accountId,$rootScope.loginInfo.mobile,curCert.uniscid,curCert.CN];
                    console.log(params)
                    var successFunc = function (result) {
                        $rootScope.localCert = { useCertPwd: '' };
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }

                        signUploadEvent();//上传监听

                        if (result.rslt == 'success') {
                            if($rootScope.curQRCodeInfo.versions=="3"&&$rootScope.curQRCodeInfo.openSign=="1"){
                                $state.go('signCompleted',{cert:curCert});
                                return;
                            }else{
                                control.showPopup('扫码操作成功', 2000);
                            }
                        }
                        else {
                            if(result.errorMsg.includes("签名验证失败")){
                                control.showPopup(result.errorMsg + "，请重新下载证书后重试！", 2000);
                            }else{
                                control.showPopup(result.errorMsg, 2000);
                            }
                        }

                         nav.navigate('tab/home');
                    };

                    var failFunc = function (result) {
                        control.hideLoading();
                        if(result.errorMsg.includes("签名验证失败")){
                            control.showPopup(result.errorMsg+"请重新下载证书后重试！", 2000);
                            requestWrapper.sendMesToDingTalk("密码模块错误","扫码上传",result.alarmMsg+"请重新下载证书后重试！")
                        }else{
//                            var toastTips = "";
//                            $scope.showLocalCertList.forEach((v, index)=>{
//                                toastTips = (index+1)+":CN="+v.CN + ",containerName="+v.containerName+";" + toastTips;
//                            })
//                            console.log(result.errorMsg+"====toastTips===="+toastTips)
                            control.showPopup(result.errorMsg, 5000);
                            requestWrapper.sendMesToDingTalk("密码模块错误","扫码上传",result.alarmMsg)
                        }
                    };

                    setTimeout(function () {
                        nativeHelper.uploadinfo({ data: params, success: successFunc, fail: failFunc });
                    }, 1000);
                }



                /**
                * 搜索证书
                */
                $scope.searchCert = function () {
                    if ($scope.searchInfo.key == '') {
                        $scope.showLocalCertList = $scope.allLocalCertList;
                        return;
                    }
                    $scope.showLocalCertList = $filter('filter')($scope.allLocalCertList, $scope.searchInfo.key);
                    //关闭软键盘
                    cordova.plugins.Keyboard.close();
                }

                $scope.navigate = function (state) {
                    nav.navigate(state);
                };

                // 获取native基础数据配置
                var getBaseConfig = function() {
                    var returnFunc = function(baseData) {
                        $rootScope.appid = baseData.appid;
                        $rootScope.secret = baseData.secret;
                        $rootScope.zwwAppid = baseData.zwwAppid;
                        $rootScope.zwwSecret = baseData.zwwSecret;
                        $rootScope.deviceModelName = baseData.deviceModelName;
                        $rootScope.systemVersion = baseData.systemVersion;
                        $rootScope.uuid = baseData.uuid;
                        $rootScope.deviceAuthenticationType = baseData.deviceAuthenticationType;//0-生物识别都不支持 1-面容 2-指纹
                        $rootScope.appVersion = baseData.version;
                        $rootScope.urlConfig = {
                            "serverUrl": baseData.urlConfig.serverUrl,
                            "cloudCertUrl": baseData.urlConfig.cloudCertUrl,
                            "doDecDataUrl": baseData.urlConfig.cloudCertUrl,
                            "authCenterUrl" : baseData.urlConfig.authCenterUrl,
                            "scanUrl": baseData.urlConfig.scanUrl,
                            "OCRUrl": baseData.urlConfig.OCRUrl,
                            "CTIDAuthUrl": baseData.urlConfig.CTIDAuthUrl,
                            "msgCenterUrl": baseData.urlConfig.msgCenterUrl,
                            "TimeUrl": baseData.urlConfig.TimeUrl,
                            "frdecrUrl": baseData.urlConfig.frdecrUrl,
                            "stampUrl": baseData.urlConfig.stampUrl,
                            "letterUrl":baseData.urlConfig.letterUrl
                        }
                        checkAppCanScanQrcode();
                    }

                    nativeHelper.getBaseConfig({
                        data:[],
                        success: returnFunc
                    });
                }
                // getBaseConfig();
            }]);
})();
