(function() {
    "use strict"
    angular.module('starter')
    .controller('videoGuidance', ['$rootScope', '$scope','$sce', 'nav', 'control','nativeHelper',
    function($rootScope, $scope,$sce, nav, control, nativeHelper) {
      screen.orientation.unlock();
      screen.orientation.lock('portrait');
      $scope.videoUrl = $sce.trustAsResourceUrl($rootScope.certReissueVideoUrl);
      //默认不全屏
      $scope.isFull = false;
    if(!$rootScope.isHomePageToVideo){nav.navigate('tab/home');}
       //恢复默认值 标识观看视频是首页跳转还是上一个页面返回
       $rootScope.isHomePageToVideo = false;
       //设备类型
       $scope.isAndroid = true;
      if (cordova.platformId === 'ios'){
         $scope.isAndroid = false;
         var video = document.getElementById('myVideo');
         $scope.isPlay=false;
         video.addEventListener('play', function () { //播放开始执行的函数
            console.log("开始播放");
            $scope.isPlay=true;
            $scope.$apply();
        })
         video.addEventListener('pause', function () { //播放开始执行的函数
            console.log("暂停播放");
            $scope.isPlay=false;
            $scope.$apply();
        })
        // 监听全屏开始事件
        video.addEventListener('webkitbeginfullscreen', function() {
            // 全屏开始时的操作
            console.log('Video entered fullscreen');
            screen.orientation.unlock();
            screen.orientation.lock('portrait');
            screen.orientation.lock('landscape');
            if (cordova.platformId === 'ios') {
                nativeHelper.setOrientation({
                    data: ['LandscapeRight'],
                    success: null,
                    fail: null
                });
            }
        });
        // 监听全屏结束事件
        video.addEventListener('webkitendfullscreen', function() {
            // 全屏结束时的操作
            console.log('Video exited fullscreen');
            screen.orientation.unlock();
            screen.orientation.lock('portrait');
            if (cordova.platformId === 'ios') {
                nativeHelper.setOrientation({
                    data: ['Portrait'],
                    success: null,
                    fail: null
                });
            }
        });
        //点击遮罩触发暂停播放操作
        $scope.onPlay = function () { video.pause();};
      }else{
         const video = document.getElementById('myVideo');
        // const playPauseBtn = document.getElementById('playPauseBtn');
         const progressRange = document.getElementById('progressRange');
         const muteBtn = document.getElementById('muteBtn');
         const fullscreenBtn = document.getElementById('fullscreenBtn');
         $scope.videoPlayBtn="img/svg/icon-video-play.svg";
         $scope.videoSoundSrc="img/svg/icon-no-sound.svg";
         // 播放/暂停按钮逻辑
         $scope.playPauseBtn = function () {
            if (video.paused || video.ended) {
               video.play();
               $scope.videoPlayBtn="img/svg/icon-video-playing.svg";
               $scope.$apply();
            } else {
               video.pause();
               $scope.videoPlayBtn="img/svg/icon-video-play.svg";
               $scope.$apply();
            }
         };
         // 进度条逻辑
         video.addEventListener('timeupdate', function() {
           progressRange.value = video.currentTime * 100 / video.duration;
         });
         //进度条监听
         progressRange.addEventListener('input', function() {
           const skipTo = this.value * video.duration / 100;
           video.currentTime = skipTo;
         });
         //默认静音
         video.muted = true;
         // 静音按钮逻辑
         muteBtn.addEventListener('click', function() {
            video.muted = !video.muted;
            if(video.muted){
               $scope.videoSoundSrc="img/svg/icon-no-sound.svg";
            }else{
               $scope.videoSoundSrc="img/svg/icon-sound.svg";
            }
             $scope.$apply();
         });
         // 全屏按钮逻辑（注意：全屏API可能因浏览器策略而异）
         fullscreenBtn.addEventListener('click', function() {
            if(!$scope.isFull) {
               $scope.isFull=true;
               // 当前是全屏状态
               screen.orientation.unlock();
               screen.orientation.lock('portrait');
               screen.orientation.lock('landscape');
               video.style.width = '100%';
               video.style.height = (document.documentElement.clientWidth-21)+"px";
               $scope.$apply();
            } else {
               $scope.isFull = false;
               video.style.width = '100%';
               video.style.height = 'auto';
               $scope.$apply();
               // 不是全屏状态
               screen.orientation.unlock();
               screen.orientation.lock('portrait');
             }
         });
         // 移除原生控制（如果需要）
         video.removeAttribute('controls');
         // 全屏点击返回
         $scope.returnClick=function(){
            $scope.isFull = false;
            video.style.width = '100%';
            video.style.height = 'auto';
            $scope.$apply();
            // 不是全屏状态
            screen.orientation.unlock();
            screen.orientation.lock('portrait');
         }
      }
     //复制视频链接
     $scope.copyUrl = function () {
       var text = $rootScope.certReissueVideoUrl;
       var successFunc = function() {
             control.showPopup('复制成功', 2000);
       }

       var failFunc = function() {
            control.showPopup('复制失败', 2000);
       }

       nativeHelper.socialAgent({
           data: [text, 1,''],
           success: successFunc,
           fail: failFunc
       });
    };
     //跳过观看引导视频
    $scope.cancelVideoClick=function(){
       if (!$rootScope.loginInfo.userId) {
            nav.navigate('signIn');
            return;
        }
        $rootScope.applyCertType = 1; // 0 可申领的证书   1 可补办的证书
        if ($rootScope.loginInfo.realNameGrade != "1") {
            $rootScope.identityAuthRootPage = "applyCertSearchV2";
            $rootScope.showActive = true;
            $rootScope.isIdentityAuth = true;
            nav.navigate('tab/home');
        }else{
            nav.navigate('applyCertSearchV2');
            var eventCounter = new Object();
            eventCounter.page = "首页-证书补办";
            MobclickAgent.onEventWithParameters("homeCertReissueEvent", eventCounter);
        }
    }
    }]);
})();
