﻿(function () {
    "use strict"

    angular.module('starter')
    .controller('tab', ['$rootScope', '$scope', '$ionicHistory','nav', 'control','nativeHelper','utility','$ionicViewSwitcher', function ($rootScope, $scope, $ionicHistory,nav,control,nativeHelper,utility,$ionicViewSwitcher) {
        // $rootScope.bottomSafeAreaHeight = 34; //0  34
        $rootScope.showActive = false;
        $rootScope.delayCertNum = 0;// 延期证书数量
        $rootScope.changeCertNum = 0;// 变更证书数量

        $rootScope.certOperationList = []; // 我的证书列表
        $rootScope.homeCertRefreshTime = 0;// 记录首页证书刷新时间
        $rootScope.isGetHomeCertApi = true;// 主动触发首页是否获取证书接口
        $rootScope.homeCertRefreshIntervalTime = 60;//首页刷新时间间隔（秒）
        //
        $rootScope.isHomeCertRefresh = function(){
            if($rootScope.isGetHomeCertApi){
                $rootScope.homeCertRefreshTime = Date.now();
                return true
            }

            if(Date.now()-$rootScope.homeCertRefreshTime>$rootScope.homeCertRefreshIntervalTime*1000){
                $rootScope.homeCertRefreshTime = Date.now();
                return true
            }else{
                return false
            }
        }

        $scope.cancel = function(){
            $rootScope.isIdentityAuth = false;
            $rootScope.showActive = false;
        }

        $rootScope.faceAuth = function(){
            $rootScope.showActive = false;
            $rootScope.authentication = {
                name:'',
                card:''
            };
            $scope.navigate('authenticationInfo');
        }

        $scope.scan = function(){
            if (!$rootScope.loginInfo.userId) {
                $scope.navigate('signIn');
               return;
           }

           var params = [];
           var successFunc = function (result) {
           }
           var failFunc = function (error) {
               control.showPopup(error.msg, 2000);
           };
           $rootScope.scanFromCertDetail = false;
           nativeHelper.navToScanView({ data: params, success: successFunc, fail: failFunc });
           var eventCounter = new Object();
           eventCounter.page = "首页-扫一扫";
           MobclickAgent.onEventWithParameters("homeScanEvent", eventCounter);
        }

        $scope.uerManage = function(){
            if($rootScope.isLogin){
                nav.navigate('tab/account');
            }else{
                nav.navigate('signIn');
            }
            var eventCounter = new Object();
            eventCounter.page = "首页-我的";
            MobclickAgent.onEventWithParameters("homeMyselfEvent", eventCounter);
        }

        // 验证是否需要人脸  15分钟内不需要人脸
        $rootScope.isAuthFace = function(){
            if($rootScope.authSuccessTime == undefined||$rootScope.authSuccessTime == null){
                 return true
            }
            if($rootScope.realPersonAuthValidTime == undefined||$rootScope.realPersonAuthValidTime == null){
                 $rootScope.realPersonAuthValidTime = 15
            }

            if(Date.now()-$rootScope.authSuccessTime>$rootScope.realPersonAuthValidTime*60000){
                return true
            }else{
                return false
            }
        }
        // 设置人脸成功时间
        $rootScope.setAuthSuccessTime = function(){
            $rootScope.authSuccessTime = Date.now();
        }
        $rootScope.goBackV2=function(){
            $ionicHistory.goBack();
            $ionicViewSwitcher.nextDirection("back");
        }

        $rootScope.isFaceAuthFail = false;

        $rootScope.faceFailTime = null;
         // 人脸错误提示 5分钟内错误两次提示
        $rootScope.isOpenFaceAuthFail = function(){
            if($rootScope.faceFailTime == null){
                $rootScope.faceFailTime = Date.now();
                return false
            }
            if(Date.now()-$rootScope.faceFailTime<=5*60000){
                $rootScope.faceFailTime = Date.now();
                $rootScope.isFaceAuthFail = true;
                return true
            }else{
                $rootScope.faceFailTime = Date.now();
                return false
            }
        }




        $rootScope.closeFaceAuthFail = function(){
            $rootScope.isFaceAuthFail = false;
        }
        // 邮寄申领
        $rootScope.mailApply = function(){
            $rootScope.isFaceAuthFail = false;
            $rootScope.applyCertType = 2; // 0 可申领的证书   1 可补办的证书 2 邮寄材料
            nav.navigate('applyCertSearchV2');
        }
        // 首页我的证书下载华测证书更新资料弹框关闭
        $rootScope.homeCertCancelClick = function () {
            $rootScope.homeCertShowUpdatePicAlert = false;// 华测证书下载需要更新资源的弹框开关
        }
        $scope.navigate = function (state) {
            nav.navigate(state);
        };

    }]);
})();
