(function () {
    angular.module('starter')
    .directive('previewPicture',
    ['nativeHelper','control','$ionicPlatform','$location','$ionicHistory','utility',function (nativeHelper,control,$ionicPlatform,$location,$ionicHistory, utility) {
        return {
            restrict: 'E',
            templateUrl: 'html/directives/previewPicture.html',
            scope: {
                showPreview: '=',
                previewPic:'=',
                cancel:'&',
            },


             link:function(scope, element, attrs) {
                scope.x = 0;
                scope.y = 0;
                scope.xd = 0;
                scope.yd = 0;
                scope.scaleCount = 1;
                scope.scaleIndex = 1;
                scope.image = document.getElementById('preview-image');

                scope.hammers = new Hammer(scope.image);
                scope.hammers.get('pinch').set({enable:true});
                scope.hammers.on("pinchmove pinchstart pinchin pinchout",e => {//缩放
                    if(e.type == "pinchstart"){
                        scope.scaleIndex = scope.scaleCount || 1;
                    }
                    scope.scaleCount = scope.scaleIndex*e.scale;
                    if(scope.scaleCount<1){
                        scope.scaleCount = 1;
                    }else if(scope.scaleCount>3){
                        scope.scaleCount = 3;
                    }
                    scope.image.style.transform = "scale(" + scope.scaleCount+ ")"
                });

                scope.hammers.on('panright panleft panup pandown',(e)=>{//拖动
                    scope.xd = e.deltaX+scope.x;
                    scope.yd = e.deltaY+scope.y;
//                    if(scope.xd<0){
//                        scope.x=0;
//                        scope.xd = 0;
//                    }
//                    if(scope.yd<0){
//                        scope.y = 0;
//                        scope.yd = 0;
//                    }
                    scope.image.style.transform="translateX("+(scope.xd)+"px)"+"translateY("+(scope.yd)+"px)"+"scale(" + (scope.scaleCount)+ ")"
                })
                scope.hammers.on('panend',(e)=>{
                    scope.x=e.deltaX+scope.x;
                    scope.y=e.deltaY+scope.y;
                })
                scope.closePreview = function () {
                    scope.cancel();
                }
            }
        };
    }]);
})();
