(function () {
    "use strict"
    angular.module('starter')
        .factory('downloadLogic', ['$rootScope','$ionicLoading', '$ionicActionSheet', 'nav', 'control', 'nativeHelper', 'validate', 'utility', '$filter', '$timeout', 'url','md5', 'requestWrapper','localStorage','$state','verifyIdentity',
            function ($rootScope, $ionicLoading, $ionicActionSheet, nav, control,
                nativeHelper, validate, utility, $filter, $timeout, urlFct,md5,requestWrapper,localStorage,$state,verifyIdentity) {

                var orderNoData;
                var clickType; // 0:下载证书 1:证书延期 2:证书变更
                // 下载证书
                var downloadCertLogic = function (item) {
                    clickType = '0';
                    $rootScope.userNameForPwdPopup = $rootScope.loginInfo.userName;
                    $rootScope.userPhoneForPwdPopup  = $rootScope.loginInfo.mobile;
                    orderNoData = item;
                    // 3.0.1 政采云申领的证书 facePassState字段没有
                    //orderType = 业务单类型：0材料领证 1授权领证, downloadCert = 0 业务单 ,facePassState0材料 facePassState=1 邮寄
                    if(item.downloadType=='0'&&item.orderType == '0'&&item.facePassState=='1'&&item.handleState!='100'){
                        $state.go('downloadCert', {
                            'downloadCertInfo': orderNoData
                        });
                        return;
                    }else if(item.downloadType=='0'&&item.isweb=='2'){// 线下网点办理
                        $state.go('downloadCert', {
                            'downloadCertInfo': orderNoData
                        });
                        return;
                    }else{
                        // realNameGrade = 0未实名 1已实名
                        if($rootScope.loginInfo.realNameGrade == "1"){

                            if(item.downloadType=='0'){ // 首页我的证书业务单判断华测证书是否需要上传材料
                                if ('HCCA_NEW' == item.caName) {
                                    doCheckUploadPicture(item);
                                } else {
                                    doGetMobileDeviceList(item);
                                }
                            }else{
                                doGetMobileDeviceList(item);
                            }
                        }else{
                            $rootScope.identityAuthRootPage = item.sourceType;
                            nav.go('authorizationFace');
                        }
                    }
                }

                // 证书延期和变更信任设备判断
                // clickType  0:下载证书 1:证书延期 2:证书变更
                $rootScope.downloadLogic_certDelayAndModifyLogic = function (item,type,sourceType) {

                    if(sourceType=='home'&&type=='1'){
                         var eventCounter = new Object();
                         eventCounter.page = "首页-证书延期操作";
                         MobclickAgent.onEventWithParameters("homeCertDelayPlayEvent", eventCounter);
                         $rootScope.updatePictures = {
                            businessLicensePic: '',
                            IDCardFrontPic: '',
                            IDCardBackPic: '',
                            authorizationPic: '',
                            uploadFrom: ''
                         }
                    }else if(sourceType=='home'&&type=='2'){
                        var eventCounter = new Object();
                        eventCounter.page = "首页-证书变更操作";
                        MobclickAgent.onEventWithParameters("homeCertChangePlayEvent", eventCounter);
                    }else if(sourceType=='mycert'&&type=='1'){
                        var eventCounter = new Object();
                        eventCounter.page = "我的证书-证书延期";
                        MobclickAgent.onEventWithParameters("certManageCertDelayEvent", eventCounter);
                    }else if(sourceType=='mycert'&&type=='2'){
                        var eventCounter = new Object();
                        eventCounter.page = "我的证书-证书变更";
                        MobclickAgent.onEventWithParameters("certManageCertChangeEvent", eventCounter);
                    }

                    clickType = type;
                    $rootScope.userNameForPwdPopup = $rootScope.loginInfo.userName;
                    $rootScope.userPhoneForPwdPopup  = $rootScope.loginInfo.mobile;
                    orderNoData = item;
                    if($rootScope.loginInfo.userName===undefined||$rootScope.loginInfo.userName===null||$rootScope.loginInfo.userName===""){
                        certOperateClick();
                    }else{
                        // 账号和证书使用人是否同一人
                        // doGetMobileDeviceList();
                        doCheckOperator()
                    }
                }

               // s判断当前证书经办人是否为当前登录用户，true一致 false不一致
               var doCheckOperator = function(item) {
                    var params = [$rootScope.loginInfo.idCard, orderNoData.serialNum];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({},
                            result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }
                        if (result.code==200) {
                            if (result.data) {
                                doGetMobileDeviceList();
                            }else{
                                $rootScope.isVerifyUseCertPersonPop = true;
                            }
                        }else{
                            control.showPopup(result.msg, 2000);
                        }
                    }
                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup(error.msg, 2000);
                    };

                    nativeHelper.doCheckOperator({
                        data: params,
                        success: successFunc,
                        fail: failFunc
                    });

               }

               $rootScope.downloadLogic_verifyUseCertPersonPopClick = function (type) {
                    $rootScope.isVerifyUseCertPersonPop = false;
                    if(type=='makeUp'){ // 补办
                        $rootScope.applyCertType = 1; // 0 可申领的证书   1 可补办的证书
                        nav.navigate('applyCertSearchV2');
                    }
               }


                // 检查是否需要上传资料
                var doCheckUploadPicture = function(item) {
                    var time = utility.getCurrentTime();
                    var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
                    var temp = {
                        "corpid": item.corpid,
                        "proxIdNo": $rootScope.loginInfo.idCard,
                        "categoryBh": item.categoryBh,
                        "orderNo": item.orderNo,
                        'keyNo':$rootScope.uuid,
                        "token" : $rootScope.loginInfo.token
                    }

                    var reqParams = DES3.encrypt(hashdata.substring(0,24), 'ZJHUIXIN', angular.toJson(temp))

                    var params = {
                        "appid": $rootScope.appid,
                        "time": time,
                        "hashdata": hashdata,
                        "reqParams": reqParams
                    };
                    requestWrapper.doCheckUploadPicture({ data: params, refresh: true })
                        .then(function (result) {
                            control.hideLoading();
                            if (result == null || angular.equals({}, result)) {
                                control.showPopup('服务出错啦', 2000);
                                return;
                            };
                            if (true == result.success) {
                                if ('yes' == result.value.isUpload) {
                                    $rootScope.homeCertShowUpdatePicAlert = true;
                                } else {
                                    doGetMobileDeviceList(item);
                                }
                            } else {
                                control.showPopup(result.msg, 2000);
                            }
                        })
                        .catch(function (e) {
                            control.hideLoading();
                            console.log('网络请求失败：' + e.status);
                            control.showPopup('网络请求失败：' + e.status, 2000);
                        });
                }


                // 获取设备列表
                var doGetMobileDeviceList = function(item) {
                	control.showLoading();
                	var time = utility.getCurrentTime();
                	var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
                	var params = {'appid': $rootScope.appid,'time': time,'hashdata': hashdata,'mobilePhone': $rootScope.loginInfo.mobile,'idCard': $rootScope.loginInfo.idCard,'keyNo': $rootScope.uuid,'token': $rootScope.loginInfo.token}

                	requestWrapper.doGetMobileDeviceList({data: params,refresh: true})
                		.then(function(result) {
                			control.hideLoading();
                			if (result.success) {
                				var deviceList = result.value;
                				var isTrustedDevice = false;
                				for (let index in deviceList) {
                					if (deviceList[index].keySerial == $rootScope.uuid) {
                						isTrustedDevice = true;
                						break;
                					}
                				}
                				// 是否是信任设备
                				if (isTrustedDevice) {
                					//生物识别开关是否打开, 不同系统不同开关
                					if (($rootScope.openBiometryAndroid == '1' && 'android' == cordova.platformId) || ($rootScope.openBiometryIOS == '1' && 'ios' == cordova.platformId)) {
                						var authInfo = localStorage.getObject('authInfo' + $rootScope.loginInfo.accountId);
                						//是否开启指纹
                						if (JSON.stringify(authInfo) == '{}' || authInfo.openVerify == '0') {
                							// 密码校验
                							$rootScope.pwdPopupFrom = 'certManage';
                							control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopupV2.html');
                							return;
                						} else {
                							// 用指纹/登录密码校验
                							if ('0' != $rootScope.deviceAuthenticationType) {
                								// 如果指纹已打开且可用 用指纹校验
                								var successFunc = function(res) {
                									if (1 == res.code) {
                										certOperateClick();
                									} else if (2 == res.code) {
                										//用户选择了取消
                										if (cordova.platformId === 'android' && $rootScope.deviceAuthenticationType === '1') {
                											//安卓面容验证点击取消出现密码验证
                											$rootScope.pwdPopupFrom = 'certManage';
                											control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopupV2.html');
                										}
                										return;
                									}else {
                										// 密码校验
                										$rootScope.pwdPopupFrom = 'certManage';
                										control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopupV2.html');
                										return;
                									}
                								}
                								var failFunc = function(res) {
                									console.log('fail - ' + JSON.stringify(res));
                								}
                								nativeHelper.deviceAuthentication({
                									data: ['输入登录密码'],
                									success: successFunc,
                									fail: failFunc
                								});
                							} else {
                								// 密码校验
                								$rootScope.pwdPopupFrom = 'certManage';
                								control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopupV2.html');
                								return;
                							}
                						}
                					} else {
                						certOperateClick();
                					}
                				} else {
                					if ($rootScope.isAuthFace()) {
                						// ctid认证流程
                						$rootScope.downloadLogic_acShowAuthConfirm = false;
                						$rootScope.downloadLogic_alert_applicant_info = true;
                					} else {
                						certOperateClick();
                					}
                				}
                			} else {
                				control.showPopup(result.msg, 2000);
                			}
                		});
                }

                //实人检测错误提示
                var detectionError = function (resultMsg) {
                     control.showPopup(resultMsg, 2000);
                }
                //采集人脸提示
                $rootScope.downloadLogic_alert_applicant_info = false;
                $rootScope.downloadLogic_closeApplicantInfoAlert = function () {
                    $rootScope.downloadLogic_alert_applicant_info = false;
                }

                //开始活体检测
//                $scope.startBiopsy = function () {
//                    $rootScope.downloadLogic_acShowAuthConfirm = true;
//                    $rootScope.downloadLogic_alert_applicant_info = false;
//                }

                var authLivingFailEvent = function () {
                    var eventCounter = new Object();
                    eventCounter.page = "活体识别失败";
                    MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
                }

                var photoData;
                var listenerLiveDetectionResTime = 0;
                //人脸识别结果监听
                var liveDetectionResult = function (res) {
                    if (res.rslt == 'success') {
                        if (res.data.result == 'success') {
                            photoData = res.photoData;
                            $rootScope.setAuthSuccessTime();
                            certOperateClick();
                        }else{
                            authLivingFailEvent();
                            if (res.data.authResult == '5XXX' || res.data.authResult == '6XXX') {
                                if(!$rootScope.isOpenFaceAuthFail()){
                                    detectionError('姓名或身份证号码有误，错误代码' + res.data.authResult);
                                }
                                return;
                            } else if (res.data.authResult == '01XX' || res.data.authResult == '02XX' || res.data.authResult == '02XX') {
                                if(!$rootScope.isOpenFaceAuthFail()){
                                    detectionError('人脸比对失败，错误代码' + res.data.authResult);
                                }
                                return;
                            } else {
                               if(!$rootScope.isOpenFaceAuthFail()){
                                    control.showPopup(res.data.authResultMsg, 2000);
                               }
                            }
                        }
                    }else{
                        authLivingFailEvent();
                        control.showPopup(res.errorMsg, 2000);
                    }
                };
                $rootScope.downloadLogic_acShowAuthConfirm = false;
                $rootScope.downloadLogic_acCloseClick = function() {
                    $rootScope.downloadLogic_acShowAuthConfirm = false;
                }
                // 人脸再试一次
                $rootScope.downloadLogic_faceAuthTryAgain = function(){
                    $rootScope.downloadLogic_acShowAuthConfirm = true;
                    $rootScope.closeFaceAuthFail();
                }
                $rootScope.downloadLogic_acIsAgreeApplyAgreement = false;
                $rootScope.downloadLogic_acAgree = function() {
                    $rootScope.downloadLogic_acIsAgreeApplyAgreement = !$rootScope.downloadLogic_acIsAgreeApplyAgreement;
                }
                $rootScope.downloadLogic_acAgreement = function() {
                    var url = window.currentUrl + '/app/ezt/faceAgreement.html';
                    var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                    cordova.InAppBrowser.open(url, '_blank', operation);
                }
                $rootScope.downloadLogic_acNext = function() {
                    if (!$rootScope.downloadLogic_acIsAgreeApplyAgreement) {
                        control.showPopup("请确认同意《人脸认证功能协议》", 2000);
                        return;
                    }
                    $rootScope.downloadLogic_acShowAuthConfirm = false;
                    $rootScope.downloadLogic_alert_applicant_info = false;
                    verifyIdentity.startLiveDetection($rootScope.loginInfo.userName,$rootScope.loginInfo.idCard,$rootScope.loginInfo.userId,liveDetectionResult);
                }

                $rootScope.downloadLogic_startLiveDetectionClick = function() {
                  $rootScope.downloadLogic_acShowAuthConfirm = true;
                  $rootScope.downloadLogic_alert_applicant_info = false;
                }

                $rootScope.popupPwdHidden = true;

                $rootScope.pwdPopup = {userPassword: ''};
                $rootScope.downloadLogic_passwordPopupCloseClick = function() {
                    control.hideCustomPopup();
                }
                $rootScope.downloadLogic_passwordPopupConfirmClick = function () {
                    if('' == $rootScope.pwdPopup.userPassword){
                        return;
                    }

                    var time = utility.getCurrentTime();
                    var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
                    var temp = {
                        'mobile': $rootScope.loginInfo.mobile,
                        'password': $rootScope.pwdPopup.userPassword,
                        'keyNo':$rootScope.uuid,
                        "token" : $rootScope.loginInfo.token
                    }

                    var reqParams = DES3.encrypt(hashdata.substring(0,24), 'ZJHUIXIN', angular.toJson(temp))

                    var params = {
                        "appid": $rootScope.appid,
                        "time": time,
                        "hashdata": hashdata,
                        "reqParams": reqParams
                    };

                    control.showLoading();
                    requestWrapper.verifyPassword({data: params, refresh: true})
                        .then(function (result) {
                            control.hideLoading();
                            $rootScope.pwdPopup = {userPassword: ''};
                            if (true == result.success) {
                                control.hideCustomPopup();
                                certOperateClick();
                            } else {
                                control.showPopup(result.msg, 2000);
                            }
                        });
                }

                $rootScope.downloadLogic_passwordPopupForgetClick = function () {
                    control.hideCustomPopup();
                    var hideMobile = $rootScope.loginInfo.mobile;
                    if(hideMobile == undefined || hideMobile == null || hideMobile == ''){
                        hideMobile = ''
                    }
                    if (!isNaN(parseFloat(hideMobile)) && isFinite(hideMobile)) {
                        var prefix = hideMobile.slice(0, 3);
                        var suffix = hideMobile.slice(7)
                        hideMobile = prefix + "****" + suffix;
                    }
                    var template = "<h4 style='word-break:break-all;'>找回密码需要短信验证，确定要给您的手机号"+hideMobile+ "发送验证码短信吗？</h4>"
                    control.showConfirm3(function() {
                        nav.navigate('retrievePasswordForPwdPopup');
                    },function() {},'', '确定', 'check-information', template);
                }

                $rootScope.downloadLogic_popupPwdIconClick = function() {
                    if ($rootScope.popupPwdHidden) {
                        let input = document.getElementById("pwdpopup-pwdinput");
                        input.setAttribute("type", "text");
                        let icon = document.getElementById("pwdpopup-pwdicon");
                        icon.setAttribute("class", "pwdpopup-show-icon");
                    } else {
                        let input = document.getElementById("pwdpopup-pwdinput");
                        input.setAttribute("type", "password");
                        let icon = document.getElementById("pwdpopup-pwdicon");
                        icon.setAttribute("class", "pwdpopup-hide-icon");
                    }
                    $rootScope.popupPwdHidden = !$rootScope.popupPwdHidden;
                }

                $rootScope.downloadLogic_popupPwdClearClick = function() {
                    $rootScope.pwdPopup = {userPassword: ''};
                }

                var getFeeInfo = function(){
                    var params = [orderNoData.categoryBh, orderNoData.corpid, orderNoData.netType];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({},
                            result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }

                        if (result.success) {
                            if (!result.value.isFree) {
                                $rootScope.certCharge = result.value.fee;
                                paymentApply(orderNoData)
                                return;
                            }
                            if (!result.value.inService) {
                                item.endDate = result.endDate;
                                item.fee = result.fee;
                                certFeeTip(orderNoData, '年费', '缴费', result.value.fee);
                            } else {
                                doNetOrderInfo(orderNoData)
                            }
                        }
                        if (!result.success) {
                            control.showPopup(result.msg, 2000);
                        }
                    }
                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup(error.msg, 2000);
                    };

                    nativeHelper.getFeeInfo({
                        data: params,
                        success: successFunc,
                        fail: failFunc
                    });
                }


                var paymentApply = function(item) {
                    $rootScope.paymentWay = '1'// 经办人下载
                    $rootScope.downloadLogic_okFunc = function() {
                        if(orderNoData.downloadType=="0"){
                            if(orderNoData.orderType=='1'){
                                $state.go('orderInfoConfirm',{'orderInfo':orderNoData});
                                return;
                            }
                            var item = { orderNo: orderNoData.orderNo, payType: orderNoData.payType, allFee: orderNoData.allFee, entName: orderNoData.entName, lastPage: 'businessManage',facePassState:orderNoData.facePassState };
                            $state.go('orderDetails', { orderInfo: item });
                        }else{
                            var operatorType;
                            switch (orderNoData.identityType) {
                            case '0':
                                operatorType = '0'
                                break;
                            case '1':
                                operatorType = '2';
                                break;
                            case '2':
                                operatorType = '1';
                                break;
                            }
                            $state.go('confirmCertInvoice', {
                                'netOrderInfoWithInvoice': {
                                    'entName': orderNoData.entName,
                                    'uniscid': orderNoData.uniscid,
                                    'agenter': $rootScope.loginInfo.userName,
                                    'cert': orderNoData.cert,
                                    'mobile': orderNoData.mobile,
                                    'corpid': orderNoData.corpid,
                                    'categoryBh': orderNoData.categoryBh,
                                    'netType': orderNoData.netType,
                                    'letter': orderNoData.letter,
                                    'idCardFace': '',
                                    'authId': orderNoData.authId,
                                    'operatorType': operatorType,
                                    'orderType': '1',
                                    'businessCode': orderNoData.netType == '8' ? 'B03': 'P012',
                                }
                            });
                        }

                        $rootScope.downloadLogic_showTimeConfirm = false;
                    }
                    $rootScope.downloadLogic_cancelClick2 = function() {
                        $rootScope.downloadLogic_showTimeConfirm = false;
                    }
                    $rootScope.downloadLogic_showTimeConfirm = true;
                    return;
                }


                // 只处理年费 付费在paymentApply方法
                var certFeeTip = function (item, type, btnLeft, fee) {
                    var tipContent = '';
                    var btnRight = '';
                    if (type == '年费') {
                        tipContent = '证书年费<p>证书年费服务期已于' + item.endDate + '过期,请先缴纳证书年费后再办理证书相关维护业务,证书使用年费'+item.fee+'元/张/年。<p>'
                        btnRight = "取消";
                    } else if (type == '子证书') {
                        paymentApply(item);
                        return;
                    }
                    control.showConfirm(tipContent,
                        function () {
                            //生成业务单：经办人类型 0法定代表人 1经办人 2管理员
                            //授权记录："0法定代表人 1管理员 2经办人"
                            if (type == '子证书') {
                                var operatorType;
                                switch (item.identityType) {
                                    case '0':
                                        operatorType = '0'
                                        break;
                                    case '1':
                                        operatorType = '2';
                                        break;
                                    case '2':
                                        operatorType = '1';
                                        break;
                                }
                                $state.go('confirmCertInvoice', {
                                    'netOrderInfoWithInvoice': {
                                        'entName': item.unitName,
                                        'uniscid': item.uniscid,
                                        'agenter': $rootScope.loginInfo.userName,
                                        'cert': item.cert,
                                        'mobile': item.mobile,
                                        'corpid': item.corpid,
                                        'categoryBh': item.categoryBh,
                                        'netType': item.netType,
                                        'letter': item.letter,
                                        'idCardFace': '',
                                        'authId': item.authId,
                                        'operatorType': operatorType,
                                        'orderType': '1',
                                        'businessCode': item.netType == '8' ? 'B03' : 'P012',
                                    }
                                });
                                return;
                            }
                        },
                        function () {
                            if (type == '年费') {
                                //封装证书年费所需信息
                                $rootScope.certAnnualFeeInfo = {
                                    entName: item.entName,
                                    uniscid: item.uniscid,
                                    categoryBh: item.categoryBh,
                                    isFree: item.isFree,
                                    corpid: item.corpid,
                                    businessCode: type,
                                    operator: item.agenter,
                                    operatorid: item.cert,
                                    parentPage: "authorizationRecord"
                                }
                                nav.navigate('confirmPayInfo');
                                return;
                            }
                        },
                        btnLeft, btnRight, 'cusClass');
                }

                // 生成授权领证业务单
                var doNetOrderInfo = function (item) {
                    control.showLoading();

                    var params = [item.agenter, item.cert, $rootScope.loginInfo.mobile, $rootScope.loginInfo.accountId, item.corpid, item.categoryBh, item.netType, {
                        'letter': item.letter,
                        'idCardFace': "data:image/png;base64," + photoData
                    },
                        'EPASSAPP', item.authId, '1'];
                    var successFunc = function (result) {
                        control.hideLoading();

                        if (result == null || angular.equals({},
                            result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        }

                        if (result.success) {
                            //0：法人 1:经办人
                            $state.go('downloadCert', {
                                'downloadCertInfo': {
                                    'entName': item.unitName,
                                    'uniscid': item.uniscid,
                                    'orderNo': result.value.orderNo,
                                    'corpid': item.corpid,
                                    'orderType': '1',
                                    'businessCode': item.netType == '8' ? 'B03' : 'P012',
                                    'operatorId': item.cert,
                                }
                            });
                        }
                        if (!result.success) {
                            if (result.hasOwnProperty('value')) {
                                if (null != result.value && result.value.hasOwnProperty('busiHistoryDataJson')) {
                                    let resValueBusi = result.value.busiHistoryDataJson;
                                    if (resValueBusi) {
                                        // 判断是否为同一个人
                                        if (resValueBusi.proxIdNo == $rootScope.loginInfo.idCard) {
                                            if (false == resValueBusi.isDown) {
                                                // 未下载跳转业务管理
                                                $state.go('businessManage', {
                                                    businessManageSearchKey: item.uniscid
                                                });
                                            } else {
                                                // 已下载提示信息
                                                control.showPopup('您已下载该证书，请至【首页-我的证书】中查看', 2000);
                                            }

                                        } else {
                                            // 姓名脱敏
                                            var secName = resValueBusi.proxName;
                                            if (resValueBusi.proxName.length > 1) {
                                                secName = maskName(secName);
                                            }

                                            control.showPopup('证书已被其他用户（' + secName + '）申领下载，同一张证书同时只能一名用户使用  ', 2000);
                                        }
                                        return;
                                    }
                                }
                            }

                            control.showPopup(result.msg, 2000);
                        }
                    }
                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup(error.msg, 2000);
                    };

                    nativeHelper.doSaveAuthNetOrderInfo({
                        data: params,
                        success: successFunc,
                        fail: failFunc
                    });
                }

                // 判断是否存在重复授权
                /**
                 * @param item
                 * @param netType
                 * @param operatorType
                 */
                var checkIsRepeatAuthDelayAndUpdate = function(item,netType,operatorType){
                    operatorType = operatorType
                    var time = utility.getCurrentTime();
                    var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);

                    var temp = {
                        "idcard": $rootScope.loginInfo.idCard,
                        "uniscid": item.uniscid,
                        "netType": netType,
                        "corpid": item.corpid,
                        "categoryBh":item.categoryBh
                    }
                    console.log("checkIsRepeatAuth temp :" + JSON.stringify(temp));
                    var reqParams = DES3.encrypt(hashdata.substring(0,24), 'ZJHUIXIN', angular.toJson(temp))
                    var params = {
                        "appid": $rootScope.appid,
                        "time": time,
                        "hashdata": hashdata,
                        "keyNo": $rootScope.uuid,
                        "token": $rootScope.loginInfo.token,
                        "reqParams": reqParams
                    };
                    control.showLoading();
                    requestWrapper.checkIsRepeatAuthDelayAndUpdate({ data: params, refresh: true })
                        .then(function (result) {
                            control.hideLoading();
                            if (result == null || angular.equals({}, result)) {
                                control.showPopup('服务出错啦', 2000);
                                return;
                            };
                            if (true == result.success) {
                                //v2.9.2 新增参数belongMe："1" 业务单或授权单在自己手里  ，"0"  业务单或授权单在其他人手里
                                // type 1 有业务单  //belongMe = 0 业务单在其他人手里
                                if ("1" == result.value.type&&result.value.belongMe=='0') {
                                    //v2.9.2 新增参数payState  1 业务单存在付款记录 0或者空业务单不存在付款记录
                                    if(result.value.payState=='1'){
                                        var template = "<div><h3>"+result.value.tipMsg+"</h3></div>"
                                        control.showCustomAlert2(template,'返回', 'check-information',function() {
                                            });
                                       return;
                                    }else{
                                        var template = "<h3>"+result.value.tipMsg+"</h3>"
                                        control.showConfirm3(function() {
                                            continueOperator(item,operatorType);
                                        },function() {},'', '继续', 'check-information', template);
                                        return;
                                    }
                                } else if ("2" == result.value.type&&result.value.belongMe=='0') {//有授权
                                    var template = "<h3>"+result.value.tipMsg+"</h3>"
                                    control.showConfirm3(function() {
                                        continueOperator(item,operatorType);
                                    },function() {},'', '继续', 'check-information', template);
                                    return;
                                } else {
                                     continueOperator(item,operatorType);
                                }
                            } else {
                                control.showPopup(result.msg, 2000);
                            }
                        }).catch(function (e) {
                            control.hideLoading();
                            control.showPopup('网络请求失败：' + e.status, 2000);
                        });
                }


                /**
                 * 继续操作
                 * @param item
                 * @param operatorType 1:延期 2:变更 3:续费
                 */
                var continueOperator = function(item,operatorType){
                    if(operatorType=='1'){
                        $rootScope.curManagedCert = item;
                        nav.navigate('certDelay');
                    }else if(operatorType=='2'){
                        $rootScope.curManagedCert = item;
                        nav.navigate('certChange');
                    }else if(operatorType=='3'){
                        navCertDelay(item);
                    }
                }
                /**
                *证书延期
                **/
                var certDelay= function(item){
                    if(item.existAnnueeFee!='0'&&utility.judgeWillInvalidDate(item.yearSerEnd, 30)){
                        // 年费即将到期 延期费用
                        checkIsRepeatAuthDelayAndUpdate(item,"1","3");
                    }else{

                         // 能否延期
                        if (item.canPostpone) {
                            checkIsRepeatAuthDelayAndUpdate(item,"2","1");
                        } else {
                            control.showPopup(item.reason, 2000);
                        }
                    }
                }

               /**
                *证书变更
                **/
                var certModify=function(item){
                       if(!item.isValid){
                          return;
                      }
                      if (item.canModify) {
                           checkIsRepeatAuthDelayAndUpdate(item,"2","2");
                      } else {
                           control.showPopup(item.reason, 2000);
                      }
                }
               //续费
                var navCertDelay = function (curCert) {
                    if (2 == curCert.existAnnueeFee) {
                        control.showPopup(curCert.refuseReason, 3000);
                        return;
                    }
                    $rootScope.certAnnualFeeInfo = {
                        entName: curCert.entName,
                        uniscid: curCert.orgCode,
                        operator: '',
                        cardId: '',
                        parentPage: 'certManage',
                        corpid: curCert.corpid,
                    };
                    nav.navigate('confirmPayInfo');
                }

                // 证书操作
                var certOperateClick = function () {
                    if(clickType=='0'){ // 下载证书操作
                        downloadCert();
                    }else if(clickType=='1'){ // 证书延期操作
                        certDelay(orderNoData);
                    }else if(clickType=='2'){// 证书变更操作
                        certModify(orderNoData);
                    }else{
                        control.showPopup("证书操作类型错误,请联系管理员!"+operatorType, 2000);
                    }
                }


                // 下载证书
                var downloadCert = function () {
                    if(orderNoData.downloadType=='0'){
                        if(orderNoData.handleState == '100'){
                            paymentApply(orderNoData);
                        }else{
                            $state.go('downloadCert', {
                                'downloadCertInfo': orderNoData
                            });
                        }

                    }else if(orderNoData.downloadType=='1'){ //授权单
                        getFeeInfo();
                    }else{
                        control.showPopup("证书类型错误,请联系管理员", 2000);
                    }
                }
                return {
                    downloadCertLogic: downloadCertLogic
//                    certDelayAndModifyLogic: certDelayAndModifyLogic
                };
    }]);
})();
