/**
*授权中心需要多次调用的接口抽离实现复用
**/
(function () {
    "use strict"

    angular.module('starter')
        .factory('verifyIdentity', ['$rootScope', 'control', 'nativeHelper', '$filter',
            function ($rootScope, control, nativeHelper, $filter) {

                //检查身份类型 返回身份类型：: "0法定代表人1管理员2经办人
                var checkIdentity = function (uniscid, cert, checkIdentityType, resultFunc) {

                    control.showLoading();
                    //$rootScope.loginInfo.cert
                    var params = [uniscid, cert, checkIdentityType];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({},
                            result)) {
                            control.showPopup('服务出错啦', 3000);
                        }
                        //"identityType":"0法定代表人1管理员2经办人",
                        resultFunc(result);
                    }
                    var failFunc = function (error) {
                        control.hideLoading();
                        // control.showPopup(error.msg, 2000);
                        return '';
                    };
                    nativeHelper.checkIdentity({
                        data: params,
                        success: successFunc,
                        fail: failFunc
                    });
                };

                //三十四.查询有效授权领证信息和有效网点领证信息接口/0 未授权，1 已授权,2 记录
                var checkAuthorization = function (cert, type,keyword,pageNum,pageSize, resultFunc) {

                    control.showLoading();
                    //$rootScope.loginInfo.cert
                    var params = [cert, type, keyword,pageNum,pageSize];
                    var successFunc = function (result) {
                        control.hideLoading();
                        resultFunc(result);
                    }
                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup(error.msg, 2000);
                    };
                    nativeHelper.doGetPermitInfo({
                        data: params,
                        success: successFunc,
                        fail: failFunc
                    });
                };

                //判断人脸是否和身份信息匹配  新版人脸用不到startIdentityAuthenticationAction 作废(备留)
                //是否需要更新联连信息：updateLLInfo（String类型，0->不更新，1->更新，不传或者为空时，默认为1)
//                var startIdentityAuthenticationAction = function (userName, idCard, photoData, userId, realNameGrade, resultFunc, updateLLInfo) {
//                    control.showLoading();
//                    // var params = ['0x42', userName, idCard, photoData, userId, realNameGrade,updateLLInfo?updateLLInfo:"1"];
//                    // var params = ['0x42', userName, idCard, photoData, userId, realNameGrade,"1"];
//                    var params = ['0x42', userName, idCard, photoData, userId, '1', "1"];
//                    var successFunc = function (result) {
//                        control.hideLoading();
//                        if (result == null || angular.equals({},
//                            result)) {
//                            control.showPopup('服务出错啦', 2000);
//                        }
//
//                        if (result.rslt == 'success') {
//                            //  $rootScope.claimant.base64PhotoData = photoData;
//                            resultFunc(result.data);
//
//                        }
//                        if (result.rslt == 'fail') {
//                            var eventCounter = new Object();
//                            eventCounter.page = "活体接口认证";
//                            MobclickAgent.onEventWithParameters("authLivingInterfaceFailEvent", eventCounter);
//                            result.result = "fail"
//                            result.authResultMsg = result.errorMsg
//                            resultFunc(result);
//                        }
//                    }
//                    var failFunc = function (error) {
//                        var eventCounter = new Object();
//                        eventCounter.page = "活体接口认证";
//                        MobclickAgent.onEventWithParameters("authLivingInterfaceFailEvent", eventCounter);
//                        control.hideLoading();
//                        control.showPopup(error.msg, 2000);
//                    };
//
//                    nativeHelper.identityAuthentication({
//                        data: params,
//                        success: successFunc,
//                        fail: failFunc
//                    });
//                }


                //开启活体静默检测
                var startLiveDetection = function (userName, idCard, userId,listenerLiveDetectionRes) {
                    //监听活体次数
                    var eventCounter = new Object();
                    eventCounter.page = "活体认证";
                    MobclickAgent.onEventWithParameters("authLivingEvent", eventCounter);
                    var params = ['0x42', userName, idCard, userId, '1', "1",$rootScope.isNewLive];
                    control.showLoading();
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({},result)) {
                            control.showPopup('服务出错啦', 2000);
                        }
                        listenerLiveDetectionRes(result);
                    };
                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup(error.msg, 2000);
                    };
                    nativeHelper.liveDetection({data: params,success: successFunc,fail: failFunc});
                };

                var getDate = function (time, day) {
                    time.setDate(time.getDate() + day);
                    var y = time.getFullYear();
                    var m = time.getMonth() + 1;
                    var d = time.getDate();
                    return y + "-" + (m < 10 ? "0" + m : m) + "-" + (d < 10 ? "0" + d : d);
                }
                //申请授权
                /**
                *系统时间、经办人身份号码、经办人姓名、结果回调
                **/
                var applyAuthorize = function (systemTime, idCard, userName, applyAuthorizeRes) {
                    console.log('itemCode:' + $rootScope.curAuthCode);
                    var time = new Date(systemTime);
                    var endDate = getDate(time, 14);
                    control.showLoading();

                    var extendData = {
                        'certName': $rootScope.certUnderwayInfo.netType == "8" ? $rootScope.certUnderwayInfo.certName : $rootScope.certUnderwayInfo.entName,
                        'categoryBh': $rootScope.certUnderwayInfo.categoryBh,
                        'netType': $rootScope.certUnderwayInfo.netType,
                        'corpid': $rootScope.certUnderwayInfo.corpid,
                        'businessType': $filter('netTypeNumToText')($rootScope.certUnderwayInfo.netType),
                    };


                    var code = $rootScope.curAuthCode || '20191016172831442090';
                    // var code = '20191016172831442090';
                    var params = [
                        $rootScope.certUnderwayInfo.uniscid, idCard,
                        userName,
                        code,
                        $rootScope.loginInfo.mobile, systemTime + ' 00:00:00',
                        endDate + ' 23:59:59', 'EPASSAPP', extendData
                    ];

                    console.log('params: ' + JSON.stringify(params));
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({},
                            result)) {
                            control.showPopup('服务出错啦', 3000);
                            return;
                        }
                        if (result.rslt == 'success') {
                            applyAuthorizeRes(result);
                        }
                        if (result.rslt == 'fail') {
                            control.showPopup(result.errorMsg, 3000);
                        }
                    }

                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup(error.msg, 3000);
                    };

                    nativeHelper.applyAuthorize({
                        data: params,
                        success: successFunc,
                        fail: failFunc
                    });
                }
                /**
                *鉴权接口
                *参数一："type":"鉴权类型：1：根据事项编码身份信息鉴权；2：根据事项编码授权码鉴权；3：根据
                *        事项编码，身份信息，授权码鉴权；4：根据单位信息鉴权"。
                *参数二："itemCode":"事项编码"。
                *参数三："certKey":"身份证件号码的SM3hash值",js端将身份证信息传给native进行摘要。
                **/
                var getAuthorizationComfirmInfo = function (cardId, entName, uniscid, checkRsFunc) {
                    control.showLoading();
                    var authCode = $rootScope.curAuthCode || '20191016172831442090';
                    var params = ["1", authCode, cardId, $rootScope.searchResult.entName, $rootScope.searchResult.uniscid];
                    //             var params = ["1","20190325092052817016",cardId,"玉环金源进出口有限公司","913310217719107159" ];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result.rslt == 'success') {
                            checkRsFunc(result);
                        } else {
                            control.showPopup(result.errorMsg, 2000);
                        }
                    }
                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                    };
                    nativeHelper.getAuthorizationComfirmInfo({
                        data: params,
                        success: successFunc,
                        fail: failFunc
                    });
                }
                var doIdentityVerify = function (corpid, idNum,userId,mobilePhone,doIdentityVerifyRes) {
                    control.showLoading();
                    var params = [corpid, idNum,userId,mobilePhone];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({},
                            result)) {
                            control.showPopup('服务出错啦', 3000);
                        }
                        doIdentityVerifyRes(result);
                    }
                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup("身份校验异常", 3000);
                    };
                    nativeHelper.doIdentityVerify({
                        data: params,
                        success: successFunc,
                        fail: failFunc
                    });
                };

                var mobileCheck = function (corpid, name, idNum, mobilePhone,userId,mobileCheck) {
                    control.showLoading();
                    var params = [corpid, name, idNum, mobilePhone,userId];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({},
                            result)) {
                            control.showPopup('服务出错啦', 3000);
                        }
                        mobileCheck(result);
                    }
                    var failFunc = function (error) {
                        control.hideLoading();
                        control.showPopup("身份校验异常", 3000);
                    };
                    nativeHelper.mobileCheck({
                        data: params,
                        success: successFunc,
                        fail: failFunc
                    });
                };

                return {
                    checkIdentity: checkIdentity,
                    checkAuthorization: checkAuthorization,
                    // startIdentityAuthenticationAction: startIdentityAuthenticationAction,
                    startLiveDetection: startLiveDetection,
                    applyAuthorize: applyAuthorize,
                    getAuthorizationComfirmInfo: getAuthorizationComfirmInfo,
                    doIdentityVerify:doIdentityVerify,
                    mobileCheck:mobileCheck
                };
            }]);
})();
